/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== bonus.c: niveaux bonus de FlashTris
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#include <stdlib.h>
#include <stdio.h>

#include "ftris.h"
#include "key.h"
#include "video.h"
#include "bonus.h"
#include "menu.h"
#include "game.h"
#include "./module/mod.h"


/* ===== GENERAL ===== */

int             bonus_timer_ready[NBJ_MAX];
int             bonus_demarre[NBJ_MAX];         /* = 1 si bonus demarre           */
int             bonus_temps_limite[NBJ_MAX];    /* = 1 si bonus avec temps limite */
int             bonus_nb_appels[NBJ_MAX];
int             bonus_sec_reste[NBJ_MAX];
int             bonus_sec_change[NBJ_MAX];
int             bonus_voix_son[NBJ_MAX];

unsigned char   *nom_bonus[NB_BONUS] =
                { "Brix", "Nibble", "Tron" };

/* ===== BONUS NIBBLE ===== */

int             nib_x[100], nib_y[100];
int             nib_dir;

/* ==== BONUS_TRON ==== */

int             tron_x, tron_y, tron_dir, tron_coul;
int             tron_x_inc[4] = {  0, 1, 0, -1 };
int             tron_y_inc[4] = { -1, 0, 1,  0 };

/* ==== BONUS BRIX ==== */

int             brix_niveau[NBJ_MAX];               /* niveau pour chaque joueur             */
signed char     brix_etat[ETAT_Y_MAX][ETAT_X_MAX];  /* etat des cases pour le casse-briques  */
t_sprite        brix_balle[5];                      /* dessin de la balle                    */
t_sprite        brix_raquette[5];                   /* dessin de la raquette                 */
t_sprite        brix_missile[5];                    /* dessin du missile                     */
int             brix_taille_balle;                  /* taille de la balle (depend de la      */
                                                    /* taille de l'aire de jeu du joueur)    */
int             brix_largeur_raq;                   /* largeur de la raquette                */
int             brix_nb_brix[NBJ_MAX];              /* nombre de briques restantes           */
int             brix_nb_brix_ini[NBJ_MAX];          /* nombre de briques initial             */
int             brix_x[NBJ_MAX], brix_y[NBJ_MAX];   /* position de la balle                  */
int             brix_x_raq[NBJ_MAX];                /* position de la raquette               */
int             brix_dir_x[NBJ_MAX];                /* direction de la balle en X            */
int             brix_dir_y[NBJ_MAX];                /* direction de la balle en Y            */
int             brix_speed_x[NBJ_MAX];              /* vitesse de la balle en X              */
int             brix_speed_y[NBJ_MAX];              /* vitesse de la balle en Y              */
int             brix_missile_x[NBJ_MAX];            /* coordonnee en X du missile            */
                                                    /* (-1 = pas de missile tire)            */
int             brix_missile_y[NBJ_MAX];            /* coordonnee en Y du missile            */

unsigned char   brix_figure1[4][4] =
                { { 0, 1, 1, 0 },
                  { 1, 1, 1, 1 },
                  { 1, 1, 1, 1 },
                  { 0, 1, 1, 0 } };

unsigned char   brix_figure2[6][6] =
                { { 0, 0, 1, 1, 0, 0 },
                  { 0, 1, 1, 1, 1, 0 },
                  { 1, 1, 1, 1, 1, 1 },
                  { 1, 1, 1, 1, 1, 1 },
                  { 0, 1, 1, 1, 1, 0 },
                  { 0, 0, 1, 1, 0, 0 } };

/* ========================================================================== */

/*
 * affiche_nombre_pour_bonus: affiche un nombre dans la case "nombre de lignes"
 */

void affiche_nombre_pour_bonus(int joueur, int nombre)
{
    game_write_xy_s_c_o(ECRAN_REEL, x_fin[team[joueur]]+4,
        y_carres_lignes[team[joueur]][0]+9, 17, 56, 1, 28,
        "%d", nombre);
}

/*
 * brix_pose: pose une brique a un endroit donne
 */

void brix_pose(int joueur, int x, int y)
{
    brix_etat[y_min[joueur]+y][x_min[joueur]+x] = rand()%7+1;
    affiche_brique(VSCR_AUTRES+3,
        x_deb[joueur]+x*tc,
        y_deb[joueur]+y*tc,
        tc, brix_etat[y_min[joueur]+y][x_min[joueur]+x]-1);
    brix_nb_brix[joueur]++;
}

/*
 * init_brix: initialise les briques a detruire en fonction du niveau
 */

void init_brix(int joueur, int level)
{
    int     i, j, x, x2, y;

    for (i = x_min[joueur]; i <= x_max[joueur]; i++)
        for (j = y_min[joueur]; j <= y_max[joueur]; j++)
            brix_etat[j][i] = 0;
    brix_nb_brix[joueur] = 0;
    /*level = 3;*/
    switch (level)
    {
        case 0:     /* un petit rond */
            x = (x_max[joueur]-x_min[joueur]+1-4)/2;
            y = (y_max[joueur]-y_min[joueur])/6;
            for (i = 0; i < 4; i++)
                for (j = 0; j < 4; j++)
                    if (brix_figure1[j][i] != 0)
                        brix_pose(joueur, x+i, y+j);
            break;
        case 1:     /* un rond */
            x = (x_max[joueur]-x_min[joueur]+1-6)/2;
            y = (y_max[joueur]-y_min[joueur])/8;
            for (i = 0; i < 6; i++)
                for (j = 0; j < 6; j++)
                    if (brix_figure2[j][i] != 0)
                        brix_pose(joueur, x+i, y+j);
            break;
        case 2:     /* un carre en haut */
            for (i = 2; i <= x_max[joueur]-x_min[joueur]-2; i++)
                for (j = 2; j < 6; j++)
                    brix_pose(joueur, i, j);
            break;
        case 3:     /* une pyramide pointe en bas */
            x = 0;
            x2 = x_max[joueur]-x_min[joueur];
            y = 0;
            while (x <= x2)
            {
                for (i = x; i <= x2; i++)
                    brix_pose(joueur, i, y);
                y++;
                x++;
                x2--;
            }
            break;
        case 4:     /* tour en briques */
            for (i = 0; i < x_max[joueur]-x_min[joueur]+1; i++)
                for (j = 0; j < 2; j++)
                    brix_pose(joueur, i, j);
            x = x_max[joueur]-x_min[joueur];
            y = (y_max[joueur]-y_min[joueur])/2;
            for (j = 2; j <= y; j++)
            {
                brix_pose(joueur, 0, j);
                brix_pose(joueur, 1, j);
                brix_pose(joueur, x-1, j);
                brix_pose(joueur, x, j);
            }
            break;
        case 5:     /* 1/4 rempli avec une briques sur 2 */
            y = (y_max[joueur]-y_min[joueur])/4;
            for (i = 0; i < x_max[joueur]-x_min[joueur]+1; i++)
                for (j = 0; j <= y; j++)
                    if ( ( (j%2 == 0) && (i%2 == 0) )
                        || ( (j%2 != 0) && (i%2 != 0) ) )
                        brix_pose(joueur, i, j);
            break;
        case 6:     /* 1/4 de briques */
            y = (y_max[joueur]-y_min[joueur])/4;
            for (i = 0; i < x_max[joueur]-x_min[joueur]+1; i++)
                for (j = 0; j <= y; j++)
                    brix_pose(joueur, i, j);
            break;
        case 7:     /* double pyramide */
            x = 0;
            x2 = x_max[joueur]-x_min[joueur];
            y = 0;
            while (x <= x2)
            {
                for (i = x; i <= x2; i++)
                    brix_pose(joueur, i, y);
                y++;
                x++;
                x2--;
            }
            x--;
            x2++;
            while (x >= x_min[joueur])
            {
                for (i = x; i <= x2; i++)
                    brix_pose(joueur, i, y);
                y++;
                x--;
                x2++;
            }
            break;
        case 8:     /* la moitie avec 1 brique sur 2 */
            y = (y_max[joueur]-y_min[joueur])/2;
            for (i = 0; i < x_max[joueur]-x_min[joueur]+1; i++)
                for (j = 0; j <= y; j++)
                    if ( ( (j%2 == 0) && (i%2 == 0) )
                        || ( (j%2 != 0) && (i%2 != 0) ) )
                    brix_pose(joueur, i, j);
            break;
        case 9:     /* la moitie en briques */
            y = (y_max[joueur]-y_min[joueur])/2;
            for (i = 0; i < x_max[joueur]-x_min[joueur]+1; i++)
                for (j = 0; j <= y; j++)
                    brix_pose(joueur, i, j);
            break;
        case 10:     /* les 3/4 en briques ! */
            y = ((y_max[joueur]-y_min[joueur])*3)/4;
            for (i = 0; i < x_max[joueur]-x_min[joueur]+1; i++)
                for (j = 0; j <= y; j++)
                    brix_pose(joueur, i, j);
            break;
        default:
            ftris_error(MSG_ERROR, BUG, CLOSE_SB16, STOP_PROG,
                "brix level > 10");
            break;
    }
    brix_nb_brix_ini[joueur] = brix_nb_brix[joueur];
}

/*
 * init_bonus: initialise un niveau bonus pour un joueur
 */

void init_bonus(int joueur)
{
    unsigned char   chaine[4][50];
    int             i, largeur;

    fill_rectangle(ECRAN_REEL, x_deb[joueur], y_deb[joueur],
        x_fin[joueur]-1, y_fin[joueur]-1, 15);
    if ( (sb16) && (sons == SOUND_SB16) )
        SON_DEBUT_BONUS;
    copy_v2v_xy(VSCR_AUTRES+2, VSCR_AUTRES+3, x_deb[joueur], y_deb[joueur],
        x_fin[joueur]-x_deb[joueur], y_fin[joueur]-y_deb[joueur]);
    /*  */
    if (bonus[joueur] == BONUS_RANDOM)
        bonus[joueur] = BONUS_BRIX;
    switch (bonus[joueur])
    {
        case BONUS_BRIX:
            init_brix(joueur, brix_niveau[joueur]);
            /*  */
            brix_taille_balle = 5;
            brix_largeur_raq = 16;
            while ( (brix_taille_balle >= tc) && (brix_taille_balle > 1) )
            {
                brix_taille_balle--;
                brix_largeur_raq -= 2;
            }
            brix_x[joueur] = x_deb[joueur]+1+rand()%(x_fin[joueur]-x_deb[joueur]-brix_taille_balle-2);
            brix_y[joueur] = y_fin[joueur]-5-brix_taille_balle;
            if (rand()%2 == 0)
                brix_dir_x[joueur] = 1;
            else
                brix_dir_x[joueur] = -1;
            brix_dir_y[joueur] = -1;
            brix_speed_x[joueur] = 1;
            brix_speed_y[joueur] = 1;
            brix_x_raq[joueur] = x_deb[joueur]+((x_fin[joueur]-x_deb[joueur]-brix_largeur_raq)/2);
            brix_missile_x[joueur] = -1;
            brix_missile_y[joueur] = -1;
            bonus_sec_reste[joueur] = 0;
            affiche_nombre_pour_bonus(joueur, brix_nb_brix[joueur]);
            bonus_temps_limite[joueur] = 0;
            if (langue == ANGLAIS)
                sprintf(chaine[2], "Level %d/10", brix_niveau[joueur]+1);
            else
                sprintf(chaine[2], "Niveau %d/10", brix_niveau[joueur]+1);
            break;
        case BONUS_NIBBLE:
            nib_dir = 0;
            bonus_temps_limite[joueur] = 0;
            chaine[2][0] = '\0';
            break;
        case BONUS_TRON:
            tron_x = x_deb[joueur]+(rand()%(x_fin[joueur]-x_deb[joueur]));
            if (rand()%2 == 0)
            {
                tron_y = y_deb[joueur]+(rand()%((y_fin[joueur]-y_deb[joueur])/3));
                tron_dir = 2;
            }
            else
            {
                tron_y = y_fin[joueur]-(rand()%((y_fin[joueur]-y_deb[joueur])/3));
                tron_dir = 0;
            }
            tron_coul = 1;
            putpixel_ofs(ECRAN_REEL, tron_x+(tron_y*scr_nbx), tron_coul);
            bonus_temps_limite[joueur] = 1;
            bonus_sec_reste[joueur] = 10;
            chaine[2][0] = '\0';
            break;
    }

    copy_v2s_xy(VSCR_AUTRES+3, x_deb[joueur], y_deb[joueur],
        x_fin[joueur]-x_deb[joueur], y_fin[joueur]-y_deb[joueur]);

    if (langue == ANGLAIS)
    {
        strcpy(chaine[0], "Bonus level:");
        strcpy(chaine[3], "Ready ?");
    }
    else
    {
        strcpy(chaine[0], "Niveau bonus:");
        strcpy(chaine[3], "Pret ?");
    }
    strcpy(chaine[1], nom_bonus[bonus[joueur]-2]);


    for (i = 0; i < 4; i++)
    {
        largeur = text_length(chaine[i]);
        write_xy_s_c_o(ECRAN_REEL,
            x_deb[joueur]+((x_fin[joueur]-x_deb[joueur]-largeur)/2),
            y_deb[joueur]+((y_fin[joueur]-y_deb[joueur])/2)+y_texte_ready[i],
            coul_texte_ready[i][0], coul_texte_ready[i][1],
            coul_texte_ready[i][2], chaine[i]);
    }

    bonus_nb_appels[joueur] = 0;
    bonus_sec_change[joueur] = 1;           /* force l'affichage du temps des le premier passage dans traite_bonus() */
    bonus_timer_ready[joueur] = 91+(91/2);  /* 1,5 secondes de "Ready ?"                                             */
    bonus_demarre[joueur] = 0;
}

/*
 * bonus_explose_lignes: fait exploser des lignes suite a un bonus
 *                       renvoie le nombre de lignes non vides explosees
 */

int bonus_explose_lignes(int joueur, int nb_lignes)
{
    int     i, j, ligne_vide, nb_explosees;

    nb_explosees = 0;
    annule_etats_team(joueur);
    for (i = 0; i < nb_lignes; i++)
    {
        ligne_vide = 1;
        for (j = x_min[joueur]; j <= x_max[joueur]; j++)
            ligne_vide &= (etat[y_max[joueur]-i][j] == 0);
        if (ligne_vide)
            break;
        explosion_ligne(joueur, y_max[joueur]-i);
        nb_explosees++;
    }
    return nb_explosees;
}

/*
 * fin_bonus: fin d'un niveau bonus (perdu ou gagne)
 */

void fin_bonus(int joueur, int gagne)
{
    int     i, nb_explose;

    redessine_aire_jeu(joueur);
    affiche_piece(ECRAN_REEL, joueur, &piece[joueur]);
    affiche_nombre_lignes(joueur);
    efface_msgs(joueur);
    if (gagne)  /* bonus gagne ! */
    {
        /*if ( (sb16) && (sons == SOUND_SB16) )
            SON_BONUS_GAGNE;*/
        switch (bonus[joueur])
        {
            case BONUS_BRIX:
                if (brix_niveau[joueur] < 10)
                    brix_niveau[joueur]++;
                nb_explose = bonus_explose_lignes(joueur,
                    ((y_max[joueur]-y_min[joueur]+1)*2)/5);
                if (nb_explose > 0)
                {
                    if (nb_explose > 1)
                        ajoute_msg(joueur, 1, "%d explosions", nb_explose);
                    else
                        ajoute_msg(joueur, 1, "%d explosion", nb_explose);
                }
                if ( (nb_explose > 0) && (sb16) && (sons == SOUND_SB16) )
                    SON_EXPLOSION;
                break;
        }
        if (langue == ANGLAIS)
            ajoute_msg(joueur, 1, "You win !");
        else
            ajoute_msg(joueur, 1, "Vous gagnez !");
    }
    else
    {
        switch(bonus[joueur])
        {
            case BONUS_BRIX:
                /* calcul du pourcentage de briques detruites */
                i = ((brix_nb_brix_ini[joueur]-brix_nb_brix[joueur])*100)/brix_nb_brix_ini[joueur];
                i = (i/10)*10;
                if (i < 30)
                    i = 0;
                nb_explose = bonus_explose_lignes(joueur,
                    ((y_max[joueur]-y_min[joueur]+1)*i)/400);
                if (nb_explose > 0)
                {
                    if (nb_explose > 1)
                        ajoute_msg(joueur, 1, "%d explosions", nb_explose);
                    else
                        ajoute_msg(joueur, 1, "%d explosion", nb_explose);
                }
                if ( (nb_explose > 0) && (sb16) && (sons == SOUND_SB16) )
                    SON_EXPLOSION;
                break;
        }
    }
    bonus[joueur] = NO_BONUS;
}

/*
 * traite_bonus: traitement d'un niveau bonus pour un joueur
 *               (affichage, traitement des touches, ...)
 */

void traite_bonus(int joueur)
{
    int     i, x, x2, y, y2, brix_degomme;

    switch (bonus[joueur])
    {
        case BONUS_BRIX:
            brix_degomme = 0;
            copy_v2s_xy(VSCR_AUTRES+2, brix_x[joueur],
                brix_y[joueur], brix_taille_balle, brix_taille_balle);
            brix_x[joueur] += brix_dir_x[joueur]*brix_speed_x[joueur];
            brix_y[joueur] += brix_dir_y[joueur]*brix_speed_y[joueur];

            /* perdu ? */
            if ( (brix_dir_y[joueur] == 1)
                && (brix_y[joueur] == y_fin[joueur]-5-brix_taille_balle)
                && ( (brix_x[joueur] < brix_x_raq[joueur]-brix_taille_balle+1)
                    || (brix_x[joueur] >= brix_x_raq[joueur]+brix_largeur_raq) ) )
                fin_bonus(joueur, 0);
            else
            {
                x = x_min[joueur]+(brix_x[joueur]-x_deb[joueur])/tc;
                x2 = x_min[joueur]+(brix_x[joueur]+brix_taille_balle-x_deb[joueur])/tc;

                y = y_min[joueur]+(brix_y[joueur]-y_deb[joueur])/tc;
                y2 = y_min[joueur]+(brix_y[joueur]+brix_taille_balle-y_deb[joueur])/tc;

                if (brix_etat[y][x] != 0)
                {
                    brix_etat[y][x] = 0;
                    efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                        x_deb[joueur]+((x-x_min[joueur])*tc),
                        y_deb[joueur]+((y-y_min[joueur])*tc), tc);
                    brix_nb_brix[joueur]--;
                    brix_dir_x[joueur] = -brix_dir_x[joueur];
                    brix_dir_y[joueur] = -brix_dir_y[joueur];
                    brix_degomme = 1;
                    if ( (sb16) && (sons == SOUND_SB16) )
                        SON_BRIX_DEGOMME;
                }
                else
                {
                    if (brix_x[joueur]+(brix_dir_x[joueur]*brix_speed_x[joueur]) < x_deb[joueur])
                        brix_dir_x[joueur] = -brix_dir_x[joueur];
                    else
                        if (brix_x[joueur]+(brix_dir_x[joueur]*brix_speed_x[joueur])+brix_taille_balle-1 >= x_fin[joueur])
                            brix_dir_x[joueur] = -brix_dir_x[joueur];
                        else
                            if ( (brix_dir_x[joueur] == -1)
                                && ((brix_x[joueur]-x_deb[joueur])%tc == 0)
                                && ( (brix_etat[y][x-1] != 0)
                                    || (brix_etat[y2][x-1] != 0) ) )
                            {
                                if (brix_etat[y][x-1] != 0)
                                {
                                    brix_etat[y][x-1] = 0;
                                    efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                        x_deb[joueur]+((x-1-x_min[joueur])*tc),
                                        y_deb[joueur]+((y-y_min[joueur])*tc), tc);
                                    brix_nb_brix[joueur]--;
                                }
                                if (brix_etat[y2][x-1] != 0)
                                {
                                    brix_etat[y2][x-1] = 0;
                                    efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                        x_deb[joueur]+((x-1-x_min[joueur])*tc),
                                        y_deb[joueur]+((y2-y_min[joueur])*tc), tc);
                                    brix_nb_brix[joueur]--;
                                }
                                brix_dir_x[joueur] = -brix_dir_x[joueur];
                                brix_degomme = 1;
                                if ( (sb16) && (sons == SOUND_SB16) )
                                    SON_BRIX_DEGOMME;
                            }
                            else
                                if ( (brix_dir_x[joueur] == 1)
                                    && ((brix_x[joueur]+brix_taille_balle-x_deb[joueur])%tc == 0)
                                    && ( (brix_etat[y][x+1] != 0)
                                        || (brix_etat[y2][x+1] != 0) ) )
                                {
                                    if (brix_etat[y][x+1] != 0)
                                    {
                                        brix_etat[y][x+1] = 0;
                                        efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                            x_deb[joueur]+((x+1-x_min[joueur])*tc),
                                            y_deb[joueur]+((y-y_min[joueur])*tc), tc);
                                        brix_nb_brix[joueur]--;
                                    }
                                    if (brix_etat[y2][x+1] != 0)
                                    {
                                        brix_etat[y2][x+1] = 0;
                                        efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                            x_deb[joueur]+((x+1-x_min[joueur])*tc),
                                            y_deb[joueur]+((y2-y_min[joueur])*tc), tc);
                                        brix_nb_brix[joueur]--;
                                    }
                                    brix_dir_x[joueur] = -brix_dir_x[joueur];
                                    brix_degomme = 1;
                                    if ( (sb16) && (sons == SOUND_SB16) )
                                        SON_BRIX_DEGOMME;
                                }

                    if ( (brix_dir_y[joueur] == 1)
                        && (brix_y[joueur] == y_fin[joueur]-5-brix_taille_balle) )
                        brix_dir_y[joueur] = -brix_dir_y[joueur];
                    else
                    {
                        if (brix_y[joueur]+(brix_dir_y[joueur]*brix_speed_y[joueur]) < y_deb[joueur])
                            brix_dir_y[joueur] = -brix_dir_y[joueur];
                        else
                        {
                            if (brix_y[joueur]+(brix_dir_y[joueur]*brix_speed_y[joueur])+brix_taille_balle-1 >= y_fin[joueur])
                                brix_dir_y[joueur] = -brix_dir_y[joueur];
                            else
                            {
                                if ( (brix_dir_y[joueur] == -1)
                                    && ((brix_y[joueur]-y_deb[joueur])%tc == 0)
                                    && ( (brix_etat[y-1][x] != 0)
                                        || (brix_etat[y-1][x2] != 0) ) )
                                {
                                    if (brix_etat[y-1][x] != 0)
                                    {
                                        brix_etat[y-1][x] = 0;
                                        efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                            x_deb[joueur]+((x-x_min[joueur])*tc),
                                            y_deb[joueur]+((y-1-y_min[joueur])*tc), tc);
                                        brix_nb_brix[joueur]--;
                                    }
                                    if (brix_etat[y-1][x2] != 0)
                                    {
                                        brix_etat[y-1][x2] = 0;
                                        efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                            x_deb[joueur]+((x2-x_min[joueur])*tc),
                                            y_deb[joueur]+((y-1-y_min[joueur])*tc), tc);
                                        brix_nb_brix[joueur]--;
                                    }
                                    brix_dir_y[joueur] = -brix_dir_y[joueur];
                                    if ( (!brix_degomme) && (sb16) && (sons == SOUND_SB16) )
                                        SON_BRIX_DEGOMME;
                                    brix_degomme = 1;
                                }
                                else
                                {
                                    if ( (brix_dir_y[joueur] == 1)
                                        && ((brix_y[joueur]+brix_taille_balle-y_deb[joueur])%tc == 0)
                                        && ( (brix_etat[y+1][x] != 0)
                                            || (brix_etat[y+1][x2] != 0) ) )
                                    {
                                        if (brix_etat[y+1][x] != 0)
                                        {
                                            brix_etat[y+1][x] = 0;
                                            efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                                x_deb[joueur]+((x-x_min[joueur])*tc),
                                                y_deb[joueur]+((y+1-y_min[joueur])*tc), tc);
                                            brix_nb_brix[joueur]--;
                                        }
                                        if (brix_etat[y+1][x2] != 0)
                                        {
                                            brix_etat[y+1][x2] = 0;
                                            efface_brique(ECRAN_REEL, VSCR_AUTRES+2,
                                                x_deb[joueur]+((x2-x_min[joueur])*tc),
                                                y_deb[joueur]+((y+1-y_min[joueur])*tc), tc);
                                            brix_nb_brix[joueur]--;
                                        }
                                        brix_dir_y[joueur] = -brix_dir_y[joueur];
                                        if ( (!brix_degomme) && (sb16) && (sons == SOUND_SB16) )
                                            SON_BRIX_DEGOMME;
                                        brix_degomme = 1;
                                    }
                                }
                            }
                        }
                    }
                }

                /* gestion missile */
                for (i = 0; i < 2; i++)
                {
                    if (brix_missile_x[joueur] != -1)
                    {
                        copy_v2s_xy(VSCR_AUTRES+2, brix_missile_x[joueur],
                            brix_missile_y[joueur], brix_taille_balle, brix_taille_balle);
                        brix_missile_y[joueur]--;
                        /* collision avec la balle ? */
                        if ( (brix_dir_y[joueur] == 1)
                            && (brix_missile_x[joueur] >= brix_x[joueur]-brix_taille_balle+1)
                            && (brix_missile_x[joueur] <= brix_x[joueur]+brix_taille_balle-1)
                            && (brix_missile_y[joueur] >= brix_y[joueur]-brix_taille_balle+1)
                            && (brix_missile_y[joueur] <= brix_y[joueur]+brix_taille_balle-1) )
                        {
                            brix_dir_y[joueur] = -brix_dir_y[joueur];
                            brix_missile_x[joueur] = -1;
                            brix_missile_y[joueur] = -1;
                        }
                        else
                        {
                            x = x_min[joueur]+(brix_missile_x[joueur]-x_deb[joueur])/tc;
                            x2 = x_min[joueur]+(brix_missile_x[joueur]+brix_taille_balle-x_deb[joueur])/tc;
                            y = y_min[joueur]+(brix_missile_y[joueur]-y_deb[joueur])/tc;
                            if ( (brix_missile_y[joueur] < y_deb[joueur])
                                || (brix_etat[y][x] != 0)
                                || (brix_etat[y][x2] != 0) )
                            {
                                brix_missile_x[joueur] = -1;
                                brix_missile_y[joueur] = -1;
                            }
                            else
                                putsprite_tr(&brix_missile[brix_taille_balle-1],
                                    brix_missile_x[joueur], brix_missile_y[joueur]);
                        }
                    }
                }

                putsprite_tr(&brix_balle[brix_taille_balle-1],
                    brix_x[joueur], brix_y[joueur]);

                if ( (key_tab[touche[nbp-1][joueur][0]])    /* gauche */
                    && (brix_x_raq[joueur] > x_deb[joueur]) )
                {
                    copy_v2s_xy(VSCR_AUTRES+2, brix_x_raq[joueur],
                        y_fin[joueur]-5, brix_largeur_raq, 5);
                    brix_x_raq[joueur]--;
                }
                else
                    if ( (key_tab[touche[nbp-1][joueur][1]])    /* droite */
                        && (brix_x_raq[joueur] < x_fin[joueur]-brix_largeur_raq) )
                    {
                        copy_v2s_xy(VSCR_AUTRES+2, brix_x_raq[joueur],
                            y_fin[joueur]-5, brix_largeur_raq, 5);
                        brix_x_raq[joueur]++;
                    }
                if ( (key_tab[touche[nbp-1][joueur][3]])        /* retourner = tirer */
                    && (brix_missile_x[joueur] == -1) )
                {
                    brix_missile_x[joueur] =
                        brix_x_raq[joueur]+(brix_largeur_raq-brix_taille_balle)/2;
                    brix_missile_y[joueur] = y_fin[joueur]-5-brix_taille_balle;
                    key_tab[touche[nbp-1][joueur][3]] = 0;
                }

                putsprite_tr(&brix_raquette[brix_taille_balle-1],
                    brix_x_raq[joueur], y_fin[joueur]-5);

                if (brix_nb_brix[joueur] < 0)
                    ftris_error(MSG_ERROR, BUG, CLOSE_SB16, STOP_PROG,
                        "number of brix < 0");
                if (brix_nb_brix[joueur] == 0)
                    fin_bonus(joueur, 1);
                else
                    if (brix_degomme)
                        affiche_nombre_pour_bonus(joueur, brix_nb_brix[joueur]);
            }
            break;
        case BONUS_NIBBLE:
            if (key_tab[touche[nbp-1][joueur][2]])  /* bas */
                fin_bonus(joueur, 0);
            break;
        case BONUS_TRON:
            if (bonus_sec_reste[joueur] == 0)
                fin_bonus(joueur, 1);
            else
            {
                tron_x += tron_x_inc[tron_dir];
                tron_y += tron_y_inc[tron_dir];
                if ( (tron_x <= x_deb[joueur]) || (tron_x >= x_fin[joueur])
                    || (tron_y <= y_deb[joueur]) || (tron_y >= y_fin[joueur])
                    || (getpixel_ofs(ECRAN_REEL, tron_x+(tron_y*scr_nbx)) == tron_coul) )
                    fin_bonus(joueur, 0);
                else
                {
                    putpixel_ofs(ECRAN_REEL, tron_x+(tron_y*scr_nbx), tron_coul);
                    if (key_tab[touche[nbp-1][joueur][0]])  /* gauche */
                    {
                        tron_dir = (tron_dir == 0)?3:tron_dir-1;
                        key_tab[touche[nbp-1][joueur][0]] = 0;
                    }
                    if (key_tab[touche[nbp-1][joueur][1]])  /* droite */
                    {
                        tron_dir = (tron_dir+1)%4;
                        key_tab[touche[nbp-1][joueur][1]] = 0;
                    }
                }
            }
            break;
    }
    if ( (bonus[joueur] != NO_BONUS) && (bonus_temps_limite[joueur])
        && (bonus_sec_change[joueur]) )
    {
        bonus_sec_change[joueur] = 0;
        if (bonus_sec_reste[joueur] == 0)
            game_write_xy_s_c_o(ECRAN_REEL, x_fin[joueur]+4,
                y_carres_lignes[joueur][0]+9, 17, 49, 1, 41, "-");
        else
            game_write_xy_s_c_o(ECRAN_REEL, x_fin[joueur]+4,
                y_carres_lignes[joueur][0]+9, 17, 49, 1, 41,
                "%d", bonus_sec_reste[joueur]);
    }
}
