/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== menu.c: chargement/sauvegarde de la config de FlashTris
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#include "ftris.h"
#include "config.h"
#include "game.h"
#include "netftris.h"
#include "menu.h"
#include "./module/mod.h"


t_config    ftris_cfg[] =
            /*------ENTIER------CHAINE---VALEUR PAR DEFAUT--------VALEUR LUE--*/
            { { &langue,         NULL,    ANGLAIS,           NULL,   0, NULL },
              { &clavier,        NULL,    AZERTY,            NULL,   0, NULL },
              { &couleur_tubes,  NULL,    3,                 NULL,   0, NULL },
              { &game_mode,      NULL,    GAME_CLASSIC,      NULL,   0, NULL },
              { &game_team,      NULL,    0,                 NULL,   0, NULL },
              { &nbp,            NULL,    1,                 NULL,   0, NULL },
              { &nbc,            NULL,    0,                 NULL,   0, NULL },
            /*{ &nbx,            NULL,    10,                NULL,   0, NULL },
              { &nby,            NULL,    20,                NULL,   0, NULL },*/
              { &difficulte,     NULL,    3,                 NULL,   0, NULL },
              { &same_pieces,    NULL,    YES,               NULL,   0, NULL },
              { &eccentric,      NULL,    NO,                NULL,   0, NULL },
              { &hauteur_ini,    NULL,    0,                 NULL,   0, NULL },
              { &time_limite,    NULL,    0,                 NULL,   0, NULL },
              { &view_next,      NULL,    2,                 NULL,   0, NULL },
              { &stats,          NULL,    YES,               NULL,   0, NULL },
              { &acceler,        NULL,    ACCELER_FAST,      NULL,   0, NULL },
              { &aire_de_jeu,    NULL,    0,                 NULL,   0, NULL },
              { &fond_jeu,       NULL,    1,                 NULL,   0, NULL },
              { &bonus_level,    NULL,    YES,               NULL,   0, NULL },
              { &status_jeu,     NULL,    1,                 NULL,   0, NULL },
              { &window_msg,     NULL,    1,                 NULL,   0, NULL },
              { &cheat,          NULL,    NO,                NULL,   0, NULL },
              { &volume,         NULL,    (VOLUME_MAX*9)/10, NULL,   0, NULL },
              { &force_port,     NULL,    NO,                NULL,   0, NULL },
              { &force_irq,      NULL,    NO,                NULL,   0, NULL },
              { &music_menu,     NULL,    1,                 NULL,   0, NULL },
              { &music_jeu,      NULL,    2,                 NULL,   0, NULL },
              { &sons,           NULL,    SOUND_SB16,        NULL,   0, NULL },
              { &sons_menu,      NULL,    YES,               NULL,   0, NULL },
              #ifdef MSDOS
              { &net_type,       NULL,    NET_IPX,           NULL,   0, NULL },
              #else
              { &net_type,       NULL,    NET_TCPIP,         NULL,   0, NULL },
              #endif
              { &net_nbj_max,    NULL,    100,               NULL,   0, NULL },
              { &net_allow_bots, NULL,    YES,               NULL,   0, NULL },
              { &net_death,      NULL,    NO,                NULL,   0, NULL },
              { &net_chat,       NULL,    1,                 NULL,   0, NULL },
              { NULL,            net_nom, 0,                 "PLAYER", 0, NULL },
              { NULL,            net_server,0,               "127.0.0.1", 0, NULL },
              { &net_view_other, NULL,    YES,               NULL,   0, NULL },
              { &net_bonus_level,NULL,    YES,               NULL,   0, NULL },
              { &net_same_pieces,NULL,    YES,               NULL,   0, NULL },
              { &net_port_serveur,NULL,   1234,              NULL,   0, NULL },
              { &fond_menu,      NULL,    0,                 NULL,   0, NULL },
              { &titre_en_flames,NULL,    YES,               NULL,   0, NULL },
              { &about_scrolling,NULL,    YES,               NULL,   0, NULL },
              { &brik_copyright, NULL,    YES,               NULL,   0, NULL },
              { &pixel_nb,       NULL,    4,                 NULL,   0, NULL },
              { &barres_samples, NULL,    2,                 NULL,   0, NULL },
              { &bulles,         NULL,    YES,               NULL,   0, NULL },
              /*{ &fast_preview,   NULL,    NO,                NULL,   0, NULL },*/
              { NULL,            NULL,    0,                 NULL,   0, NULL } };

int     volume_config;


/*
 * config_par_defaut: installe la config par defaut
 */

void config_par_defaut()
{
    int     i;
    #ifndef MSDOS
    unsigned char   user[100];
    #endif

    i = 0;
    while ( (ftris_cfg[i].cfg_valeur_int != NULL)
        || (ftris_cfg[i].cfg_valeur_chaine != NULL) )
    {
        if (ftris_cfg[i].cfg_valeur_int != NULL)
        {
            /* entier */
            *(ftris_cfg[i].cfg_valeur_int) = ftris_cfg[i].cfg_valeur_int_par_defaut;
            ftris_cfg[i].cfg_valeur_int_lue = ftris_cfg[i].cfg_valeur_int_par_defaut;
        }
        else
        {
            /* chaine */
            strcpy(ftris_cfg[i].cfg_valeur_chaine, ftris_cfg[i].cfg_valeur_chaine_par_defaut);
            ftris_cfg[i].cfg_valeur_chaine_lue =
                (unsigned char *)ftris_malloc(100, "configuration file buffer");
            strcpy(ftris_cfg[i].cfg_valeur_chaine_lue, ftris_cfg[i].cfg_valeur_chaine_par_defaut);
        }
        i++;
    }
    #ifndef MSDOS
    strcpy(user, getlogin());
    if (strlen(user) > 10)
        user[10] = '\0';
    strcpy(net_nom, user);
    #endif
}

/*
 * charge_config: charge la config de FlashTris
 */

void charge_config()
{
    int             i, nb_car;
    unsigned char   signature[100], os[10];
    FILE            *f;

    if (!silencieux)
        printf("Reading configuration... ");
    f = fopen("ftris.cfg", "rb");
    if (f == NULL)
    {
        if (!silencieux)
            printf("NOT FOUND (default config used)\n");
        config_par_defaut();
    }
    else
    {
        fread(signature, strlen(SIGNATURE_CONFIG), 1, f);
        signature[strlen(SIGNATURE_CONFIG)] = '\0';
        if (strcmp(signature, SIGNATURE_CONFIG) != 0)
        {
            if (!silencieux)
                printf("ERROR\n");
            ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                "bad configuration file. Default config used");
            config_par_defaut();
        }
        else
        {
            fread(os, strlen(OS_CONFIG), 1, f);
            os[strlen(OS_CONFIG)] = '\0';
            i = 0;
            while ( (ftris_cfg[i].cfg_valeur_int != NULL)
                || (ftris_cfg[i].cfg_valeur_chaine != NULL) )
            {
                if (ftris_cfg[i].cfg_valeur_int != NULL)
                {
                    /* entier */
                    fread(ftris_cfg[i].cfg_valeur_int, sizeof(int), 1, f);
                    ftris_cfg[i].cfg_valeur_int_lue = *ftris_cfg[i].cfg_valeur_int;
                }
                else
                {
                    /* chaine */
                    fread(&nb_car, sizeof(nb_car), 1, f);
                    ftris_cfg[i].cfg_valeur_chaine_lue =
                        (unsigned char *)ftris_malloc(100, "configuration file buffer");
                    fread(ftris_cfg[i].cfg_valeur_chaine_lue, nb_car, 1, f);
                    ftris_cfg[i].cfg_valeur_chaine_lue[nb_car] = '\0';
                    strcpy(ftris_cfg[i].cfg_valeur_chaine,
                        ftris_cfg[i].cfg_valeur_chaine_lue);
                }
                i++;
            }
            fclose(f);
            if (strcmp(os, OS_CONFIG) != 0)
            {
                #ifdef MSDOS
                /* config Linux lue sous Dos */
                volume = (volume*VOLUME_MAX)/VOLUME_MAX_LINUX;
                if (!silencieux)
                    printf("OK (converted from Linux format)\n");
                #else
                /* config Dos/Windows lue sous Linux */
                volume = (volume*VOLUME_MAX)/VOLUME_MAX_DOS;
                if (!silencieux)
                    printf("OK (converted from Dos/Windows format)\n");
                #endif
            }
            else
                if (!silencieux)
                    printf("OK\n");
        }
    }
    volume_config = volume;
}

/*
 * sauve_config: sauve la config de FlashTris
 */

void sauve_config()
{
    int             i, nb_car;
    unsigned char   signature[100], os[10];
    FILE            *f;

    if (!silencieux)
        printf("Saving configuration.... ");
    f = fopen("ftris.cfg", "wb");
    if (f == NULL)
    {
        if (!silencieux)
            printf("ERROR\n");
        ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
            "can't write configuration file 'ftris.cfg'");
        return;
    }
    strcpy(signature, SIGNATURE_CONFIG);
    fwrite(signature, strlen(SIGNATURE_CONFIG), 1, f);
    strcpy(os, OS_CONFIG);
    fwrite(os, strlen(OS_CONFIG), 1, f);
    i = 0;
    while ( (ftris_cfg[i].cfg_valeur_int != NULL)
        || (ftris_cfg[i].cfg_valeur_chaine != NULL) )
    {
        if (ftris_cfg[i].cfg_valeur_int != NULL)
        {
            /* entier */
            fwrite(ftris_cfg[i].cfg_valeur_int, sizeof(int), 1, f);
        }
        else
        {
            /* chaine */
            nb_car = strlen(ftris_cfg[i].cfg_valeur_chaine);
            fwrite(&nb_car, sizeof(nb_car), 1, f);
            fwrite(ftris_cfg[i].cfg_valeur_chaine, nb_car, 1, f);
        }
        i++;
    }
    fclose(f);
    if (!silencieux)
        printf("OK\n");
}
