/* ========================================================================== *
 *                                                                            *
 *                                                                            *
 *          FlashTris (c) 2001/09/06 by FlashCode (Sebastien Helleu)          *
 *                          (started on 1999/06/21)                           *
 *                                                                            *
 *                       web: http://flashcode.free.fr                        *
 *                         e-mail: flashcode@free.fr                          *
 *                                                                            *
 *                                                                            *
 * ========================================================================== *

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <string.h>

#ifdef MSDOS
    #include <dos.h>
    #include <dpmi.h>
    #include <go32.h>
#else
    #include <signal.h>
    #ifndef CYGWIN
        #include <vga.h>
        #include <vgakeyboard.h>
        #include <X11/Xlib.h>
    #endif
#endif

#include "ftris.h"
#include "date.h"
#include "key.h"
#include "game.h"
#include "bonus.h"
#include "config.h"
#include "menu.h"
#include "video.h"
#include "./module/mod.h"
#include "playfli.h"
#include "data_exe.h"


/* ================ SON ================ */

int             sb16;           /* = 1 si carte son detectee et OK               */
int             force_port;     /* force le port de la SB16                      */
int             force_irq;      /* force l'IRQ de la SB16                        */
int             music_menu;     /* musique du menu                               */
int             music_jeu;      /* musique du jeu                                */
int             music_jouee;    /* pour savoir quelle est la musique en "Random" */
int             sons;           /* 0 = aucun   1 = speaker   2 = SB16+speaker    */
int             sons_menu;      /* bruitages sur le menu ?                       */
unsigned char   *nom_music[NB_MUSIC+1] =    /* nom des musiques */
                { "empty6.dat", "elecdru6.dat", "tetris6.dat", "cousins6.dat",
                  "12war6.dat", "2cyber6.dat", /*"daria6.dat",*/ "crystal6.dat",
                  "transfo6.dat", "eyetige6.dat", "fairlig6.dat",
                  "ultimat6.dat", "woow6.dat", "speed6.dat", "pop56.dat",
                  "tune26.dat", "ice6.dat", "ziriax6.dat",
                  /*"country6.dat",*/ "xmas6.dat" };
int             shuffle_music[NB_MUSIC];
int             pos_shuffle;

/* =============== AUTRES ============== */

int     mosaique[800][2] = { /* (32 x 25) */
{7,18}, {6,15}, {9,24}, {19,3}, {17,18}, {31,22}, {10,18}, {12,15}, {9,20},
{13,19}, {26,23}, {11,13}, {18,21}, {27,1}, {3,5}, {6,10}, {28,16}, {2,7},
{20,11}, {24,16}, {27,12}, {8,5}, {7,5}, {13,13}, {22,5}, {26,22}, {14,14},
{3,10}, {19,14}, {9,10}, {26,18}, {6,13}, {18,20}, {13,8}, {23,17}, {24,1},
{3,19}, {26,13}, {5,7}, {29,17}, {5,13}, {23,3}, {24,5}, {9,4}, {30,24},
{20,22}, {11,22}, {18,11}, {13,0}, {27,2}, {20,5}, {20,23}, {17,8}, {2,24},
{20,18}, {1,15}, {1,22}, {29,3}, {28,8}, {7,10}, {16,10}, {9,3}, {30,13},
{1,4}, {1,16}, {1,8}, {28,3}, {7,9}, {30,11}, {1,17}, {30,12}, {10,7},
{28,23}, {11,1}, {22,4}, {15,21}, {24,12}, {28,14}, {10,24}, {12,18}, {16,24},
{27,18}, {27,7}, {18,23}, {15,12}, {28,22}, {20,20}, {12,2}, {24,17}, {27,16},
{28,12}, {26,5}, {30,2}, {3,23}, {27,24}, {26,17}, {26,11}, {27,20}, {9,6},
{17,15}, {6,3}, {5,16}, {28,2}, {28,7}, {21,15}, {24,8}, {30,8}, {1,20},
{9,8}, {25,2}, {28,13}, {27,6}, {8,1}, {25,22}, {15,13}, {21,3}, {11,5},
{17,2}, {19,8}, {5,22}, {15,16}, {0,8}, {9,9}, {1,11}, {5,5}, {10,3}, {11,21},
{11,19}, {16,19}, {8,10}, {7,2}, {4,4}, {29,0}, {31,21}, {3,13}, {30,20},
{28,15}, {27,9}, {4,23}, {5,17}, {19,22}, {26,6}, {5,20}, {11,20}, {25,3},
{3,11}, {27,11}, {16,21}, {4,5}, {4,7}, {17,7}, {30,10}, {9,12}, {28,21},
{20,17}, {12,16}, {18,3}, {27,5}, {16,20}, {15,4}, {19,19}, {13,11}, {3,8},
{8,7}, {7,17}, {21,13}, {28,0}, {27,14}, {15,6}, {2,21}, {26,1}, {11,7},
{1,6}, {31,16}, {24,22}, {24,11}, {4,0}, {27,13}, {19,17}, {21,6}, {10,4},
{14,6}, {24,15}, {18,0}, {0,9}, {25,17}, {13,22}, {29,9}, {14,8}, {23,5},
{26,2}, {11,9}, {12,5}, {5,10}, {12,1}, {6,12}, {11,4}, {10,17}, {21,14},
{2,15}, {30,16}, {16,14}, {21,18}, {19,9}, {27,4}, {28,10}, {19,6}, {22,0},
{20,19}, {19,15}, {2,17}, {16,11}, {30,6}, {15,3}, {18,6}, {21,12}, {29,1},
{2,4}, {14,2}, {8,16}, {20,7}, {18,19}, {10,16}, {20,9}, {8,19}, {26,8},
{10,14}, {24,0}, {8,6}, {4,1}, {12,20}, {27,21}, {19,5}, {14,23}, {12,8},
{23,14}, {13,5}, {27,22}, {9,21}, {5,4}, {6,9}, {4,8}, {13,24}, {3,3},
{4,6}, {31,4}, {20,14}, {22,24}, {30,3}, {18,14}, {12,4}, {10,15}, {4,15},
{16,5}, {22,10}, {0,23}, {3,22}, {12,17}, {7,15}, {4,19}, {20,4}, {11,14},
{25,12}, {26,12}, {6,23}, {3,12}, {30,18}, {5,3}, {17,3}, {7,14}, {19,0},
{23,18}, {16,9}, {20,10}, {25,15}, {23,22}, {0,12}, {16,22}, {8,13}, {5,2},
{30,0}, {20,2}, {4,24}, {24,14}, {26,7}, {9,13}, {9,18}, {16,7}, {26,21},
{9,22}, {10,9}, {30,5}, {17,6}, {5,18}, {8,4}, {19,23}, {26,24}, {20,12},
{17,11}, {25,14}, {18,1}, {23,1}, {14,4}, {5,0}, {15,11}, {8,3}, {9,11},
{2,11}, {19,20}, {0,17}, {10,6}, {18,12}, {18,9}, {21,24}, {8,2}, {6,11},
{2,3}, {25,4}, {8,20}, {7,3}, {21,16}, {16,1}, {31,23}, {0,24}, {4,3},
{28,5}, {5,6}, {14,18}, {23,15}, {25,19}, {13,20}, {21,22}, {0,11}, {12,12},
{23,11}, {4,12}, {5,11}, {17,16}, {12,7}, {12,14}, {6,19}, {17,22}, {28,1},
{0,22}, {27,0}, {2,14}, {4,11}, {1,3}, {3,20}, {15,7}, {2,0}, {3,0}, {20,15},
{15,1}, {26,16}, {15,23}, {7,4}, {22,16}, {19,10}, {7,19}, {31,3}, {17,1},
{13,21}, {15,10}, {22,13}, {3,24}, {21,4}, {1,9}, {4,9}, {3,6}, {7,23},
{24,10}, {18,2}, {5,23}, {24,19}, {5,8}, {10,1}, {24,23}, {23,0}, {1,7},
{21,8}, {2,9}, {10,13}, {9,14}, {14,0}, {13,6}, {22,23}, {8,22}, {12,9},
{26,10}, {18,18}, {20,3}, {8,17}, {18,4}, {23,7}, {10,5}, {8,21}, {3,7},
{0,16}, {12,0}, {23,8}, {10,0}, {13,18}, {18,8}, {25,13}, {12,19}, {11,18},
{2,23}, {22,17}, {17,0}, {25,7}, {13,7}, {6,16}, {31,11}, {9,2}, {3,15},
{21,23}, {2,16}, {2,13}, {30,19}, {1,1}, {13,17}, {5,9}, {9,19}, {11,11},
{14,19}, {21,11}, {7,20}, {22,20}, {10,21}, {31,5}, {1,10}, {29,4}, {30,17},
{3,9}, {27,10}, {31,0}, {30,7}, {14,13}, {18,15}, {25,8}, {28,9}, {12,22},
{7,7}, {28,18}, {1,18}, {7,0}, {15,17}, {25,1}, {16,4}, {23,9}, {20,13},
{10,19}, {7,22}, {30,22}, {31,17}, {11,17}, {22,3}, {22,11}, {14,16}, {14,21},
{25,9}, {3,18}, {10,11}, {30,15}, {12,10}, {22,21}, {1,23}, {11,15}, {22,9},
{1,13}, {15,20}, {18,16}, {21,20}, {21,2}, {12,6}, {19,1}, {29,18}, {28,20},
{19,18}, {0,10}, {29,14}, {1,2}, {8,11}, {28,19}, {14,22}, {11,0}, {8,18},
{19,2}, {6,6}, {6,7}, {7,8}, {11,23}, {6,17}, {18,22}, {31,13}, {27,19},
{0,1}, {24,13}, {22,8}, {7,11}, {30,1}, {27,3}, {4,10}, {0,21}, {2,10},
{17,20}, {21,17}, {0,18}, {13,9}, {29,7}, {13,10}, {27,15}, {22,12}, {12,21},
{6,4}, {15,18}, {19,11}, {26,15}, {24,6}, {21,9}, {16,12}, {2,18}, {29,15},
{26,9}, {5,12}, {3,2}, {19,24}, {20,16}, {26,3}, {3,21}, {14,20}, {11,6},
{17,13}, {14,24}, {23,6}, {0,3}, {25,0}, {23,4}, {25,21}, {16,13}, {15,0},
{31,24}, {27,8}, {26,4}, {17,5}, {13,3}, {10,8}, {27,23}, {29,8}, {20,8},
{4,16}, {23,13}, {16,17}, {0,4}, {29,6}, {8,15}, {17,19}, {31,12}, {21,1},
{8,0}, {29,10}, {14,3}, {16,16}, {14,12}, {2,19}, {24,4}, {3,4}, {25,6},
{11,12}, {8,24}, {2,2}, {30,14}, {13,1}, {7,1}, {17,17}, {21,10}, {10,20},
{12,11}, {16,2}, {17,14}, {1,5}, {15,2}, {29,16}, {10,22}, {22,22}, {9,15},
{8,8}, {23,16}, {23,21}, {4,2}, {28,4}, {0,5}, {7,13}, {22,2}, {30,4},
{13,2}, {29,13}, {25,23}, {15,22}, {29,20}, {6,1}, {29,22}, {29,11}, {16,18},
{6,24}, {23,12}, {0,13}, {25,11}, {6,8}, {13,12}, {16,15}, {17,9}, {23,23},
{2,5}, {22,15}, {13,15}, {6,22}, {28,6}, {21,19}, {15,8}, {23,10}, {2,12},
{9,5}, {1,24}, {31,1}, {24,20}, {18,13}, {23,2}, {4,20}, {16,3}, {19,13},
{5,1}, {21,0}, {31,10}, {29,5}, {17,23}, {4,17}, {20,0}, {10,12}, {11,16},
{11,10}, {17,4}, {1,0}, {13,16}, {14,11}, {31,2}, {26,0}, {26,19}, {14,17},
{6,20}, {13,14}, {14,15}, {29,12}, {7,16}, {7,21}, {11,3}, {25,16}, {18,24},
{14,9}, {7,12}, {19,4}, {20,24}, {2,6}, {24,3}, {11,24}, {16,8}, {18,5},
{5,14}, {29,24}, {12,23}, {3,17}, {24,9}, {9,17}, {1,14}, {14,10}, {19,12},
{12,13}, {3,16}, {1,12}, {7,24}, {10,10}, {29,23}, {12,3}, {15,9}, {18,7},
{31,18}, {28,24}, {24,21}, {29,19}, {24,2}, {29,2}, {21,21}, {0,15}, {22,1},
{18,10}, {1,21}, {22,6}, {15,19}, {31,19}, {27,17}, {10,2}, {9,7}, {13,23},
{19,7}, {4,13}, {11,8}, {31,6}, {0,19}, {25,18}, {5,19}, {12,24}, {0,0},
{17,10}, {1,19}, {24,18}, {2,8}, {23,19}, {22,7}, {25,5}, {8,12}, {22,19},
{2,1}, {25,10}, {31,8}, {6,14}, {0,14}, {9,16}, {31,15}, {30,21}, {29,21},
{6,5}, {7,6}, {16,6}, {5,21}, {15,15}, {4,21}, {19,16}, {17,12}, {4,14},
{6,18}, {31,20}, {3,1}, {30,9}, {17,21}, {25,24}, {8,14}, {15,14}, {11,2},
{3,14}, {31,9}, {10,23}, {4,22}, {15,5}, {0,20}, {5,15}, {21,5}, {15,24},
{9,23}, {20,6}, {2,20}, {16,0}, {2,22}, {31,7}, {28,11}, {0,7}, {19,21},
{6,0}, {8,23}, {24,24}, {14,1}, {24,7}, {22,14}, {20,21}, {14,5}, {6,2},
{30,23}, {6,21}, {5,24}, {26,20}, {18,17}, {14,7}, {23,24}, {8,9}, {31,14},
{26,14}, {20,1}, {28,17}, {21,7}, {13,4}, {16,23}, {25,20}, {17,24}, {0,2},
{4,18}, {23,20}, {22,18}, {9,0}, {9,1}, {0,6} };

unsigned char   *nom_fond[NB_FONDS] =
                { "astronef.dat", "brique.dat", "disco.dat", "dune.dat",
                  "feuilles.dat", "melted.dat", "mud.dat", "neuron.dat",
                  "rocks.dat", "whirl.dat" };

/* parametres de ligne de commande: */
unsigned char   argv0[256];         /* parametre 0 (nom de l'executable)       */
int             no_intro;           /* pas de presentation ?                   */
int             no_sound;           /* pas de son ni musique ?                 */
int             no_game;            /* ne lance ni le menu ni le jeu (debug)   */
int             silencieux;         /* pas de message a afficher ?             */
int             nbx, nby;           /* dimensions de la fenetre pour FlashTris */
int             experimental_X_console; /* mode experimental (console sous X-Window) */

/* autre: */
t_sprite        titre_flashtris;    /* titre "Flashtris"                                       */
t_sprite        titre_flashtris_blanc;  /* titre "Flashtris" tout blanc (pour l'eclair)        */
t_sprite        copyright;          /* copyright                                               */
t_sprite        grillage;           /* grillage pour le menu                                   */
t_sprite        grillage_clair;     /* grillage plus clair (partie de menu activee)            */

t_sprite        case_vide[2];       /* dessin d'une case a cocher VIDE                         */
t_sprite        case_cochee[6];     /* dessin d'une case a cocher COCHEE (6 coloris possibles) */

t_sprite        brique[NB_TC][8];   /* dessin des briques                                      */

t_sprite        explosion[NB_TC];   /* dessin de l'explosion                                   */
t_sprite        bombe[NB_TC][2];    /* dessin de la bombe                                      */
t_sprite        tube[15][7];        /* dessin des tubes (pour le menu)                         */


/* ========================================================================== */

/*
 * ftris_error: affiche un warning ou une erreur
 *              si error = 0, warning, si 1: erreur
 *              si bug = 1, affiche en plus que c'est un bug
 *              si fin_sb16 = 1, appelle close_sb16 (reinitialise la SoundBlaster)
 *              si stop_prog > 0, arrete le programme sans retourner a l'appelant
 */

void ftris_error(int error, int bug, int fin_sb16, int stop_prog,
                 unsigned char *chaine, ...)
{
    unsigned char   buffer[255];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    if (error)
        fprintf(stderr, "FlashTris ERROR: %s\n", buffer);
    else
        if (!silencieux)
            fprintf(stderr, "FlashTris WARNING: %s\n", buffer);
    if (bug)
        fprintf(stderr, REPORT_BUG);
    if (fin_sb16)
        close_sb16();
    if (stop_prog)
        exit(stop_prog);
}

void *ftris_malloc(int taille, unsigned char *libelle)
{
    void    *ptr;

    ptr = malloc(taille);
    if (ptr == NULL)
        ftris_error(MSG_ERROR, NO_BUG, CLOSE_SB16, STOP_PROG,
            "not enough memory for %s (asked: %d bytes)", libelle, taille);
    return ptr;
}

/* ========================================================================== */

/*
 * affiche_entete_aide: affiche l'entete de l'aide
 */

void affiche_entete_aide()
{
    printf("******************************************************************************\n");
    printf(" ****   FlashTris  (c) " DATE_EN_LONG " " VERSION " for " OS "   ****\n");
    printf("  ****   by FlashCode                   %s  <== e-mail   ****\n", EMAIL);
    printf("   ****   (Sebastien Helleu)     %s  <==== web   ****\n", SITE_WEB);
    printf("    **********************************************************************\n");
    printf("\n");
}

/*
 * affiche_aide_options: affiche l'aide sur les options
 */

void affiche_aide_options()
{
    affiche_entete_aide();
    printf("Syntax: ftris [-i | -nointro] [-s | -nosound] [-q | -quiet]\n");
    printf("              [-v[a] | -version[all]] [-l | -license] [-h | -hardware]\n");
    printf("              [-irq#] [-port###] [-nbx#] [-nby#]\n");
    printf("\n");
    printf(" -i, -nointro  skip intro\n");
    printf(" -s, -nosound  no sound either music\n");
    printf(" -q, -quiet    disable startup messages (keep severe errors)\n");
    printf(" -v, -version  latest versions history (-va or -versionall: all versions)\n");
    printf(" -l, -license  show FlashTris license\n");
    printf(" -h, -hardware show recommended hardware\n");
    printf(" -irq#         (Dos/Win. only) forces irq # (2, 3, 5 or 7) for SoundBlaster\n");
    printf(" -port###      (Dos/Win. only) forces port ### (hexa,200-280) for SoundBlaster\n");
    printf(" -nbx#         (X-Window only) width of window (320-1280, default:640)\n");
    printf(" -nby#         (X-Window only) height of window (200-800, default:400)\n");
    #if !defined(MSDOS) && !defined(CYGWIN)
    printf("\n");
    #endif
    exit(0);
}

/*
 * affiche_dernieres_versions: affiche les dernieres versions
 */

void affiche_dernieres_versions()
{
    affiche_entete_aide();
    printf("FlashTris v0.001 to v0.009  type 'ftris -va'\n");
    printf("          ................\n");
    printf("           0.1  2001/01/15  bonus level \"brix\", new music, messages window,\n");
    printf("                            cooperative mode (with computer), bugs\n");
    printf("           0.2  2001/02/26  network game (Linux only), graphical effects,\n");
    printf("                            more levels (1P game), new music\n");
    printf("          0.25  2001/03/26  intro music, time, bugs\n");
    printf("          0.26  2001/04/17  challenge mode, bugs\n");
    printf("          0.27  2001/05/07  random music, bonus choice,\n");
    printf("                            experimental X-console\n");
    printf("          0.28  2001/05/26  scroll info on menu, bugs\n");
    printf("          0.29  2001/06/03  new music (Tetris original !), fixed display bugs\n");
    printf("    >>>>   0.3  2001/09/06  full source code available !!!!!!!!!!!!!!!!!!!!!!!!\n");
    printf("\n");
    printf("You are running FlashTris " VERSION " for " OS "\n");
    printf("compiled on " DATE_COMPILED "\n");
    #if !defined(MSDOS) && !defined(CYGWIN)
    printf("\n");
    #endif
    exit(0);
}

/*
 * affiche_toutes_versions: affiche l'historique de toutes les versions
 */

void affiche_toutes_versions()
{
    affiche_entete_aide();
    printf("FlashTris v0.001  july  1999  only menu...\n");
    printf("           0.002  aug.  1999  bugs\n");
    printf("           0.003  sep.  1999  game, bugs\n");
    printf("           0.004  jan.  2000  1st downloadable version\n");
    printf("           0.005  june  2000  high scores table\n");
    printf("           0.006  2000/11/13  Linux version available\n");
    printf("           0.007  2000/12/14  configuration, bugs\n");
    printf("           0.008  2000/12/21  improved material detection, bugs\n");
    printf("           0.009  2001/01/01  new music, shaded items on menu, bugs\n");
    printf("             0.1  2001/01/15  bonus level \"brix\", new music, messages window,\n");
    printf("                              cooperative mode (with computer), bugs\n");
    printf("             0.2  2001/02/26  network game (Linux only), graphical effects,\n");
    printf("                              more levels (1P game), new music\n");
    printf("            0.25  2001/03/26  intro music, time, bugs\n");
    printf("            0.26  2001/04/17  challenge mode, bugs\n");
    printf("            0.27  2001/05/07  random music, bonus choice,\n");
    printf("                              experimental X-console\n");
    printf("            0.28  2001/05/26  scroll info on menu, bugs\n");
    printf("            0.29  2001/06/03  new music (Tetris original !), fixed display bugs\n");
    printf("      >>>>   0.3  2001/09/06  full source code available !!!!!!!!!!!!!!!!!!!!!!\n");
    printf("\n");
    printf("You are running FlashTris " VERSION " for " OS "\n");
    /*printf("compiled on " __DATE__ " " __TIME__ "\n");*/
    printf("compiled on " DATE_COMPILED "\n");
    #if !defined(MSDOS) && !defined(CYGWIN)
    printf("\n");
    #endif
    exit(0);
}

/*
 * affiche_licence: affiche la licence de FlashTris
 */

void affiche_licence()
{
    affiche_entete_aide();
    printf("     FlashTris (c) Copyright 1999,2000,2001 by FlashCode (Sebastien Helleu)\n");
    printf("\n");
    printf("     This program is free software; you can redistribute it and/or modify\n");
    printf("     it under the terms of the GNU General Public License as published by\n");
    printf("     the Free Software Foundation; either version 2 of the License, or\n");
    printf("     (at your option) any later version.\n");
    printf("\n");
    printf("     This program is distributed in the hope that it will be useful,\n");
    printf("     but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
    printf("     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
    printf("     GNU General Public License or file COPYING for more details.\n\n");
    exit(0);
}

/*
 * affiche_hardware: affiche la config recommandee pour jouer a FlashTris
 */

void affiche_hardware()
{
    affiche_entete_aide();
    printf("Minimal hardware : PC 386 with 2 Mb RAM, VGA graphics card\n\n");
    printf("Recommended hardware (for maximal fun :) :\n");
    printf(" - Intel Pentium or AMD K6 with 8 Mb RAM\n");
    printf(" - soundcard 100%% compatible with SoundBlaster 16\n");
    printf(" - Internet connection (modem or other)\n\n");
    printf("For full details and animations, mini is : 200 MHz processor, 8 Mb RAM\n");
    printf("For medium details, mini is : 133 MHz processor, 2 Mb RAM\n");
    printf("For low details, mini is : 80386 processor, 2 Mb RAM\n\n");
    printf("Type \"ftris -?\" for help.\n\n");
    exit(0);
}

/*
 * traite_options_immediates: recherche s'il y a le parametre
 *                            "demande d'aide" ou "liste des versions"
 *                            sur la ligne de commande
 *                            et traite l'option -q (-quiet)
 */

void traite_options_immediates(int argc, char *argv[])
{
    int     i;

    silencieux = 0;
    nbx = 0;
    nby = 0;
    experimental_X_console = 0;
    for (i = 1; i < argc; i++)
        if ( (strcmp(argv[i], "-?") == 0) || (strcmp(argv[i], "/?") == 0)
            || (strcmp(argv[i], "?") == 0) )
            affiche_aide_options();
        else
            if ( (strcasecmp(argv[i], "-version") == 0)
                || (strcasecmp(argv[i], "-v") == 0) )
                affiche_dernieres_versions();
            else
                if ( (strcasecmp(argv[i], "-versionall") == 0)
                    || (strcasecmp(argv[i], "-va") == 0) )
                    affiche_toutes_versions();
                else
                    if ( (strcasecmp(argv[i], "-license") == 0)
                        || (strcasecmp(argv[i], "-l") == 0) )
                            affiche_licence();
                    else
                        if ( (strcasecmp(argv[i], "-hardware") == 0)
                            || (strcasecmp(argv[i], "-h") == 0) )
                            affiche_hardware();
                        else
                            if ( (strcasecmp(argv[i], "-quiet") == 0)
                                || (strcasecmp(argv[i], "-q") == 0) )
                                silencieux = 1;
                            #if !defined(MSDOS) && !defined(CYGWIN)
                            else
                                if (strncasecmp(argv[i], "-nbx", 4) == 0)
                                {
                                    if (!X_Window)
                                        ftris_error(MSG_WARNING, NO_BUG,
                                            NO_CLOSE_SB16, CONTINUE,
                                            "parameter '-nbx' runs only under X-Window !");
                                    else
                                        nbx = atoi(&argv[i][4]);
                                }
                                else
                                    if (strncasecmp(argv[i], "-nby", 4) == 0)
                                    {
                                        if (!X_Window)
                                            ftris_error(MSG_WARNING, NO_BUG,
                                                NO_CLOSE_SB16, CONTINUE,
                                                "parameter '-nby' runs only under X-Window !");
                                    else
                                        nby = atoi(&argv[i][4]);
                                    }
                                    else
                                        if (strcasecmp(argv[i], "-experimental_X_console") == 0)
                                            experimental_X_console = 1;
                            #endif
    if ( (nbx != 0) && ( (nbx < 320) || (nbx > 1280) ) )
    {
        ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
            "invalid window width (nbx must be between 320 and 1280)");
        nbx = 0;
    }
    if (nbx == 0)
        nbx = X_NBX_DEFAUT;
    if ( (nby != 0) && ( (nby < 200) || (nby > 800) ) )
    {
        ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
            "invalid window height (nby must be between 200 and 800)");
        nby = 0;
    }
    if (nby == 0)
        nby = X_NBY_DEFAUT;
    if ( (nbx%320 != 0) || (nby%200 != 0) || ((nbx*5)/8 != nby) )
    {
        ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
            "window size msut be multiple of 320x200");
        nbx = X_NBX_DEFAUT;
        nby = X_NBY_DEFAUT;
    }
}

/*
 * traite_options: traite les options de la ligne de commande
 *                 (apres le chargement de la config et si argv[0] != '-?' ou '/?')
 */

void traite_options(int argc, char *argv[])
{
    int             i;
    #ifdef MSDOS
    unsigned char   format[10];
    #endif

    no_intro = 0;
    no_sound = 0;
    no_game = 0;
    force_port = 0;
    force_irq = 0;
    for (i = 1; i < argc; i++)
        if ( (strcasecmp(argv[i], "-quiet") != 0)
            && (strcasecmp(argv[i], "-q") != 0) )
        {
            if ( (strcasecmp(argv[i], "-nointro") == 0)
                || (strcasecmp(argv[i], "-i") == 0) )
                no_intro = 1;
            else
                if ( (strcasecmp(argv[i], "-nosound") == 0)
                    || (strcasecmp(argv[i], "-s") == 0) )
                    no_sound = 1;
                else
                    if (strcasecmp(argv[i], "-nogame") == 0)
                        no_game = 1;
                    else
                        #ifdef MSDOS
                        if (strncasecmp(argv[i], "-port", 5) == 0)
                        {
                            sprintf(format, "%%03X");
                            sscanf(&argv[i][5], format, &force_port);
                            printf("port decode = %03X\n", force_port);
                        }
                        else
                            if (strncasecmp(argv[i], "-irq", 4) == 0)
                                force_irq = atoi(&argv[i][4]);
                            else
                        #else
                            if ( (strncasecmp(argv[i], "-nbx", 4) != 0)
                                && (strncasecmp(argv[i], "-nby", 4) != 0)
                                && (strcasecmp(argv[i], "-experimental_X_console") != 0) )
                        #endif
                            ftris_error(MSG_WARNING, NO_BUG,
                                NO_CLOSE_SB16, CONTINUE,
                                "unknown parameter: '%s'", argv[i]);
        }
    if ( (force_port != 0) && ( (force_port < 0x200) || (force_port > 0x280) ) )
    {
        ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
            "SB16 port must be between 0x200 and 0x280");
        force_port = 0;
    }
    if ( (force_irq != 0) && (force_irq != 2) && (force_irq != 3)
        && (force_irq != 5) && (force_irq != 7) )
    {
        ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
            "SB16 irq must be 2, 3, 5 or 7");
        force_irq = 0;
    }
}

/*
 * detecte_systeme: detecte le systeme d'exploitation
 */

void detecte_systeme()
{
    #if defined(MSDOS) || defined(CYGWIN)
    union REGS  regs_in, regs_out;
    #endif

    if (!silencieux)
        printf("Detecting system........ ");
    #if defined(MSDOS) || defined(CYGWIN)
    if (!silencieux)
    {
        regs_in.h.ah = 0x30;
        intdos(&regs_in, &regs_out);
        if (regs_out.h.al < 7)
            printf("MsDos (v%d.%d)\n", (int)(regs_out.h.al), (int)(regs_out.h.ah));
        else
        {
            if ( (regs_out.h.al == 7) && (regs_out.h.ah == 0) )
                printf("Windows 95\n");
            else
                printf("Windows 95/98/2000\n");
        }
        printf("Initializing grafx...... OK (320x200,256c)\n");
    }
    #else
    if (X_Window)
    {
        if (!silencieux)
        {
            printf("Linux (X-Window)\n");
            /*printf("Initializing grafx...... OK (%dx%d,%dc) -- !!! ALPHA X-WINDOW VERSION !!!\n",
                nbx, nby, 1 << DefaultDepth(display, DefaultScreen(display)));*/
            if (experimental_X_console)
                printf("Initializing grafx...... OK *** WARNING: EXPERIMANTAL CONSOLE (X) MODE !!!!\n");
            else
                printf("Initializing grafx...... ERROR\n");
        }
        if (experimental_X_console)
        {
            printf("*** WARNING: This is experimental mode under X-Window.\n");
            printf("*** This mode opens a console under X-Window.\n");
            printf("*** If display isn't OK, press Esc to quit FlashTris and please\n");
            printf("*** run it in console mode.\n");
            X_Window = 0;
        }
        else
        {
            printf("\nSorry, X-Window version of FlashTris is under development... (not stable)\n");
            printf("To make inquiries about X-Window version, please visit :\n\n");
            printf("    " SITE_WEB "\n\n");
            printf("    or send an e-mail to: " EMAIL "\n\n");
            printf("Please run FlashTris under Linux console. Thank you.\n\n");
            printf("!! NEW !!\n");
            printf("You can try to run FlashTris under an X-console (waiting for windowed version):\n");
            printf("ftris -experimental_X_console\n");
            printf("WARNING: display may not be stable !\n");
            printf("If display isn't OK, press Esc to quit FlashTris and please\n");
            printf("run it in console mode.\n\n");
            exit(1);
        }
    }
    else
        if (!silencieux)
        {
            printf("Linux (console)\n");
            printf("Initializing grafx...... OK (320x200,256c)\n");
        }
    #endif
}


/* ==========================================================================

                             INTERRUPTIONS / TIMER

   ========================================================================== */

/*
 * nouveau_clavier: nouvelle interrpution pour le clavier (Dos uniquement)
 */

#if defined(MSDOS) || defined(CYGWIN)
void nouveau_clavier()
{
    key = inportb(0x60);
    key_tab[key & 127] = (key < 128);
    outportb(0x20, 0x20);
}
#endif

/*
 * detourne_interruption: detourne une interruption (Dos uniquement)
 */

#if defined(MSDOS) || defined(CYGWIN)
void detourne_interruption(int no_int, int adr_new_int,
                           __dpmi_paddr *old_int, _go32_dpmi_seginfo *wrap_int)
{
    __dpmi_paddr    new_int;

    /* sauve l'ancienne interruption */
    __dpmi_get_protected_mode_interrupt_vector(no_int, old_int);
    /* alloue le "wrapper" pour la nouvelle interruption */
    wrap_int->pm_offset = adr_new_int;
    wrap_int->pm_selector = _my_cs();
    _go32_dpmi_allocate_iret_wrapper(wrap_int);
    /* et enfin installe la nouvelle interruption */
    new_int.offset32 = wrap_int->pm_offset;
    new_int.selector = wrap_int->pm_selector;
    __dpmi_set_protected_mode_interrupt_vector(no_int, &new_int);
}
#endif

/*
 * restaure_interruption: restaure une interruption (Dos uniquement)
 */

#if defined(MSDOS) || defined(CYGWIN)
void restaure_interruption(int no_int, __dpmi_paddr *old_int,
                           _go32_dpmi_seginfo *wrap_int)
{
    /* reinstalle l'ancienne interruption */
    __dpmi_set_protected_mode_interrupt_vector(no_int, old_int);
    /* desalloue le "wrapper" associe */
    _go32_dpmi_free_iret_wrapper(wrap_int);
}
#endif

/* ==========================================================================

                                 GESTION DE LA ZIKMU

   ========================================================================== */

/*
 * ftris_detect_sb16: tente d'initialiser la carte son et renvoie :
 *                    0 si OK (carte son detectee et initialisee)
 *                    1 si carte son non detectee
 *                    2 si carte son detectee mais pb d'initialisation
 */

int ftris_detect_sb16()
{
    #if defined(MSDOS) || defined(CYGWIN)
    if ( (force_port == 0) || (force_irq == 0) )
    {
        if (detect_sb16() != 0)
        {
            sb16 = 0;
            return 1;
        }
    }
    if (force_port != 0)
        port_sb = force_port;
    if (force_irq != 0)
        irq_sb = force_irq;
    #endif
    if (sbinit() != 0)
    {
        sb16 = 0;
        return 2;
    }
    else
    {
        sb16 = 1;
        return 0;
    }
}

void init_sb16()
{
    if (!silencieux)
        printf("Initializing sound...... ");
    if (no_sound)
    {
        if (!silencieux)
            printf("DISABLED\n");
        return;
    }
    switch (ftris_detect_sb16())
    {
        case 0:
            if (!silencieux)
                #if defined(MSDOS) || defined(CYGWIN)
                printf("OK (SB16 at %03Xh, irq %d)\n", port_sb, irq_sb);
                #else
                printf("OK\n");
                #endif
            break;
        case 1:
            if (!silencieux)
                printf("ERROR (unable to init SB16; running without music)\n");
            /*ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                "SoundBlaster not found, running without music...");*/
            break;
        case 2:
            if (!silencieux)
                printf("ERROR (unable to init sound; running without music)\n");
            /*ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                "unable to initialize sound, running without music...");*/
            break;
    }
}

/*
 * close_sb16: reinitialise la carte son en fin de programme
 */

void close_sb16()
{
    if (sb16)
    {
        if (!silencieux)
            printf("Soundcard reset......... ");
        /*setvolume(0);*/
        sbdone();
        if (!silencieux)
            printf("OK\n");
    }
}

/*
 * make_shuffle: fabrique un tableau "shuffle" pour les musiques
 */

void make_shuffle()
{
    int     i, numero;
    int     deja_prise[NB_MUSIC];

    for (i = 0; i < NB_MUSIC; i++)
        deja_prise[i] = 0;
    for (i = 0; i < NB_MUSIC; i++)
    {
        do
        {
            numero = rand()%NB_MUSIC;
        } while (deja_prise[numero]);
        deja_prise[numero] = 1;
        shuffle_music[i] = numero+1;
    }
    pos_shuffle = 0;
}

/*
 * ftris_loadmodule: charge un module en memoire
 */

int ftris_loadmodule(unsigned char *nom_module, int stop_at_end)
{
    #ifdef DATA_EXE
    return load_hmodule(argv0, position_fichier(nom_module));
    #else
    unsigned char   nom_complet[256];

    music_stop_at_end = stop_at_end;
    sprintf(nom_complet, "%s%s", PATH_MUSIC, nom_module);
    return load_hmodule(nom_complet, 0L);
    #endif
}

/*
 * ftris_loadsample: charge un sample en memoire
 */

int ftris_loadsample(unsigned char *nom_sample, int instr)
{
    #ifdef DATA_EXE
    return loadsample(argv0, instr, position_fichier(nom_sample));
    #else
    unsigned char   nom_complet[256];

    sprintf(nom_complet, "%s%s", PATH_MUSIC, nom_sample);
    return loadsample(nom_complet, instr, 0L);
    #endif
}

/*
 * ftris_vide_samples: vide tous les samples charges en plus du module
 */

void ftris_vide_samples()
{
    int     i;

    for (i = 35; i < 64; i++)
        if (samplen[i] > 0)
        {
            free(sampptr[i]);
            samplen[i] = 0;
        }
}

/*
 * ftris_charge_samples: charges les samples du menu (0) ou du jeu (1)
 */

void ftris_charge_samples(int jeu)
{
    switch (jeu)
    {
        case 0:
            /* samples pour le menu */
            ftris_loadsample("son1.smp", 35);
            ftris_loadsample("son2.smp", 36);
            ftris_loadsample("son3.smp", 37);
            ftris_loadsample("son4.smp", 38);
            ftris_loadsample("cyber3.smp", 39);
            break;
        case 1:
            /* samples pour le jeu */
            ftris_loadsample("sonj1.smp", 35);
            ftris_loadsample("sonj2.smp", 36);
            ftris_loadsample("son3.smp", 37);
            ftris_loadsample("cyber3.smp", 39);
            break;
    }
}

/*
 * stop_music: stoppe le module en cours
 */

void stop_music()
{
    int     vol_save;

    vol_save = volume;
    setvolume(0);
    stopmodule();
    freemodule();
    volume = vol_save;
}

/*
 * change_music: change de musique
 *               Si "nom_force_musique" est non NULL, cette musique est chargee
 *                 sinon on charge la musique dans le tableau nom_music[]
 */

void change_music(unsigned char *nom_force_musique, int charge_samples)
{
    int             ret, numero_music, music_random;
    unsigned char   *ptr_nom_music;

    music_random = 0;
    if (playing_module)
        stop_music();
    if (nom_force_musique == NULL)
    {
        if ( (en_jeu) || (en_pause) )
            numero_music = music_jeu;
        else
            numero_music = music_menu;
        if (numero_music == NO_MUSIC)
            ptr_nom_music = nom_music[0];
        else
            if (numero_music == MUSIC_RANDOM)
            {
                numero_music = shuffle_music[pos_shuffle];
                pos_shuffle = (pos_shuffle+1)%NB_MUSIC;
                ptr_nom_music = nom_music[numero_music];
                music_random = 1;
            }
            else
                ptr_nom_music = nom_music[numero_music];
    }
    else
        ptr_nom_music = nom_force_musique;
    music_jouee = numero_music;
    ret = ftris_loadmodule(ptr_nom_music, music_random);
    switch (ret)
    {
        case -1:
            #if defined(MSDOS) || defined(CYGWIN)
            restaure_int_timer();
            #endif
            ftris_error(MSG_ERROR, BUG, CLOSE_SB16, STOP_PROG,
                "music not found");
            break;
        case -2:
            #if defined(MSDOS) || defined(CYGWIN)
            restaure_int_timer();
            #endif
            ftris_error(MSG_ERROR, NO_BUG, CLOSE_SB16, STOP_PROG,
                "not enough memory to load music");
            break;
        case -3:
        case -4:
        case -5:
            #if defined(MSDOS) || defined(CYGWIN)
            restaure_int_timer();
            #endif
            ftris_error(MSG_ERROR, BUG, CLOSE_SB16, STOP_PROG,
                "invalid music file (error=%d)", ret);
            break;
    }
    if (charge_samples)
        ftris_charge_samples(en_jeu);
    playmodule();
    setvolume(volume);
}

/* ==========================================================================

                                 GESTION DU CLAVIER

   ========================================================================== */

/*
 * init_clavier: initialise le clavier pour FlashTris
 */

void init_clavier()
{
    #if defined(MSDOS) || defined(CYGWIN)
    memset(key_tab, 0, 129);
    detourne_interruption(0x09, (int)nouveau_clavier, &old_int09, &wrap_int09);
    #else
    if (X_Window)
        key_tab = (unsigned char *)ftris_malloc(129, "keyboard buffer");
    else
    {
        /* Linux Console : */
        keyboard_init();
        key_tab = keyboard_getstate();
    }
    memset(key_tab, 0, 129);
    #endif
}

/*
 * fin_clavier: restaure le clavier en fin de programme
 */

void fin_clavier()
{
    #if defined(MSDOS) || defined(CYGWIN)
    restaure_interruption(0x09, &old_int09, &wrap_int09);
    #else
    if (X_Window)
        free(key_tab);
    else
        keyboard_close();
    #endif
}

/* ==========================================================================

                                   GRAPHISME

   ========================================================================== */


/*
 * presentation_fli: joue le fli "FlashCode Game"
 */

void presentation_fli()
{
    load_fli("ftris.fli");
    if ( (sb16) && (!no_sound) )
    {
        #if defined(MSDOS) || defined(CYGWIN)
        detourne_int_timer();
        #endif
        ftris_loadmodule("huntin6.dat", 0);
        ftris_loadsample("lightnin.smp", 35);
        ftris_loadsample("son1.smp", 36);
        setvolume(volume);
        playmodule();
    }
    #if defined(MSDOS) || defined(CYGWIN)
    if ( (sb16) && (!no_sound) )
    {
        compteur_usleep_dos = 0;
        while (compteur_usleep_dos < 91) ;
    }
    else
        sleep(1);
    #else
    sleep(1);
    #endif

    play_fli(buffer_fli);

    #if defined(MSDOS) || defined(CYGWIN)
    if ( (sb16) && (!no_sound) )
    {
        compteur_usleep_dos = 0;
        while (compteur_usleep_dos < 91*2) ;
    }
    else
        sleep(2);
    #else
    sleep(3);
    #endif
}

/*
 * presentation_images: affiche l'eclair suivi de la presentation
 */

void presentation_images()
{
    unsigned char   pal_noire[768], pal_titre[2][768];
    /*unsigned char   nom_presentation[13];*/
    int             no_ecran, cptr_waitretrace;

    memset(pal_noire, 0, 768);

    #if defined(MSDOS) || defined(CYGWIN)
    if ( (sb16) && (!no_sound) )
    {
        compteur_usleep_dos = 0;
        while (compteur_usleep_dos < 91) ;
    }
    else
        sleep(1);
    #else
    sleep(1);
    #endif

    /* ECLAIR */
    load_dat("lightnin.dat", VSCR_VSCREEN);
    setpal(pal_noire);
    copy_v2s(VSCR_VSCREEN);
    if ( (sb16) && (!no_sound) )
    {
        #if defined(MSDOS) || defined(CYGWIN)
        /*detourne_int_timer();*/
        #endif
        /*ftris_loadmodule(nom_music[0], 0);*/     /* musique vide */
        /*ftris_loadsample("lightnin.smp", 35);*/
        /*playmodule();*/
        playsample(4, 35, 50, 63);
    }
    setpal(palette);
    #if !defined(MSDOS) && !defined(CYGWIN)
    usleep(180000);         /* duree de l'eclair */
    #else
    if ( (sb16) && (!no_sound) )
    {
        compteur_usleep_dos = 0;
        while (compteur_usleep_dos < 20) ;
    }
    else
        usleep(180000);
    #endif

    /* PRESENTATIONS */
    /*sprintf(nom_presentation, "titre%d.dat", (rand()%2)+1);*/
    /*load_dat(nom_presentation, VSCR_AUTRES);*/
    load_dat("titre1.dat", VSCR_AUTRES);
    memcpy(pal_titre[0], palette, 768);
    load_dat("titre2.dat", VSCR_AUTRES+1);
    memcpy(pal_titre[1], palette, 768);

    setpal(pal_noire);
    #if !defined(MSDOS) && !defined(CYGWIN)
    usleep(500000);
    #else
    if ( (sb16) && (!no_sound) )
    {
        compteur_usleep_dos = 0;
        while (compteur_usleep_dos < 45) ;
    }
    else
        usleep(500000);
    #endif

    no_ecran = rand()%2;

    /*copy_v2s(VSCR_AUTRES+no_ecran);*/
    /*fade_in(pal_titre[no_ecran], 1, 10000);*/
    clear_screen();
    setpal(pal_titre[no_ecran]);
    affiche_ecran_vers_centre(VSCR_AUTRES+no_ecran, 2);
    playsample(5, 36, 600, 63);

    cptr_waitretrace = 0;
    while ( (!key_tab[1]) && (!key_tab[SCANCODE_ENTER])
        && (!key_tab[SCANCODE_KEYPADENTER]) && (!key_tab[57])
        && (cptr_waitretrace < 2000) )
    {
        #if !defined(MSDOS) && !defined(CYGWIN)
        if (!X_Window)
            keyboard_update();
        #endif
        teste_shift_ctrl_alt();
        if ( (sb16) && (!no_sound) )
        {
            /* augmentation volume  '+' */
            if ( (key_tab[78]) && (volume < VOLUME_MAX) )
            {
                if (key_control)
                    volume = (volume > VOLUME_MAX-INC_VOLUME_VITE)?VOLUME_MAX:volume+INC_VOLUME_VITE;
                else
                    volume++;
                setvolume(volume);
                key_tab[78] = 0;
            }

            /* diminution volume  '-' */
            if ( (key_tab[74]) && (volume > 0) )
            {
                if (key_control)
                    volume = (volume < INC_VOLUME_VITE)?0:volume-INC_VOLUME_VITE;
                else
                    volume--;
                setvolume(volume);
                key_tab[74] = 0;
            }
        }
        waitretrace();
        cptr_waitretrace++;
        if (cptr_waitretrace == 800)
        {
            /*fade_out(pal_titre[no_ecran], 6, 5000);*/
            /*setpal(pal_noire);*/
            efface_ecran_mosaique(ECRAN_REEL, mosaique, 32, 25, 40);
            no_ecran ^= 1;
            /*copy_v2s(VSCR_AUTRES+no_ecran);*/
            /*fade_in(pal_titre[no_ecran], 6, 5000);*/
            setpal(pal_titre[no_ecran]);
            affiche_ecran_mosaique(VSCR_AUTRES+no_ecran, mosaique, 32, 25, 40);
        }
    }

    fade_out(pal_titre[no_ecran], 5, 10000);
    clear_screen();

    if (sb16)
    {
        setvolume(0);
        stopmodule();
        freemodule();
        setvolume(vol_ini);
        #if defined(MSDOS) || defined(CYGWIN)
        restaure_int_timer();
        #endif
    }
}

/* load_gfx: charge les graphismes pour le menu et le jeu */

void load_gfx()
{
    int     i, j, k, m, n;
    int     coul[9];                /* 4 coins + 4 bords + interieur  */
    /*int     meilleure_coul;*/     /* couleur la plus proche trouvee */
    /*int     ecart_pal;*/
    /*int     meilleur_ecart_pal;*/ /* ecart le plus faible trouve */

    switch (load_dat("ftris1.dat", VSCR_VSCREEN) != 0)
    {
        case -1:
            ftris_error(MSG_ERROR, BUG, CLOSE_SB16, STOP_PROG,
                "graphics file not found");
            break;
        case -2:
            ftris_error(MSG_ERROR, BUG, CLOSE_SB16, STOP_PROG,
                "graphics file is invalid");
            break;
        case -3:
            ftris_error(MSG_ERROR, NO_BUG, CLOSE_SB16, STOP_PROG,
                "not enough memory to load graphics");
            break;
    }
    /*setpal(palette);*/

    /* Pour le menu : */
    getsprite(VSCR_VSCREEN, 7, 168, 214, 29, &titre_flashtris);
    getsprite(VSCR_VSCREEN, 7, 168, 214, 29, &titre_flashtris_blanc);

    for (j = 0; j < 15; j++)
        for (i = 0; i < 7; i++)
            getsprite(VSCR_VSCREEN, 225+i*10, 39+j*10, 9, 9, &tube[j][i]);

    /* Inversion des couleurs du titre */
    for (j = 0; j < 29; j += 2)
        for (i = 0; i < 214; i++)
            /*if (titre_flashtris.s_ptr[j*214+i] != 0)*/
            if (getpixel_xy_sprite(&titre_flashtris, i, j) != 0)
                /*titre_flashtris.s_ptr[j*214+i] = 110-j/2;*/
                putpixel_xy_sprite(&titre_flashtris, i, j, 110-j/2);
    /* Titre flashtris blanc */
    for (j = 0; j < 29; j += 2)
        for (i = 0; i < 214; i++)
            /*if (titre_flashtris_blanc.s_ptr[j*214+i] != 0)*/
            if (getpixel_xy_sprite(&titre_flashtris_blanc, i, j) != 0)
                /*titre_flashtris_blanc.s_ptr[j*214+i] = 15;*/
                putpixel_xy_sprite(&titre_flashtris_blanc, i, j, 15);
    getsprite(VSCR_VSCREEN, 0, 82, 217, 12, &copyright);
    getsprite(VSCR_VSCREEN, 75/*92*/, 58, 16, 16, &grillage);
    getsprite(VSCR_VSCREEN, 75/*92*/, 58, 16, 16, &grillage_clair);
    for (i = 0; i < 2; i++)
        getsprite(VSCR_VSCREEN, 121+i*8, 41, 7, 6, &case_vide[i]);
    for (i = 0; i < 6; i++)
        getsprite(VSCR_VSCREEN, 110+(i*9), 65, 7, 6, &case_cochee[i]);

    /* Pour le jeu: */

    /* chargement des briques 8x8 */
    for (i = 0; i < 7; i++)
        getsprite(VSCR_VSCREEN, i*9, 0, 8, 8, &brique[8-TC_MIN][i]);

    /* creation de la brique grise */
    /*brique[8-TC_MIN][7].s_lx = 8;
    brique[8-TC_MIN][7].s_ly = 8;
    brique[8-TC_MIN][7].s_ptr = (unsigned char *)ftris_malloc(8*8, "a brix");*/
    getsprite(VSCR_VSCREEN, 0, 0, 8, 8, &brique[8-TC_MIN][7]);
    putpixel_ofs_sprite(&brique[8-TC_MIN][7], 0, 21);       /* coin gris superieur gauche */
    putpixel_ofs_sprite(&brique[8-TC_MIN][7], 7, 23);       /* coin gris superieur droit  */
    putpixel_ofs_sprite(&brique[8-TC_MIN][7], 56, 23);      /* coin gris inferieur gauche */
    putpixel_ofs_sprite(&brique[8-TC_MIN][7], 63, 26);      /* coin gris inferieur droit  */
    for (i = 0; i < 6; i++)
    {
        /*memset(&brique[8-TC_MIN][7].s_ptr[1], 22, 6);*/   /* bord gris haut */
        putpixel_ofs_sprite(&brique[8-TC_MIN][7], i+1, 22);
        /*memset(&brique[8-TC_MIN][7].s_ptr[57], 22, 6);*/  /* bord gris bas */
        putpixel_ofs_sprite(&brique[8-TC_MIN][7], i+57, 25);
    }
    for (i = 1; i < 7; i++)
    {
        putpixel_ofs_sprite(&brique[8-TC_MIN][7], i*8, 22);     /* bord gris gauche */
        putpixel_ofs_sprite(&brique[8-TC_MIN][7], i*8+7, 25);   /* bord gris droit  */
        /*memset(&brique[8-TC_MIN][7].s_ptr[i*8+1], 24, 6);*/   /* milieu gris */
        for (j = 0; j < 6; j++)
            putpixel_ofs_sprite(&brique[8-TC_MIN][7], i*8+1+j, 24);
    }

    /* changement des couleurs des briques marron et violet a cause de la */
    /* palette des flames du menu                                         */
    putpixel_ofs_sprite(&brique[8-TC_MIN][2], 0, 240);     /* coin marron superieur gauche */
    putpixel_ofs_sprite(&brique[8-TC_MIN][2], 7, 242);     /* coin marron superieur droit  */
    putpixel_ofs_sprite(&brique[8-TC_MIN][2], 56, 242);    /* coin marron inferieur gauche */
    putpixel_ofs_sprite(&brique[8-TC_MIN][2], 63, 245);    /* coin marron inferieur droit  */
    for (i = 0; i < 6; i++)
    {
        /*memset(&brique[8-TC_MIN][2].s_ptr[1], 241, 6);*/  /* bord marron haut */
        putpixel_ofs_sprite(&brique[8-TC_MIN][2], i+1, 241);
        /*memset(&brique[8-TC_MIN][2].s_ptr[57],244, 6);*/  /* bord marron bas  */
        putpixel_ofs_sprite(&brique[8-TC_MIN][2], i+57, 244);
    }
    putpixel_ofs_sprite(&brique[8-TC_MIN][6], 0, 246);      /* coin violet superieur gauche */
    putpixel_ofs_sprite(&brique[8-TC_MIN][6], 7, 248);      /* coin violet superieur droit  */
    putpixel_ofs_sprite(&brique[8-TC_MIN][6], 56, 248);     /* coin violet inferieur gauche */
    putpixel_ofs_sprite(&brique[8-TC_MIN][6], 63, 251);     /* coin violet inferieur droit  */
    for (i = 0; i < 6; i++)
    {
        /*memset(&brique[8-TC_MIN][6].s_ptr[1], 247, 6);*/  /* bord violet haut */
        putpixel_ofs_sprite(&brique[8-TC_MIN][6], i+1, 247);
        /*memset(&brique[8-TC_MIN][6].s_ptr[57], 250, 6);*/ /* bord violet bas  */
        putpixel_ofs_sprite(&brique[8-TC_MIN][6], i+57, 250);
    }
    for (i = 1; i < 7; i++)
    {
        putpixel_ofs_sprite(&brique[8-TC_MIN][2], i*8, 241);    /* bord marron gauche */
        putpixel_ofs_sprite(&brique[8-TC_MIN][2], i*8+7, 244);  /* bord marron droit  */
        for (j = 0; j < 6; j++)
            /*memset(&brique[8-TC_MIN][2].s_ptr[i*8+1], 243, 6);*/  /* milieu marron */
            putpixel_ofs_sprite(&brique[8-TC_MIN][2], i*8+1+j, 243);
        putpixel_ofs_sprite(&brique[8-TC_MIN][6], i*8, 247);        /* bord violet gauche */
        putpixel_ofs_sprite(&brique[8-TC_MIN][6], i*8+7, 250);      /* bord violet droit  */
        for (j = 0; j < 6; j++)
            /*memset(&brique[8-TC_MIN][6].s_ptr[i*8+1], 249, 6);*/  /* milieu violet */
            putpixel_ofs_sprite(&brique[8-TC_MIN][6], i*8+1+j, 249);
    }

    /* creation des briques de taille TC_MIN --> TC_MAX (sauf 8 !) */
    for (i = 2; i <= TC_MAX; i++)
    {
        k = i-TC_MIN;
        for (j = 0; j < 8; j++)
        {
            coul[0] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 0);     /* coin superieur gauche */
            coul[1] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 7);     /* coin superieur droit  */
            coul[2] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 7*8);   /* coin inferieur gauche */
            coul[3] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 8*8-1); /* coin inferieur droit  */
            coul[4] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 1);     /* bord haut             */
            coul[5] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 7*8+1); /* bord bas              */
            coul[6] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 8);     /* bord gauche           */
            coul[7] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 15);    /* bord droit            */
            coul[8] = getpixel_ofs_sprite(&brique[8-TC_MIN][j], 9);     /* interieur             */

            if (i != 8)
            {
                /*brique[k][j].s_lx = i;
                brique[k][j].s_ly = i;
                brique[k][j].s_ptr = (unsigned char *)ftris_malloc(i*i, "a brix");*/
                getsprite(VSCR_VSCREEN, 0, 0, i, i, &brique[k][j]);
                /* coins */
                putpixel_ofs_sprite(&brique[k][j], 0, coul[0]);
                putpixel_ofs_sprite(&brique[k][j], i-1, coul[1]);
                putpixel_ofs_sprite(&brique[k][j], (i-1)*i, coul[2]);
                putpixel_ofs_sprite(&brique[k][j], i*i-1, coul[3]);
                /* bords */
                for (m = 1; m < i-1; m++)
                {
                    /* bords haut et bas */
                    putpixel_ofs_sprite(&brique[k][j], m, coul[4]);
                    putpixel_ofs_sprite(&brique[k][j], (i-1)*i+m, coul[5]);
                    /* bords gauche et droit */
                    putpixel_ofs_sprite(&brique[k][j], m*i, coul[6]);
                    putpixel_ofs_sprite(&brique[k][j], (m+1)*i-1, coul[7]);
                }
                /* interieur */
                for (m = 1; m < i-1; m++)
                    for (n = 1; n < i-1; n++)
                        putpixel_ofs_sprite(&brique[k][j], m*i+n, coul[8]);
            }
        }
    }
    /* fabrique les briques 1x1 (!) */
    for (i = 0; i < 7; i++)
    {
        /*brique[0][i].s_lx = 1;
        brique[0][i].s_ly = 1;
        brique[0][i].s_ptr = (unsigned char *)ftris_malloc(1, "a brix");*/
        getsprite(VSCR_VSCREEN, 0, 0, 1, 1, &brique[0][i]);
        putpixel_ofs_sprite(&brique[0][i], 0,
            getpixel_ofs_sprite(&brique[8-TC_MIN][i], 9));
    }

    /*for (i = 0; i < 7; i++)
        getsprite(VSCR_VSCREEN, 147+i*4, 0, 3, 3, &brique_tiny[i]);*/

    for (i = 0; i < NB_TC; i++)
        getsprite(VSCR_VSCREEN, 175+i*8, 0, TC_MAX-i, TC_MAX-i,
            &explosion[TC_MAX-TC_MIN-i]);

    j = 1;
    for (i = 0; i < NB_TC; i++)
    {
        getsprite(VSCR_VSCREEN, j, 80,
            (TC_MAX-i)*2, (TC_MAX-i)*2, &bombe[TC_MAX-TC_MIN-i][0]);
        getsprite(VSCR_VSCREEN, j+((TC_MAX-i)*2)+1, 80,
            (TC_MAX-i)*2, (TC_MAX-i)*2, &bombe[TC_MAX-TC_MIN-i][1]);
        j += (TC_MAX-i)*4+2;
    }

    /* bonus */
    for (i = 0; i < 5; i++)
        getsprite(VSCR_VSCREEN, 176+i*6, 11, 5-i, 5-i, &brix_balle[4-i]);
    for (i = 0; i < 5; i++)
        getsprite(VSCR_VSCREEN, 176+i*17, 18, 16-i*2, 5, &brix_raquette[4-i]);
    for (i = 0; i < 5; i++)
        getsprite(VSCR_VSCREEN, 205+i*6, 11, 5-i, 5-i, &brix_missile[4-i]);
}

/*
 * free_gfx: libere la memoire utilise pour les graphismes
 */

void free_gfx()
{
    int     i, j;

    for (i = 0; i < NB_TC; i++)
    {
        for (j = 0; j < 7; j++)
        {
            #if !defined(MSDOS) && !defined(CYGWIN)
            if (X_Window)
                XDestroyImage(brique[i][j].s_ximage);
            #endif
            free(brique[i][j].s_ptr);
            /*free(brique_menu[i][j].s_ptr);*/
        }
        #if !defined(MSDOS) && !defined(CYGWIN)
        if (X_Window)
            XDestroyImage(explosion[i].s_ximage);
        #endif
        free(explosion[i].s_ptr);
    }
    for (j = 0; j < 15; j++)
        for (i = 0; i < 7; i++)
        {
            #if !defined(MSDOS) && !defined(CYGWIN)
            if (X_Window)
                XDestroyImage(tube[j][i].s_ximage);
            #endif
            free(tube[j][i].s_ptr);
        }
}

/*
 * main: FlashTris proprement dit: tout commence la !!!
 */

int main(int argc, char *argv[])
{
    struct timeval  tv;
    struct timezone tz;

    #if !defined(MSDOS) && !defined(CYGWIN)
    detect_X_Window();
    #endif
    traite_options_immediates(argc, argv);

    if (!silencieux)
        printf("Running FlashTris....... " VERSION " - " DATE_EN_LONG "\n");
    detecte_systeme();

    charge_config();
    traite_options(argc, argv);

    gettimeofday(&tv, &tz);
    srand(tv.tv_usec*tv.tv_sec);
    strcpy(argv0, argv[0]);

    /*srand((unsigned)(time(NULL)));*/

    #if defined(MSDOS) || defined(CYGWIN)
    /*for (i = 0; i < strlen(argv0); i++)
        if (argv0[i] == '/')
            argv0[i] = '\\';*/
    #endif

    /*printf("argv0 = %s\n", argv0);*/
    /*return 0;*/

    init_sb16();
    music_jouee = NO_MUSIC;
    make_shuffle();
    volume = volume_config;
    if (!silencieux)
    {
        if (no_game)
            printf("[-- !!! DEBUG MODE !!! --]\n");
        else
            printf("[--Launching game--]\n");
    }
    switch (init_grafx(nbx, nby))
    {
        case INIT_GRAFX_ERR_MEMORY:
            ftris_error(MSG_ERROR, NO_BUG, CLOSE_SB16, STOP_PROG,
                "not enough memory for graphics buffers");
            break;
        case INIT_GRAFX_ERR_MODE:
            ftris_error(MSG_ERROR, NO_BUG, CLOSE_SB16, STOP_PROG,
                "unable to activate graphics mode");
            break;
    }
    if (!no_game)
    {
        init_clavier();
        if (!no_intro)
        {
            presentation_fli();
            presentation_images();
        }
        load_gfx();
        menu();
        fin_clavier();
        free_gfx();
    }
    close_grafx();
    sauve_config();
    close_sb16();
    return 0;
}
