/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== menu.c: menu pour FlashTris
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/



/* VSCR_MENU     : utilise pour remettre le fond derriere le scrolling, les options, ... */
/* VSCR_AUTRES   : fond du menu                                                          */
/* VSCR_AUTRES+1 : fond du jeu                                                           */
/* VSCR_AUTRES+2 : fond du jeu assombrit (pour dessiner l'interieur des aires de jeu     */
/*                 de l'ecran de preview)                                                */
/* VSCR_AUTRES+3 : utilise pour assombrir la liste de choix et les bulles                */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifndef MSDOS
    #include <unistd.h>
    #include <vga.h>
    #include <vgakeyboard.h>
#endif

#include "ftris.h"
#include "menu.h"
#include "menu_gfx.h"
#include "menu_tst.h"
#include "video.h"
#include "game.h"
#include "bonus.h"
#include "netftris.h"
#include "about.h"
#include "netftris.h"
#include "effet.h"
#include "./module/mod.h"
#include "key.h"


int     quitte_flashtris;
int     quitte_rapide;

int     coul_fond_bouton[12] = {  53, /* rouge-bleu              */
                                  61, /* orange                  */
                                  75, /* jaune                   */
                                 106, /* vert                    */
                                 123, /* bleu-cyan               */
                                 133, /* bleu                    */
                                 141, /* autre bleu              */
                                 170, /* violet fonce            */
                                 187, /* violet                  */
                                 237, /* vert clair/jaune/orange */
                                 242, /* bleu ciel/vert clair    */
                                 250, /* rose/bleu               */ };


unsigned char   pal_ftris[768]; /* palette avec les flames et les bonnes     */
                                /* couleurs pour les carres marron et violet */

int             langue;         /* langue du menu et du jeu                  */
int             clavier;        /* type de clavier (Azerty ou Qwerty)        */

int             fond_menu;      /* numero de l'image de fond du menu         */

int             tab_couleur_tubes[NB_COUL_TUBES] = { 0, 1, 5, 7, 8, 9, 10, 12 };
int             couleur_tubes;

int             couleur_cases_cochees;

int             flam_x1, flam_y1, flam_x2, flam_y2, flam_largeur, flam_hauteur;
int             flam_taille_image, flam_coul, flam_nb_coul;
unsigned char   *flam_src, *flam_dest;
t_sprite        *flam_image, flam_a_afficher;
t_sprite        flam_copyright;
/* compteurs pour apparition soudaine des flames */
int             flam_cptr, flam_eclair;
int             flam_affichees;
int             flam_affichables;   /* vaut 0 si "advanced" sur menu du haut */

int             bulle_affichee;
int             bulle_cptr;         /* pour faire afficher une bulle au bout d'un certain temps */
int             bulle_duree;        /* pour faire durer un certain temps une bulle affichee     */
int             bulle_x1, bulle_y1, bulle_x2, bulle_y2;
t_sprite        bulle_fond;

int             compteur_palette;

int             compteur_clignote;  /* pour faire clignoter "PAUSE" quand le jeu est en pause */
                                    /* ou "NETWORK" si le reseau est active                   */
                                    /* ou le curseur en mode "edition chaine"                 */

int             pos_menu, pos_advanced, pos_barre;
int             save_pos_barre[4][2], save_advanced[4];
int             tab_cptr;

int             titre_en_flames;
int             about_scrolling;
int             barres_samples;
int             bulles;
/*int             fast_preview;*/

int             barsmp_x[3][4] = { { 50, 54, 58, 62 },
                                   { 45, 52, 59, 66 },
                                   { 40, 50, 60, 70 } };
int             barsmp_larg[3] = { 2, 4, 6 };
int             barsmp_haut[3] = { 9, 12, 15 };
int             barsmp_coul[3] = { 7, 5, 4 };       /* multiplicateur de couleur */

int             pos_musique;    /* position dans la musique                                     */

int             pv_tc_piece;    /* taille d'un carre des pieces de la preview                   */
int             pv_tc_next;     /* taille d'un carre de la piece suivante                       */
int             pv_tc_next2;    /* taille d'un carre de la 2eme piece suivante                  */
int             pv_larg_aire;   /* largeur d'une aire de jeu de la preview                      */
int             pv_haut_aire;   /* hauteur d'une aire de jeu de la preview                      */
int             pv_x1[NBJ_MAX]; /* abscice du debut de l'aire d'un joueur sur la preview        */
int             pv_y1[NBJ_MAX]; /* ordonnee du debut de l'aire d'un joueur sur la preview       */
int             pv_cptr_tombe;  /* compteur pour ralentir les pieces qui tombent sur la preview */

int             pv_nb_lignes;   /* nombre de lignes de textes affichees sur la preview          */
int             pv_texte_deb;   /* premiere ligne affichee sur la preview                       */
unsigned char   *pv_texte[MAX_TEXTE_PREVIEW]; /* texte affiche sur la preview                   */

int             liste_choix;                /* vaut 1 si une liste de choix est affichee pour une option */
int             liste_choix_cptr;           /* compteur pour effacer la liste de choix                   */
int             liste_choix_pos;            /* position de la barre dans la liste de choix               */
int             liste_choix_nb;             /* nombre de choix dans la liste                             */
int             liste_choix_x1;             /* coordonnees de l'aire de la liste de choix                */
int             liste_choix_y1;             /*    ...                                                    */
int             liste_choix_x2;             /*    ...                                                    */
int             liste_choix_y2;             /*    ...                                                    */
int             liste_choix_x[NB_CHOIX_MAX];/* abscisse de chaque choix                                  */
int             liste_choix_y[NB_CHOIX_MAX];/* ordonnee de chaque choix                                  */
int             liste_choix_actif[NB_CHOIX_MAX];    /* = 1 si le choix peut etre selectionne (sinon il est "grise") */
unsigned char   *liste_choix_lib[NB_CHOIX_MAX];/* pointeur vers les libelles des choix                   */
t_sprite        liste_choix_fond;           /* pour sauver le fond avant d'afficher la liste de choix    */

int             aide_affichee;              /* = 1 si l'aide est affichee                                */
int             aide_x1, aide_y1;           /* position dans l'aide (scroll)                             */

int             pieces_editor;              /* = 1 si on est dans le "pieces editor"                     */
int             editor_pos;                 /* position carre de selection                               */
int             editor_piece[4];            /* piece en cours d'edition (dans les diffrentes rotations)  */

int             redefine_keys;              /* = 1 si on est dans le "redefine keys"                     */

int             edition_chaine;             /* = 1 si on est en train d'editer une chaine                */
int             edition_chaine_x1;          /* coordonnees de la fenetre                                 */
int             edition_chaine_y1;          /*     d'edition de la chaine                                */
int             edition_chaine_x2;
int             edition_chaine_y2;
int             edition_chaine_x_curseur;   /* position du curseur clignotant                            */
unsigned char   edition_chaine_defaut[100]; /* contient la chaine par defaut (valeur initiale)           */
unsigned char   edition_chaine_editee[100]; /* chaine en cours d'edition                                 */
int             edition_chaine_max;         /* longueur maxi de la chaine editee                         */
unsigned char   edition_touche;             /* touche pressee pendant l'edition                          */
t_sprite        fond_edition;               /* pour sauver le fond avant d'afficher la chaine en edition */

int             pixel_nb;                       /* nombre (voir pixel_nb_tab)                            */
int             pixel_nb_tab[6] =
                { 0, 10, 25, 50, 75, 100 };
int             pixel_nb_a_afficher;            /* calcule par pixels_calcule_nb()                       */
float           pixel_x[NB_PIXELS_MAX];         /* coordonnees des pixels                                */
float           pixel_y[NB_PIXELS_MAX];
float           pixel_inc_x[NB_PIXELS_MAX];     /* accelaration                                          */
float           pixel_inc_y[NB_PIXELS_MAX];
float           pixel_couleur[NB_PIXELS_MAX];   /* couleur des pixels                                    */
float           pixel_inc_coul[NB_PIXELS_MAX];  /* vitesse de changement de couleur                      */
int             pixel_fond[NB_PIXELS_MAX];      /* fond sauvegarde du pixel                              */


/* ========== MOTS EN BRIQUES =============================================== */

int             brik_copyright;     /* 1 si actif, 0 sinon */
unsigned char   *brik_data[2][BRIK_NB_LIG] =
                { { "", "FLASHTRIS", "(c) 1999 - 2001", VERSION, DATE_EN_LONG,
                    "Coded by", "FlashCode",
                    "Web :", "flashcode.free.fr", "Have fun !", "" },
                  { "", "FLASHTRIS", "(c) 1999 - 2001", VERSION, DATE_FR_LONG,
                    "Ecrit par", "FlashCode",
                    "Internet :", "flashcode.free.fr", "Amusez-vous !", "" } };
int             brik_coul[BRIK_NB_LIG] = { 0, 246, 246, 246, 246, 95, 95, 136, 136, 64, 0 };
int             brik_time[BRIK_NB_LIG] = { 0, 300, 300, 300, 300, 150, 300, 150, 500, 1000 };
unsigned char   *brik_image;        /* contient l'image avec les briques                  */
t_sprite        *brik_fond;         /* sauvegarde du fond                                 */
int             brik_cptr;          /* compteur de pause (pour avoir le temps de lire...) */
int             brik_no_lig;        /* numero de ligne en cours                           */
int             brik_scroll_y;      /* position du scroll vertical                        */

/* ========================================================================== */

/* **** GENERAL: **** */

unsigned char   *lib_langue[] =
                { "English\0Anglais", "French\0Francais" };

unsigned char   *lib_clavier[] =
                { "Qwerty\0Qwerty", "Azerty\0Azerty" };

unsigned char   *lib_fond[] =
                { "Astronefs\0Astronefs", "Briks\0Briques",
                  "Disco\0Disco", "Dunes\0Dunes", "Leaves\0Feuilles",
                  "Melted\0Melange", "Mud\0Mud", "Neuron\0Neuron",
                  "Rocks\0Rochers", "Whirl\0Whirl" };

unsigned char   *lib_coul_tubes[] =
                { "Forest\0Foret", "Green metal\0Metal vert",
                  "Orange\0Orange", "Old metal\0Vieux metal", "Metal\0Metal",
                  "Blue\0Bleu", "Sky\0Ciel", "Demoniac\0Demoniac" };

unsigned char   *lib_pixels[] =
                { "None\0Rien", "10%\0" "10%", "25%\0" "25%",
                  "50%\0" "50%", "75%\0" "75%", "100%\0" "100%" };

unsigned char   *lib_barres_samples[] =
                { "None\0Rien", "Small\0Petites", "Medium\0Moyennes",
                  "Large\0Larges" };

/* **** GAME: **** */

unsigned char   *lib_game_mode[] =
                { "Classic\0Classique", "Challenge\0Challenge",
                  "Star\0Etoile" };
unsigned char   *bul_game_mode[] =
                { "Classic game\0Jeu classique",
                  "Challenge\0Challenge",
                  /*  */
                  /*"Special star mode !\0Mode special etoile !"*/
                  "!!! NOT IMPLEMENTED !!!\0!!! NON DEVELOPPE !!!" };

unsigned char   *lib_game_team[] =
                { "No\0Non", "Yes\0Oui" };
unsigned char   *bul_game_team[] =
                { "Free for all\0Chacun pour soi",
                  "Cooperative game\0Jeu en cooperatif" };

unsigned char   *lib_difficulte[] =
                /*{ "Slow\0Lent", "Beginner\0Debutant", "Good\0Bon",
                  "Very good\0Tres bon", "Fast\0Rapide",
                  "Very fast\0Tres rapide" };*/
                { "0/5\0" "0/5", "1/5\0" "1/5", "2/5\0" "2/5", "3/5\0" "3/5",
                  "4/5\0" "4/5", "5/5\0" "5/5" };
unsigned char   *bul_difficulte[] =
                { "I'm trisomic\0Je suis trisomique",
                  "What is FlashTris ?\0Qu'est-ce que FlashTris ?",
                  "I'm beginner\0Je debute",
                  "?\0?",
                  "?!!!\0?!!!",
                  "I'll beat you hollow !\0Je vais vous ecraser !" };

unsigned char   *lib_piece_suivante[] =
                { "No\0Non", "1\0" "1", "2\0" "2" };

unsigned char   *lib_hauteur_ini[] =
                { "None\0Rien", "Low\0Bas", "Medium\0Moyen", "High\0Haut",
                  "Very high\0Tres haut" };

unsigned char   *lib_temps[] =
                { "No\0Non", "1 min\0" "1 min", "2 min\0" "2 min",
                  "5 min\0" "5 min", "10 min\0" "10 min" };

unsigned char   *lib_bonus[] =
                { "None\0Aucun", "Random\0Au hasard", "Brix\0Brix",
                  "Nibble\0Nibble", "Tron\0Tron" };

unsigned char   *lib_acceleration[] =
                { "Fall\0Chute", "Fast\0Rapide", "Slow\0Lent",
                  "Very slow\0Tres lent" };

unsigned char   *lib_aire[] =
                { "Normal\0Normale", "Wide\0Large" };

unsigned char   *bul_cheat[] =
                { "No cheat. No.\0Pas de triche. Non.",
                  "Yeah, cheat !\0Yeah, triche !" };

/*unsigned char   *lib_fond_jeu[] =
                { "Empty\0Vide", "Stars\0Etoiles",
                  "Dutch cheese\0Tetes de mort", "Windows\0Fenetres" };*/

/* **** MUSIC: **** */

unsigned char   *lib_music[] =
                { "No music\0Sans musique",
                  "--Random--\0--Au hasard--",
                  "Electric drug\0Electric drug",
                  "Tetris\0Tetris",
                  "Night angels\0Night angels",
                  "12th warrior\0" "12eme guerrier",
                  "Cybernoid 2\0Cybernoid 2",
                  /*"Daria\0Daria",*/
                  "Crystal\0Crystal",
                  "Transformer\0Transformer",
                  "Eye tiger\0Eye tiger",
                  "Fairlight\0Fairlight",
                  "Ultimate\0Ultimate",
                  "Magic lasers\0Lasers magiques",
                  "Speed\0Speed",
                  "Pop5\0Pop5",
                  "Devil's theme\0Devil's theme",
                  "Ice\0Ice",
                  /**/"Ziriax\0Ziriax",
                  /*"Country\0Country",*/
                  "Xmas theme\0Theme de Noel" };

unsigned char   *bul_music[] =
                { "Sad !\0Triste !",
                  "All are good !\0Toutes bien !",
                  "Electric, is'nt it ?\0Electrique, non ?",
                  "The Tetris music !\0La musique de Tetris !",
                  "Designed for game\0Prevue pour le jeu",
                  "12th warrior\0" "12eme guerrier",
                  "Cybernoid 2\0Cybernoid 2",
                  /*"By module's god - Moustik\0Par le dieu des modules - Moustik",*/
                  "Crystalline music\0Musique cristalline",
                  "From Demoniac-Tris\0De Demoniac-Tris",
                  "Eye of the tiger\0L'oeil du tigre",
                  "Dynamic !\0Dynamique !",
                  "From Demoniac-Tris\0De Demoniac-Tris",
                  "Magic lasers\0Lasers magiques",
                  "Nibble's end !\0Fin de nibble !",
                  "Small but funny\0Petite mais amusante",
                  "Designed for menu\0Prevue pour le menu",
                  "From DTris and HTris\0De DTris et HTris",
                  /**/"HellTris theme !\0Theme de HellTris !",
                  /*"Rhythmical country music\0Musique country rythmee"*/
                  "Christmas...\0Noel..." };

/* **** SON: **** */

unsigned char   *lib_sons[] =
                { "Without\0Sans", "Speaker\0Speaker", "SB16+Speak.\0SB16+Speak." };

unsigned char   *lib_port[] =
                { "Auto\0Auto", "200\0" "200", "210\0" "210", "220\0" "220",
                  "230\0" "230", "240\0" "240", "250\0" "250", "260\0" "260",
                  "270\0" "270", "280\0" "280", "290\0" "290" };

unsigned char   *lib_irq[] =
                { "Auto\0Auto", "2\0" "2", "3\0" "3", "5\0" "5", "7\0" "7" };

/* **** RESEAU: **** */

unsigned char   *lib_type_reseau[] =
                /*{ "Demoniac\0Demoniaque", "Teams\0Equipes" };*/
                { "TCP/IP\0TCP/IP", "IPX\0IPX", "Modem\0Modem" };

/* -------------------------------------------------------------------------- */

t_option        opt_general[] =
                { { "*Start game\0*Demarrer", "Start game with current options\0Demarre le jeu avec les options choisies", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_start_game, 1, 0 },
                  { "*Resume\0*Continuer", "Continue started game\0Continue la partie commencee", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_resume_game, 1, 1 },
                  { "*About\0*A propos", "About FlashTris and his author\0A propos de FlashTris et son auteur", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_about, 1, 1 },
                  { "*Help!\0*Aide!", "Menu's keys and hints\0Touches du menus et astuces", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_help, 1, 1 },
                  { "*Advanced...\0*Avance...", "General configuration options\0Options generales de configuration", NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 1, 1 },
                  { "*Quit\0*Quitter",
                    #ifdef MSDOS
                    "Return to Dos/Windows\0Retour au Dos/Windows",
                    #else
                    "Return to Linux\0Retour a Linux",
                    #endif
                    NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 0, 0 } };

t_option        opt_general_adv[] =
                { { "Langage\0Langue", "Language for game and menu\0Langue menu et jeu", &langue, NULL, 0, 1, lib_langue, NULL, NULL, NULL, 1, 1 },
                  { "Keyboard\0Clavier", "Keyboard type\0Type de clavier", &clavier, NULL, 0, 1, lib_clavier, NULL, NULL, NULL, 1, 1 },
                  { "Pipes color\0Coul. tubes", NULL, &couleur_tubes, NULL, 0, NB_COUL_TUBES-1, lib_coul_tubes, NULL, NULL, NULL, 1, 1 },
                  { "Background\0Fond", "Menu's background image\0Image de fond du menu", &fond_menu, NULL, 0, NB_FONDS-1, lib_fond, NULL, NULL, NULL, 1, 1 },
                  { "Burning title\0Titre en feu", "'FlashTris' burning - Pentium only\0'FlashTris' en feu - Pentium seulement", &titre_en_flames, NULL, 0, 1, NULL, NULL, NULL, NULL, 1, 1 },
                  { "Scroll text\0Scrolling texte", "'About' scrolling - Pentium only\0Scrolling 'A propos' - Pentium seulement", &about_scrolling, NULL, 0, 1, NULL, NULL, NULL, NULL, 1, 1 },
                  { "Vertical scroll\0Scrolling vertical", "Copyright scrolling - Pentium only\0Scrolling copyright - Pentium seulement", &brik_copyright, NULL, 0, 1, NULL, NULL, NULL, NULL, 1, 1 },
                  { "Motion pixels\0Pixels animes", "Fast processor only\0Processeur rapide seulement", &pixel_nb, NULL, 0, 5, lib_pixels, NULL, NULL, NULL, 1, 1 },
                  { "Music bars\0Barres musik", "Displays bars on music rythm - Pentium only\0Affiche des barres en rythme avec la musique - Pentium seulement", &barres_samples, NULL, 0, 3, lib_barres_samples, NULL, NULL, NULL, 1, 1 },
                  { "Bubbles\0Bulles", "Display info bubble when an option is modified\0Affiche une bulle d'info quand une option est changee", &bulles, NULL, 0, 1, NULL, NULL, NULL, NULL, 1, 1 },
                  /*{ "Fast preview\0Previsu rapide", "Speed up game image preview\0Accelere la previsualisation de l'image du jeu", &fast_preview, NULL, 0, 1, NULL, NULL, NULL },*/
                  { "Sounds on menu\0Sons pour le menu", NULL, &sons_menu, NULL, 0, 1, NULL, NULL, NULL, NULL, 1, 1 },
                  { "Reserved 1\0Reserve 1", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "Reserved 2\0Reserve 2", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "Reserved 3\0Reserve 3", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "*Return...\0*Retour...", "Return to main menu\0Retour au menu general", NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 } };

t_option        opt_game[] =
                { { "Game\0Jeu", "Game mode\0Mode de jeu", &game_mode, NULL, 0, 2, lib_game_mode, bul_game_mode, verifie_game_mode, grise_game_mode, 1, 0 },
                  { "Team\0Equipe", "Team game\0Jeu en equipe", &game_team, NULL, 0, 1, lib_game_team, bul_game_team, verifie_game_team, grise_game_team, 1, 0 },
                  { "Players\0Joueurs", "Human players\0Joueurs humains", &nbp, NULL, 0, 5, NULL, NULL, verifie_nbp, grise_nbp, 1, 0 },
                  { "F-bots\0F-bots", "Number of computers\0Nombre d'ordinateurs", &nbc, NULL, 0, 10, NULL, NULL, verifie_nbc, grise_nbc, 1, 0 },
                  { "Bots level\0Niveau ordi", "Computer level\0Niveau de l'ordinateur", &difficulte, NULL, 0, 5, lib_difficulte, bul_difficulte, NULL, grise_difficulte, 1, 1 },
                  { "Same pieces\0Memes pieces", "Same order of pieces\0Meme ordre de pieces", &same_pieces, NULL, 0, 1, NULL, NULL, NULL, grise_same_pieces, 1, 0 },
                  { "Handicap\0Handicap", "Start height\0Hauteur initiale", &hauteur_ini, NULL, 0, 4, lib_hauteur_ini, NULL, NULL, grise_hauteur_ini, 1, 0 },
                  /*{ "Square\0Carre", NULL, &tc, NULL, 2, 12, NULL, NULL },*/
                  { "Statistics\0Statistiques", "Stats about pieces\0Stats sur les pieces", &stats, NULL, 0, 1, NULL, NULL, verifie_stats, grise_stats, 1, 0 },
                  { "Time\0Temps", "Time limit\0Limite de temps", &time_limite, NULL, 0, 4, lib_temps, NULL, NULL, grise_time, 1, 0 },
                  { "View next\0Piece suivante", "Displays next piece\0Affiche piece suiv.", &view_next, NULL, 0, 2, lib_piece_suivante, NULL, NULL, NULL, 1, 0 },
                  { "Bonus\0Bonus", "Bonus levels during game\0Niveaux bonus dans le jeu", &bonus_level, NULL, 0, NB_BONUS+1, lib_bonus, NULL, verifie_bonus_levels, grise_bonus_levels, 1, 1 },
                  { "*Advanced...\0*Avance...", "Advanced game options\0Options avancees du jeu", NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 } };

t_option        opt_game_adv[] =
                { /*{ "Fast game\0Jeu rapide", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL },*/
                  { "Eccentric\0Pieces bizarres", "Eccentric pieces\0Pieces excentriques", &eccentric, NULL, 0, 1, NULL, NULL, verifie_eccentric, grise_eccentric, 1, 1 },
                  { "Status\0Statut", "Game infos\0Infos jeu", &status_jeu, NULL, 0, 1, NULL, NULL, NULL, NULL, 1, 0 },
                  { "Window msg\0Fenetre msg", "Window for messages\0Fenetre de messages", &window_msg, NULL, 0, 1, NULL, NULL, NULL, grise_window_msg, 1, 0 },
                  { "Acceler.\0Acceler.", NULL, &acceler, NULL, 0, 3, lib_acceleration, NULL, NULL, NULL, 1, 1 },
                  { "Game area\0Aire de jeu", "Size of game area\0Taille de l'aire de jeu", &aire_de_jeu, NULL, 0, 1, lib_aire, NULL, NULL, grise_aire, 1, 0 },
                  { "Team 1\0Equipe 1", "Players in team 1\0Joueurs en equipe 1", &nbj_team[0], NULL, 0, 14, NULL, NULL, verifie_team1, NULL, 1, 0 },
                  { "Team 2\0Equipe 2", "Players in team 2\0Joueurs en equipe 2", &nbj_team[1], NULL, 0, 14, NULL, NULL, verifie_team2, NULL, 1, 0 },
                  /*{ "Team 3\0Equipe 3", "Players in team 3\0Joueurs en equipe 3", &team[2], NULL, 0, 14, NULL, NULL, verifie_team3, NULL, 1, 0 },*/
                  { "Backgrnd\0Fond", NULL, &fond_jeu, NULL, 0, NB_FONDS-1, lib_fond, NULL, NULL, NULL, 1, 0 },
                  { "Cheat\0Cheat", "Cheat codes...\0Mode tricheur...", &cheat, NULL, 0, 1, NULL, bul_cheat, NULL, grise_cheat, 1, 1 },
                  { "*Pieces editor\0*Editeur de pieces", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, grise_pieces_editor, 1, 0 },
                  { "*Redefine keys\0*Redefinir touches", "Redefine game keys\0Redefinir les touches du jeu", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_redefine_keys, 1, 1 },
                  { "*Return...\0*Retour...", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 } };

t_option        opt_sound[] =
                { { "Menu\0Menu", "Demoniac menu's music\0Musique demoniaque du menu", &music_menu, NULL, -1, NB_MUSIC, lib_music, bul_music, NULL, grise_musique_menu, 1, 0 },
                  { "Game\0Jeu", "Demoniac game's music\0Musique demoniaque du jeu", &music_jeu, NULL, -1, NB_MUSIC, lib_music, bul_music, NULL, grise_musique_jeu, 1, 1 },
                  { "Sound FX\0Bruitages", NULL, &sons, NULL, 0, 2, lib_sons, NULL, NULL, NULL, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 } };

t_option        opt_sound_adv[] =
                { { "*Detect soundcard\0*Detecter carte son", "Detect soundcard\0Detecte la carte son", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_detect_sb16, 1, 0 },
                  { "Sb16 port\0Port Sb16", "Forces Sb16 port\0Force le port de la Sb16", &force_port, NULL, 0, 10, lib_port, NULL, NULL, grise_port, 1, 1 },
                  { "Sb16 Irq\0Irq Sb16", "Forces Sb16 Irq\0Force l'Irq de la Sb16", &force_irq, NULL, 0, 4, lib_irq, NULL, NULL, grise_irq, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 } };

t_option        opt_network[] =
                { { "*Create game\0*Creer partie", "Create a game (master)\0Creer partie (maitre)", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_create_game, 1, 0 },
                  { "*Join game\0*Joindre partie", "Join a game (slave)\0Joindre partie (esclave)", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_join_game, 1, 0 },
                  { "*Cancel net\0*Annuler reseau", "Cancel network game\0Annule la partie reseau", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_cancel_net, 1, 0 },
                  #ifdef MSDOS
                  { "Name\0Nom", "Computer or player name\0Nom du joueur ou ordinateur", NULL, net_nom, 0, 10, NULL, NULL, NULL, grise_net_name, 1, 0 },
                  #else
                  { "Name\0Nom", "Computer or player name (default: Un*x user)\0Nom du joueur ou ordinateur (par defaut: utilisateur Un*x)", NULL, net_nom, 0, 10, NULL, NULL, NULL, grise_net_name, 1, 0 },
                  #endif
                  { "Net\0reseau", "Type of network\0Type de reseau", &net_type, NULL, 0, 2, lib_type_reseau, NULL, verifie_type_reseau, grise_type_reseau, 1, 0 },
                  /*{ "Type\0Type", "Type of network game\0Type de jeu reseau", &net_type, NULL, 0, 1, lib_type_reseau, NULL, NULL, NULL, 1, 0 },*/
                  /*{ "NetDeath\0Reseau mortel", "Each vs each\0Chacun pour soi", &net_death, NULL, 0, 1, NULL, NULL, NULL, NULL, 1, 0 },*/
                  { "Server\0Serveur", "Name or TCP/IP address\0Nom ou adresse TCP/IP", NULL, net_server, 0, 50, NULL, NULL, NULL, grise_net_server, 1, 0 },
                  { "Max players\0Max joueurs", NULL, &net_nbj_max, NULL, 2, NET_NBJ_MAX, NULL, NULL, NULL, grise_net_nbj_max, 1, 0 },
                  { "Allow F-bots\0Autoriser F-bots", "Allow PC with F-bot(s)\0Autoriser les F-bot(s)", &net_allow_bots, NULL, 0, 1, NULL, NULL, NULL, grise_net_allow_bots, 1, 0 },
                  { "Bonus\0Bonus", "Not implemented !\0Non developpe !", &net_bonus_level, NULL, 0, NB_BONUS+1, lib_bonus, NULL, NULL, grise_net_bonus_levels, 1, 0 },
                  { "Same pieces\0Memes pieces", "Not implemented !\0Non developpe !", &net_same_pieces, NULL, 0, 1, NULL, NULL, NULL, grise_net_same_pieces, 1, 0 },
                  { "*Advanced...\0*Avance...", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 } };

t_option        opt_network_adv[] =
                { { "View other\0Voir autres", "Not implemented !\0Non developpe !"/*"Display other players\0Affiche autres joueurs"*/, &net_view_other, NULL, 0, 1, NULL, NULL, NULL, grise_net_view_other, 1, 0 },
                  { "Chat\0Dialogue", "Not implemented !\0Non developpe !", &net_chat, NULL, 0, 1, NULL, NULL, NULL, grise_net_chat, 1, 0 },
                  { "Teams???\0Equipes???", "Not implemented !\0Non developpe !", NULL, NULL, 0, 0, NULL, NULL, NULL, grise_net_teams, 1, 0 },
                  { "Port\0Port", "Server port\0Port du serveur", &net_port_serveur, NULL, 1000, 9999, NULL, NULL, NULL, NULL, 1, 0 },
                  { "Reserved 1\0Reserve 1", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "Reserved 2\0Reserve 2", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "Reserved 3\0Reserve 3", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "Reserved 4\0Reserve 4", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "Reserved 5\0Reserve 5", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "Reserved 6\0Reserve 6", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 },
                  { "*Return...\0*Retour...", NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 1, 1 },
                  { NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0 } };

t_option        *ptr_menus[4][2] =
                { { opt_general, opt_general_adv },
                  { opt_game, opt_game_adv },
                  { opt_sound, opt_sound_adv },
                  { opt_network, opt_network_adv } };

int             touche_opt_suiv[4][2] =
                { { SCANCODE_CURSORBLOCKRIGHT, SCANCODE_CURSORBLOCKDOWN },
                  { SCANCODE_CURSORBLOCKDOWN, SCANCODE_CURSORBLOCKDOWN },
                  { SCANCODE_CURSORBLOCKDOWN, SCANCODE_CURSORBLOCKDOWN },
                  { SCANCODE_CURSORBLOCKDOWN, SCANCODE_CURSORBLOCKDOWN } };

int             touche_opt_prec[4][2] =
                { { SCANCODE_CURSORBLOCKLEFT, SCANCODE_CURSORBLOCKUP },
                  { SCANCODE_CURSORBLOCKUP, SCANCODE_CURSORBLOCKUP },
                  { SCANCODE_CURSORBLOCKUP, SCANCODE_CURSORBLOCKUP },
                  { SCANCODE_CURSORBLOCKUP, SCANCODE_CURSORBLOCKUP } };

int             nb_options[4][2];           /* nombre d'options par menu                     */

int             pos_option[4][2][15][2];    /* coordonnees des options                       */
int             largeur_option[4][2][15];   /* largeur des options                           */
int             largeur_option_reelle[4][2][15];   /* largeur reelle (plus petite si bouton) */

/* ========== SCROLLING ===================================================== */

unsigned char   *texte_scrolling[2] =
                { "                                "
                  "FlashTris " VERSION " (c) " DATE_EN_LONG
                  " by FlashCode (Sebastien HELLEU)   Version for " OS
                  " (available for " AUTRES_OS ")           "
                  "           > Short help:  [TAB] Next menu     "
                  "[A] Advanced menu     [Enter] Select     "
                  "[Arrows] Next/previous choice     "
                  "[Space] Check/uncheck     "
                  "[F1/F2] Help on current option     "
                  "[PgUp,PgDn,Home] Fastly move bar     "
                  "[Ctrl+Esc] Quick exit"
                  "           > Button 'HELP': extended help"
                  "           > Button 'ABOUT': credits on FlashTris"
                  "           > 'FTRIS -?': command line options"
                  "                 >>> For any question or suggestion, send an "
                  "e-mail to: " EMAIL "  or go to my web page: " SITE_WEB
                  "                   Thanks for playing FlashTris, have fun !!!"
                  "............"
                  "                                    ",
                  /* -------------------------------------------------------- */
                  "                                "
                  "FlashTris " VERSION " (c) " DATE_FR_LONG
                  " par FlashCode (Sebastien HELLEU)   Version pour " OS
                  " (disponible pour " AUTRES_OS ")           "
                  "           > Petite aide:  [TAB] Menu suivant     "
                  "[A] Menu avance     [Entree] Selectionner     "
                  "[Fleches] Choix suivant/precedent     "
                  "[Espace] Cocher/decocher     "
                  "[F1/F2] Aide sur l'option selectionnee     "
                  "[PgUp,PgDn,Home] Deplacer rapidement la barre     "
                  "[Ctrl+Echap] Quitter rapidement"
                  "           > Bouton 'AIDE': aide etendue"
                  "           > Bouton 'CREDITS': credits sur FlashTris"
                  "           > 'FTRIS -?': options de ligne de commande"
                  "                 >>> Pour une question ou suggestion, envoyez "
                  "un e-mail a: " EMAIL "  ou sur ma page internet: " SITE_WEB
                  "                   Merci de jouer a FlashTris, amusez-vous bien !!!"
                  "............"
                  "                                    ",
                  };

unsigned char   *image_scroll;
int             scrolltxt_x, scrolltxt_lx_image;
unsigned char   scrolltxt_coul[SCROLLTXT_LARGEUR];
int             scrolltxt_cptr;

/* ========================================================================== */

unsigned char *get_lib_music(int no_music)
{
    if (langue == ANGLAIS)
        return lib_music[no_music+1];
    else
    {
        return lib_music[no_music+1]+strlen(lib_music[no_music+1])+1;
    }
}

/*
 * menu_choix_avec_jeu: grise les options inaccessibles pendant la pause
 */

void menu_choix_avec_jeu()
{
    int     i, j, k;

    for (i = 0; i < 4; i++)
        for (j = 0; j < 2; j++)
            for (k = 0; k < nb_options[i][j]; k++)
            {
                ptr_menus[i][j][k].o_choix_actif = 1;
                if (ptr_menus[i][j][k].o_fonction_grise != NULL)
                    grise_option(ptr_menus[i][j][k].o_fonction_grise);
                ptr_menus[i][j][k].o_choix_actif &= ptr_menus[i][j][k].o_actif_en_pause;
            }
}

/*
 * menu_choix_sans_jeu: active toutes les options sauf "Resume"
 */

void menu_choix_sans_jeu()
{
    int     i, j, k;

    for (i = 0; i < 4; i++)
        for (j = 0; j < 2; j++)
            for (k = 0; k < nb_options[i][j]; k++)
            {
                if (ptr_menus[i][j][k].o_fonction_grise != NULL)
                    grise_option(ptr_menus[i][j][k].o_fonction_grise);
                else
                    if (strncmp(ptr_menus[i][j][k].o_nom, "Reserve", 7) == 0)
                        ptr_menus[i][j][k].o_choix_actif = 0;
                    else
                        ptr_menus[i][j][k].o_choix_actif = 1;
            }
}

/*
 * grise_options_menu: (de)grise les options (in)accessibles d'un menu
 */

void grise_options_menu(int partie_menu)
{
    int     i, adv;

    for (adv = 0; adv < 2; adv++)
    {
        i = 0;
        while (ptr_menus[partie_menu][adv][i].o_nom != NULL)
        {
            if (ptr_menus[partie_menu][adv][i].o_fonction_grise != NULL)
                grise_option(ptr_menus[partie_menu][adv][i].o_fonction_grise);
            i++;
        }
    }
}

/*
 * preview_affichee: renvoie 1 si la preview est affichee
 */

int preview_affichee()
{
    return ( (!aide_affichee) && (!pieces_editor) && (!redefine_keys) );
}

/*
 * affiche_pause_clignote: affiche le mot "PAUSE" qui clignote
 */

void affiche_pause_clignote()
{
    write_xy_c_o(ECRAN_REEL, 132, 96, COUL_FLAMES+10, 4, 27, "P");
    write_xy_c_o(ECRAN_REEL, 144, 96, COUL_FLAMES+10, 4, 27, "A");
    write_xy_c_o(ECRAN_REEL, 156, 96, COUL_FLAMES+10, 4, 27, "U");
    write_xy_c_o(ECRAN_REEL, 168, 96, COUL_FLAMES+10, 4, 27, "S");
    write_xy_c_o(ECRAN_REEL, 180, 96, COUL_FLAMES+10, 4, 27, "E");
}

/*
 * efface_pause_clignote: efface le mot "PAUSE" qui clignote
 */

void efface_pause_clignote()
{
    copy_v2s_xy(VSCR_MENU, 132, 96, 56, 9);
}

/*
 * affiche_network_clignote: affiche le mot "NETWORK" (ou "RESEAU") qui clignote
 */

void affiche_network_clignote()
{
    if (langue == ANGLAIS)
    {
        write_xy_c_o(ECRAN_REEL, 120, 96, COUL_FLAMES+10, 4, 27, "N");
        write_xy_c_o(ECRAN_REEL, 132, 96, COUL_FLAMES+10, 4, 27, "E");
        write_xy_c_o(ECRAN_REEL, 144, 96, COUL_FLAMES+10, 4, 27, "T");
        write_xy_c_o(ECRAN_REEL, 156, 96, COUL_FLAMES+10, 4, 27, "W");
        write_xy_c_o(ECRAN_REEL, 168, 96, COUL_FLAMES+10, 4, 27, "O");
        write_xy_c_o(ECRAN_REEL, 180, 96, COUL_FLAMES+10, 4, 27, "R");
        write_xy_c_o(ECRAN_REEL, 192, 96, COUL_FLAMES+10, 4, 27, "K");
    }
    else
    {
        write_xy_c_o(ECRAN_REEL, 126, 96, COUL_FLAMES+10, 4, 27, "R");
        write_xy_c_o(ECRAN_REEL, 138, 96, COUL_FLAMES+10, 4, 27, "E");
        write_xy_c_o(ECRAN_REEL, 150, 96, COUL_FLAMES+10, 4, 27, "S");
        write_xy_c_o(ECRAN_REEL, 162, 96, COUL_FLAMES+10, 4, 27, "E");
        write_xy_c_o(ECRAN_REEL, 174, 96, COUL_FLAMES+10, 4, 27, "A");
        write_xy_c_o(ECRAN_REEL, 186, 96, COUL_FLAMES+10, 4, 27, "U");
    }
}

/*
 * efface_network_clignote: efface le mot "NETWORK" (ou "RESEAU") qui clignote
 */

void efface_network_clignote()
{
    if (langue == ANGLAIS)
        copy_v2s_xy(VSCR_MENU, 120, 96, 80, 9);
    else
        copy_v2s_xy(VSCR_MENU, 126, 96, 68, 9);
}

/*
 * affiche_curseur_clignote: affiche le curseur pour l'edition d'une chaine
 */

void affiche_curseur_clignote()
{
    int     i;

    /*ligne_vertic(ECRAN_REEL, edition_chaine_x_curseur,
        edition_chaine_y1+1, edition_chaine_y1+6, 50);*/
    for (i = 0; i < 6; i++)
        putpixel_ofs(ECRAN_REEL,
            edition_chaine_x_curseur+(edition_chaine_y1+1+i)*scr_nbx, 64+i*2);
}

/*
 * efface_curseur_clignote: efface le curseur pour l'edition d'une chaine
 */

void efface_curseur_clignote()
{
    copy_v2s_xy(VSCR_AUTRES+3, edition_chaine_x_curseur,
        edition_chaine_y1+1, 1, 6);
}

/*
 * affiche_texte_preview: affiche du texte par dessus la preview du jeu
 */

void affiche_texte_preview()
{
    int             i, j, limite;
    unsigned char   chaine[100];

    if (pv_nb_lignes > 0)
    {
        if (pv_texte_deb+10 > pv_nb_lignes-1)
            limite = pv_nb_lignes-pv_texte_deb;
        else
            limite = 10;
        for (i = 0; i < limite; i++)
        {
            strcpy(chaine, pv_texte[pv_texte_deb+i]);
            j = strlen(chaine)-1;
            while ( (text_length(chaine) > 126) && (j >= 0) )
                chaine[j--] = '\0';
            write_xy_s_c_brut(ECRAN_REEL, 98, 62+i*8, 56, 1, chaine);
        }
    }
}

/*
 *  ajoute_texte_preview: ajoute une ligne de texte sur la preview
 *                       si numero < 0, n'affiche pas de numero
 *                       si numero >= 0, affiche le numero + "." + la ligne
 */

void ajoute_texte_preview(int numero, unsigned char *ligne)
{
    unsigned char   chaine[100];

    if (pv_nb_lignes == MAX_TEXTE_PREVIEW)
        ftris_error(MSG_ERROR, BUG, CLOSE_SB16, STOP_PROG,
            "Too much text lines on preview.");

    if (numero >= 0)
        sprintf(chaine, "%d.%s", numero, ligne);
    else
        sprintf(chaine, "%s", ligne);
    pv_texte[pv_nb_lignes] = (unsigned char *)ftris_malloc(strlen(chaine)+1, "preview text");
    strcpy(pv_texte[pv_nb_lignes], chaine);
    pv_nb_lignes++;
}

/*
 * ajoute_texte_preview_nbj: ajoute une ligne de texte sur la preview
 *                           indiquant le nombre de PC connectes au serveur
 */

void ajoute_texte_preview_nbj()
{
    unsigned char   chaine[100];

    if (nb_PC_net > 1)
    {
        if (langue == ANGLAIS)
            sprintf(chaine, "> %d PC connected", nb_PC_net-1);
        else
            sprintf(chaine, "> %d PC connectes", nb_PC_net-1);
        ajoute_texte_preview(-1, chaine);
    }
}

/*
 * efface_texte_preview: efface le texte affiche par dessus la preview du jeu
 */

void efface_texte_preview()
{
    int     i;

    copy_v2s_xy(VSCR_MENU, 96, 60, 128, 80);
    for (i = 0; i < nbj; i++)
        affiche_piece_preview(ECRAN_REEL, i, &piece[i]);
    affiche_pieces_suivantes_preview();
}

/*
 * retire_texte_preview_derniere_ligne: retire la derniere ligne du texte
 *                                      affiche sur la preview
 */

void retire_texte_preview_derniere_ligne()
{
    if (pv_nb_lignes > 0)
    {
        pv_nb_lignes--;
        free(pv_texte[pv_nb_lignes]);
        if ( (pv_texte_deb > 0) && (pv_texte_deb > pv_nb_lignes-1) )
            pv_texte_deb--;
        efface_texte_preview();
        affiche_texte_preview();
    }
}

/*
 * retire_texte_preview_une_ligne: retire une ligne du texte
 *                                 affiche sur la preview
 */

void retire_texte_preview_une_ligne(int no_ligne)
{
    int     i;

    if (pv_nb_lignes > 0)
    {
        free(pv_texte[no_ligne]);
        for (i = no_ligne; i < pv_nb_lignes-1; i++)
        {
            pv_texte[i] = ftris_malloc(strlen(pv_texte[i+1])+1, "preview text");
            strcpy(pv_texte[i], pv_texte[i+1]);
            free(pv_texte[i+1]);
        }
        pv_nb_lignes--;
        if ( (pv_texte_deb > 0) && (pv_texte_deb > pv_nb_lignes-1) )
            pv_texte_deb--;
        efface_texte_preview();
        affiche_texte_preview();
    }
}

/*
 * free_texte_preview: supprime de la memoire (et de l'ecran) le texte sur la preview
 */

void free_texte_preview()
{
    int     i;

    if (pv_nb_lignes > 0)
    {
        efface_texte_preview();
        for (i = 0; i < pv_nb_lignes; i++)
            free(pv_texte[i]);
        pv_nb_lignes = 0;
    }
}

/*
 * bascule_langue: change la langue (anglais/francais) et reaffiche les 4
 *                 parties de menu
 */

void bascule_langue()
{
    int     i;

    pixels_efface();
    pixels_init();
    i = scrolltxt_cptr;
    stop_scroll();
    init_scrolltxt();
    scrolltxt_cptr = i;
    waitretrace();
    affiche_fond_menu(ECRAN_REEL, pos_menu, pos_advanced);
    affiche_partie_menu(ECRAN_REEL, pos_menu, pos_advanced, 1);
    for (i = 0; i < 4; i++)
        if (i != pos_menu)
        {
            waitretrace();
            affiche_fond_menu(ECRAN_REEL, i, save_advanced[i]);
            affiche_partie_menu(ECRAN_REEL, i, save_advanced[i], 0);
        }
    affiche_pos_musique(ECRAN_REEL, 1);
    stop_brik();
    init_brik_image();
    if ( (brik_copyright) && (brik_no_lig > 0) )
        brik_affiche();
}

/*
 * bascule_advanced: bascule le menu du mode normal vers avance et vice-versa
 */

void bascule_advanced(int joue_son)
{
    int     i;

    pixels_efface();
    pixels_init();
    if ( (sb16) && (sons_menu) && (joue_son) )
        SON_BOUGE_BARRE;
    save_pos_barre[pos_menu][pos_advanced] = pos_barre;
    pos_advanced ^= 1;
    pos_barre = save_pos_barre[pos_menu][pos_advanced];
    waitretrace();
    affiche_fond_menu(ECRAN_REEL, pos_menu, pos_advanced);
    affiche_pos_musique(ECRAN_REEL, 1);

    if (pos_menu == 0)
    {
        if (pos_advanced == 0)
        {
            if ( (titre_en_flames) && (flam_affichees) )
                putsprite_tr(&flam_a_afficher, flam_x1, flam_y1);
            else
                putsprite_tr(&titre_flashtris, flam_x1, flam_y1);
        }
        flam_affichables ^= 1;
        if (pos_advanced)
        {
            putsprite(ECRAN_REEL, &tube[tab_couleur_tubes[couleur_tubes]][0], 87, 51);
            putsprite(ECRAN_REEL, &tube[tab_couleur_tubes[couleur_tubes]][6], 224, 51);
            copy_v2v_xy(VSCR_AUTRES, VSCR_MENU, 96, 51, 128, 89);
        }
        else
        {
            affiche_tubes_menu(ECRAN_REEL, tab_couleur_tubes[couleur_tubes]);
            redessine_preview(0, 0);
            for (i = 0; i < nbj; i++)
                affiche_piece_preview(ECRAN_REEL, i, &piece[i]);
        }
    }
    affiche_partie_menu(ECRAN_REEL, pos_menu, pos_advanced, 1);
    pixels_calcule_nb();
}

/*
 * grise_options_et_affiche: (de)grise les optins (in)accessibles d'un menu
 *                           et les affiche si modification de statut
 */

void grise_options_et_affiche(int partie_menu)
{
    int     i, adv, ret;

    for (adv = 0; adv < 2; adv++)
    {
        i = 0;
        while (ptr_menus[partie_menu][adv][i].o_nom != NULL)
        {
            if (ptr_menus[partie_menu][adv][i].o_fonction_grise != NULL)
            {
                ret = grise_option(ptr_menus[partie_menu][adv][i].o_fonction_grise);
                if ( (ret) && (pos_advanced == adv) )
                    affiche_option(ECRAN_REEL, pos_menu, pos_advanced, i, 1, (pos_barre == i), 1);
            }
            i++;
        }
    }
}

/*
 * annule_reseau: annule la connexion reseau
 *                Si envoi_disc = 1, envoi au serveur ou client (menu)
 *                Si envoi_disc = 2, envoi a tous les joueurs (jeu)
 */

void annule_reseau(int envoi_disc, int efface_texte_pv,
                   int reaffiche_menus)
{
    int     i;

    if ( (network) && (envoi_disc > 0) )
    {
        if (envoi_disc == 2)
        {
            for (i = 0; i < nb_PC_net; i++)
                if ( (i != numero_PC_net) && (PC_net[i].adresse != 0) )
                    envoi_disconnect(PC_net[i].adresse, PC_net[i].port);
        }
        else
        {
            if (net_master)
            {
                for (i = 0; i < nb_PC_net; i++)
                    envoi_disconnect(PC_net[i].adresse, PC_net[i].port);
            }
            else
                envoi_disconnect(net_adresse_serveur, net_port_serveur);
        }
    }
    network = 0;
    net_master = 0;
    cptr_net_retry = 0;
    pixels_efface();
    pixels_init();
    efface_network_clignote();
    if (reaffiche_menus)
    {
        grise_options_menu(3);
        if (pos_menu == 3)
            affiche_partie_menu(ECRAN_REEL, 3, pos_advanced, 1);
        else
            affiche_partie_menu(ECRAN_REEL, 3, save_advanced[3], 0);
        grise_options_menu(0);
        if (pos_menu == 0)
            affiche_partie_menu(ECRAN_REEL, 0, pos_advanced, 1);
        else
            affiche_partie_menu(ECRAN_REEL, 0, save_advanced[0], 0);
        grise_options_menu(1);
        if (pos_menu == 1)
            affiche_partie_menu(ECRAN_REEL, 1, pos_advanced, 1);
        else
            affiche_partie_menu(ECRAN_REEL, 1, save_advanced[1], 0);
    }
    if (efface_texte_pv)
        free_texte_preview();
    nb_PC_net = 0;
}

/*
 * start_game: demarre le jeu
 */

void start_game()
{
    int     i;

    if ( (network) && (net_master) )
        envoi_start_game();
    affiche_option(ECRAN_REEL, 0, 0, 0, 1, 0, 2);
    if (network)
        efface_network_clignote();
    free_texte_preview();
    efface_pos_musique(ECRAN_REEL);
    dessine_image_jeu(VSCR_VSCREEN, VSCR_AUTRES+1, VSCR_AUTRES+2, 1, 1);
    make_effect_debut(VSCR_VSCREEN, 1+(rand()%2), 16, VSCR_AUTRES+4);
    boucle_jeu();
    make_effect_fin(16, VSCR_AUTRES+4);
    affiche_pos_musique(ECRAN_REEL, 1);
    if (en_pause)
    {
        pos_menu = 0;
        pos_barre = 1;
        menu_choix_avec_jeu();
        for (i = 0; i < 4; i++)
            if (i == pos_menu)
                affiche_partie_menu(ECRAN_REEL, i, pos_advanced, 1);
            else
                affiche_partie_menu(ECRAN_REEL, i, save_advanced[i], 0);
    }
    else
    {
        niveau = 0;
        menu_choix_sans_jeu();
        for (i = 0; i < 4; i++)
            if (i == pos_menu)
                affiche_partie_menu(ECRAN_REEL, i, pos_advanced, 1);
            else
                affiche_partie_menu(ECRAN_REEL, i, save_advanced[i], 0);
    }
    redessine_preview(1, 1);
    reinit_touches();
    if (network)
        annule_reseau(2, 1, 1);
}

/*
 * resume_game: reprend le jeu apres une pause
 */

void resume_game()
{
    int     i;

    /*memcpy_rapide(vscreen[VSCR_VSCREEN],
        vscreen[VSCR_JEU], (scr_nbx*scr_nby)/4);*/
    efface_pos_musique(ECRAN_REEL);
    copy_v2s_xy(VSCR_MENU, 132, 96, 56, 9); /* efface le mot "PAUSE" */
    copy_v2v(VSCR_JEU, VSCR_VSCREEN);
    make_effect_debut(VSCR_VSCREEN, 1+(rand()%2), 16, VSCR_AUTRES+4);
    boucle_jeu();
    make_effect_fin(16, VSCR_AUTRES+4);
    if (en_pause)
    {
        pos_menu = 0;
        pos_barre = 1;
        menu_choix_avec_jeu();
        for (i = 0; i < 4; i++)
            if (i == pos_menu)
                affiche_partie_menu(ECRAN_REEL, i, pos_advanced, 1);
            else
                affiche_partie_menu(ECRAN_REEL, i, save_advanced[i], 0);
    }
    else
    {
        menu_choix_sans_jeu();
        for (i = 0; i < 4; i++)
            if (i == pos_menu)
                affiche_partie_menu(ECRAN_REEL, i, pos_advanced, 1);
            else
                affiche_partie_menu(ECRAN_REEL, i, save_advanced[i], 0);
    }
    redessine_preview(1, 1);
}

/*
 * action_bouton: execute une action selon le bouton appuye
 */

void action_bouton()
{
    switch (pos_menu)
    {
        case 0:
            switch (pos_advanced)
            {
                /* MENU PRINCIPAL - NORMAL */
                case 0:
                    switch (pos_barre)
                    {
                        case MENU_0_0_START:
                            start_game();
                            break;
                        case MENU_0_0_RESUME:
                            /* resume game */
                            resume_game();
                            break;
                        case MENU_0_0_ABOUT:
                            /* about */
                            about_flashtris();
                            break;
                        case MENU_0_0_HELP:
                            /* help! */
                            pixels_efface();
                            if ( (sb16) && (sons_menu) )
                                SON_BOUGE_BARRE;
                            aide_flashtris();
                            break;
                        case MENU_0_0_ADVANCED:
                            /* advanced */
                            bascule_advanced(1);
                            break;
                        case MENU_0_0_QUIT:
                            /* quit */
                            quitte_flashtris = 1;
                            break;
                    }
                    break;
                /* MENU PRINCIPAL - AVANCE */
                case 1:
                    if (pos_barre == MENU_0_1_RETURN)
                        bascule_advanced(1);
                    break;
            }
            break;
        case 1:
            /* MENU GAME */
            if ( ( (pos_advanced == 0) && (pos_barre == MENU_1_0_ADVANCED) )
                || ( (pos_advanced == 1) && (pos_barre == MENU_1_1_RETURN) ) )
                bascule_advanced(1);
            else
                if (pos_advanced)
                    switch (pos_barre)
                    {
                        case MENU_1_1_PIECES_EDITOR: /* editeur de pieces */
                            if ( (sb16) && (sons_menu) )
                                SON_BOUGE_BARRE;
                            efface_bulle();
                            prepare_pieces_editor();
                            break;
                        case MENU_1_1_REDEFINE_KEYS: /* redifinition des touches */
                            if ( (sb16) && (sons_menu) )
                                SON_BOUGE_BARRE;
                            efface_bulle();
                            prepare_redefine_keys();
                            break;
                    }
            break;
        case 2:
            /* MENU SOUND */
            if ( (pos_advanced == 1) && (pos_barre == MENU_2_1_DETECT_SB16) )
            {
                if (ftris_detect_sb16() == 0)
                {
                    /* carte son trouvee, en avant pour la musique ! */
                    change_music(NULL, 1);
                    affiche_volume(ECRAN_REEL);
                    grise_options_menu(2);
                    affiche_option(ECRAN_REEL, pos_menu, pos_advanced,
                        pos_barre, 1, 1, 0);
                }
            }
            break;
        case 3:
            /* MENU NET */
            if ( ( (pos_advanced == 0) && (pos_barre == MENU_3_0_ADVANCED) )
                || ( (pos_advanced == 1) && (pos_barre == MENU_3_1_RETURN) ) )
                bascule_advanced(1);
            else
                if (pos_advanced)
                {
                }
                else
                {
                    switch (pos_barre)
                    {
                        case MENU_3_0_CREATE_GAME: /* create game */
                            if ( (sb16) && (sons_menu) )
                                SON_BOUGE_BARRE;
                            if ( (!net_allow_bots) && (nbc > 0) )
                            {
                                pixels_efface();
                                pixels_init();
                                free_texte_preview();
                                if (langue == ANGLAIS)
                                    ajoute_texte_preview(-1, "Bots not allowed !");
                                else
                                    ajoute_texte_preview(-1, "Bots interdits !");
                            }
                            else
                                if (get_game_team())
                                {
                                    pixels_efface();
                                    pixels_init();
                                    free_texte_preview();
                                    if (langue == ANGLAIS)
                                    {
                                        ajoute_texte_preview(-1, "Team mode not implemented");
                                        ajoute_texte_preview(-1, "in this version of FlashTris");
                                        ajoute_texte_preview(-1, "Please wait for update...");
                                    }
                                    else
                                    {
                                        ajoute_texte_preview(-1, "Equipes reseau interdites");
                                        ajoute_texte_preview(-1, "dans cette version de FlashTris");
                                        ajoute_texte_preview(-1, "Attendez une mise a jour...");
                                    }
                                }
                                else
                                {
                                    if (net_init() == 0)
                                    {
                                        network = 1;
                                        net_master = 1;
                                        PC_net[0].nbp = nbp;
                                        PC_net[0].nbc = nbc;
                                        PC_net[0].nbj = nbp+nbc;
                                        PC_net[0].adresse = net_adresse_locale;
                                        PC_net[0].port = net_port_local;
                                        strcpy(PC_net[0].net_nom, net_nom);
                                        numero_PC_net = 0;
                                        nb_PC_net = 1;
                                        compteur_clignote = 0;
                                        pixels_efface();
                                        pixels_init();
                                        grise_options_menu(3);
                                        affiche_partie_menu(ECRAN_REEL, 3, 0, 1);
                                        grise_options_menu(0);
                                        affiche_partie_menu(ECRAN_REEL, 0, save_advanced[0], 0);
                                        grise_options_menu(1);
                                        affiche_partie_menu(ECRAN_REEL, 1, save_advanced[1], 0);
                                        free_texte_preview();
                                        if (langue == ANGLAIS)
                                            ajoute_texte_preview(-1, "Waiting for players...");
                                        else
                                            ajoute_texte_preview(-1, "Attente des joueurs...");
                                        ajoute_texte_preview_nbj();
                                    }
                                    else
                                    {
                                        pixels_efface();
                                        pixels_init();
                                        free_texte_preview();
                                        #ifdef MSDOS
                                        if (langue == ANGLAIS)
                                        {
                                            ajoute_texte_preview(-1, "Network not implemented");
                                            ajoute_texte_preview(-1, "  for Dos/Windows");
                                            ajoute_texte_preview(-1, "Please wait for version 0.3");
                                            ajoute_texte_preview(-1, "Thanks.");
                                        }
                                        else
                                        {
                                            ajoute_texte_preview(-1, "Reseau non developpe");
                                            ajoute_texte_preview(-1, "  pour Dos/Windows");
                                            ajoute_texte_preview(-1, "Attendez SVP la version 0.3");
                                            ajoute_texte_preview(-1, "Merci.");
                                        }
                                        #else
                                        if (langue == ANGLAIS)
                                            ajoute_texte_preview(-1, "Unable to init network !");
                                        else
                                            ajoute_texte_preview(-1, "Impossible d'initialiser le reseau !");
                                        #endif
                                    }
                                }
                            break;
                        case MENU_3_0_JOIN_GAME: /* join game */
                            if ( (sb16) && (sons_menu) )
                                SON_BOUGE_BARRE;
                            if (get_game_team())
                            {
                                pixels_efface();
                                pixels_init();
                                free_texte_preview();
                                if (langue == ANGLAIS)
                                {
                                    ajoute_texte_preview(-1, "Team mode not implemented");
                                    ajoute_texte_preview(-1, "in this version of FlashTris");
                                    ajoute_texte_preview(-1, "Please wait for update...");
                                }
                                else
                                {
                                    ajoute_texte_preview(-1, "Equipes reseau interdites");
                                    ajoute_texte_preview(-1, "dans cette version de FlashTris");
                                    ajoute_texte_preview(-1, "Attendez une mise a jour...");
                                }
                            }
                            else
                            {
                                if (net_init() == 0)
                                {
                                    network = 1;
                                    net_master = 0;
                                    compteur_clignote = 0;
                                    pixels_efface();
                                    pixels_init();
                                    grise_options_menu(3);
                                    affiche_partie_menu(ECRAN_REEL, 3, 0, 1);
                                    grise_options_menu(0);
                                    affiche_partie_menu(ECRAN_REEL, 0, save_advanced[0], 0);
                                    grise_options_menu(1);
                                    affiche_partie_menu(ECRAN_REEL, 1, save_advanced[1], 0);
                                    free_texte_preview();
                                    if (langue == ANGLAIS)
                                        ajoute_texte_preview(-1, "Connecting to server...");
                                    else
                                        ajoute_texte_preview(-1, "Connexion au serveur...");
                                    net_connect(net_server);
                                }
                                else
                                {
                                    pixels_efface();
                                    pixels_init();
                                    free_texte_preview();
                                    #ifdef MSDOS
                                    if (langue == ANGLAIS)
                                    {
                                        ajoute_texte_preview(-1, "Network not implemented");
                                        ajoute_texte_preview(-1, "  for Dos/Windows");
                                        ajoute_texte_preview(-1, "Please wait for version 0.3");
                                    }
                                    else
                                    {
                                        ajoute_texte_preview(-1, "Reseau non developpe");
                                        ajoute_texte_preview(-1, "  pour Dos/Windows");
                                        ajoute_texte_preview(-1, "Attendez SVP la version 0.3");
                                    }
                                    #else
                                    if (langue == ANGLAIS)
                                        ajoute_texte_preview(-1, "Unable to init network !");
                                    else
                                        ajoute_texte_preview(-1, "Impossible d'initialiser le reseau !");
                                    #endif
                                }
                            }
                            break;
                        case MENU_3_0_CANCEL_NET: /* cancel net game */
                            if ( (sb16) && (sons_menu) )
                                SON_BOUGE_BARRE;
                            annule_reseau(1, 1, 1);
                            break;
                    }
                }
            break;
    }
}

/*
 * action_modification_option: execute une action selon l'option modifiee
 */

void action_modification_option()
{
    int     i, j;

    switch (pos_menu)
    {
        case 0:
            /* GENERAL */
            if (pos_advanced)
                switch (pos_barre)
                {
                    case MENU_0_1_LANGAGE: /* langue */
                        bascule_langue();
                        break;
                    case MENU_0_1_KEYBOARD: /* clavier */
                        break;
                    case MENU_0_1_PIPES: /* couleur tubes */
                        waitretrace();
                        pixels_efface();
                        pixels_init();
                        affiche_tubes_menu(VSCR_MENU, tab_couleur_tubes[couleur_tubes]);
                        affiche_tubes_menu(ECRAN_REEL, tab_couleur_tubes[couleur_tubes]);
                        break;
                    case MENU_0_1_BACKGROUND: /* fond du menu */
                        load_dat(nom_fond[fond_menu], VSCR_AUTRES);
                        memcpy(palette, pal_ftris, 768);
                        scroll_resauve_fond();
                        /* reaffiche toutes les parties de menu */
                        waitretrace();
                        pixels_efface();
                        pixels_init();
                        affiche_fond_menu(VSCR_MENU, pos_menu, pos_advanced);
                        affiche_fond_menu(ECRAN_REEL, pos_menu, pos_advanced);
                        affiche_partie_menu(ECRAN_REEL, pos_menu, pos_advanced, 1);
                        for (i = 0; i < 4; i++)
                            if (i != pos_menu)
                            {
                                waitretrace();
                                affiche_fond_menu(VSCR_MENU, i, save_advanced[i]);
                                affiche_fond_menu(ECRAN_REEL, i, save_advanced[i]);
                                affiche_partie_menu(ECRAN_REEL, i, save_advanced[i], 0);
                            }
                        affiche_pos_musique(ECRAN_REEL, 1);
                        free(brik_fond->s_ptr);
                        getsprite(VSCR_MENU, BRIK_X, BRIK_Y, BRIK_NBX_AFF, BRIK_NBY_AFF, brik_fond);
                        if ( (brik_copyright) && (brik_no_lig > 0) )
                            brik_affiche();
                        break;
                    case MENU_0_1_BURNING: /* titre en feu */
                        break;
                    case MENU_0_1_SCROLL: /* scrolling texte */
                        if (!about_scrolling)
                        {
                            scroll_restaure_fond();
                            scrolltxt_x = 0;
                        }
                        break;
                    case MENU_0_1_BRIK_COPYRIGHT:   /* copyright en briques */
                        if (brik_copyright)
                        {
                            brik_no_lig = 0;
                            brik_scroll_y = BRIK_HAUT_LIG*2;
                            brik_cptr = (rand()%500)+200;
                        }
                        else
                            brik_efface();
                        break;
                    case MENU_0_1_PIXELS:   /* pixels animes */
                        i = pixel_nb;
                        pixel_nb = 5;
                        pixels_efface();
                        pixels_init();
                        pixel_nb = i;
                        pixels_calcule_nb();
                        break;
                    case MENU_0_1_MUSIC_BARS: /* barres samples */
                        copy_v2s_xy(VSCR_MENU,
                            X_VOLUME+barsmp_x[2][0],
                            Y_VOLUME-1-barsmp_haut[2]-1,
                            barsmp_x[2][3]-barsmp_x[2][0]+barsmp_larg[2],
                            barsmp_haut[2]+2);
                        break;
                    case MENU_0_1_BUBBLES: /* bulles */
                        break;
                    /*fast preview :
                    case 7:
                        redessine_preview(0, 0);
                        break;*/
                    case MENU_0_1_SOUNDS: /* sounds on menu */
                        break;
                }
            break;
        case 1:
            /* GAME */
            if (pos_advanced)
            {
                switch (pos_barre)
                {
                    case MENU_1_1_ECCENTRIC: /* eccentric */
                        redessine_preview(1, 0);
                        break;
                    case MENU_1_1_STATUS: /* statut jeu */
                        redessine_preview(1, 0);
                        break;
                    case MENU_1_1_WINDOW_MSG: /* fenetre de messages */
                        redessine_preview(1, 0);
                        break;
                    case MENU_1_1_ACCELER: /* acceleration */
                        break;
                    case MENU_1_1_GAME_AREA: /* aire de jeu */
                        redessine_preview(1, 1);
                        break;
                    case MENU_1_1_TEAM1: /* team 1 */
                        break;
                    case MENU_1_1_TEAM2: /* team 2 */
                        break;
                    /*team 3:
                    case 6:
                        break;*/
                    case MENU_1_1_BACKGROUND:     /* fond de jeu */
                        load_dat(nom_fond[fond_jeu], VSCR_AUTRES+1);
                        memcpy(palette, pal_ftris, 768);
                        for (j = 0; j < scr_nby; j++)
                            for (i = 0; i < scr_nbx; i++)
                                assombrit_pixel(VSCR_AUTRES+1, VSCR_AUTRES+2, i, j, 31, 31, 9);
                        pixels_efface();
                        pixels_init();
                        redessine_preview(0, 0);
                        for (i = 0; i < nbj; i++)
                            affiche_piece_preview(ECRAN_REEL, i, &piece[i]);
                        break;
                    case MENU_1_1_CHEAT: /* cheat ! */
                        break;
                }
            }
            else
            {
                switch (pos_barre)
                {
                    case MENU_1_0_GAME: /* game mode */
                        redessine_preview(1, 1);
                        break;
                    case MENU_1_0_TEAM: /* game team */
                        redessine_preview(1, 1);
                        break;
                    case MENU_1_0_PLAYERS: /* nombre de joueurs */
                        redessine_preview(1, 1);
                        break;
                    case MENU_1_0_F_BOTS: /* nombre d'ordi */
                        redessine_preview(1, 1);
                        break;
                    case MENU_1_0_BOTS_LEVEL: /* AI level */
                        break;
                    case MENU_1_0_SAME_PIECES: /* same pieces */
                        redessine_preview(1, 0);
                        break;
                    case MENU_1_0_HANDICAP: /* handicap */
                        redessine_preview(1, 1);
                        break;
                    case MENU_1_0_STATS: /* stats */
                        redessine_preview(0, 0);
                        for (i = 0; i < nbj; i++)
                            affiche_piece_preview(ECRAN_REEL, i, &piece[i]);
                        break;
                    case MENU_1_0_TIME: /* time */
                        break;
                    case MENU_1_0_VIEW_NEXT: /* view next */
                        redessine_preview(0, 0);
                        for (i = 0; i < nbj; i++)
                            affiche_piece_preview(ECRAN_REEL, i, &piece[i]);
                        break;
                    case MENU_1_0_BONUS_LEVELS: /* bonus levels */
                        break;
                }
            }
            break;
        case 2:
            /* SOUND */
            if (pos_advanced)
            {
                switch (pos_barre)
                {
                    case MENU_2_1_SB16_PORT: /* force port -- DOS ONLY !! */
                        break;
                    case MENU_2_1_SB16_IRQ: /* force irq -- DOS ONLY !! */
                        break;
                }
            }
            else
            {
                switch (pos_barre)
                {
                    case MENU_2_0_MUSIC_MENU: /* musique menu */
                        if (sb16)
                        {
                            if (music_menu == MUSIC_RANDOM)
                                music_stop_at_end = 1;
                            else
                                if (music_menu != music_jouee)
                                    change_music(NULL, 1);
                        }
                        break;
                    case MENU_2_0_MUSIC_GAME: /* musique jeu */
                        if ( (sb16) && (en_pause) )
                        {
                            if (music_jeu == MUSIC_RANDOM)
                                music_stop_at_end = 1;
                            else
                                if (music_jeu != music_jouee)
                                    change_music(NULL, 1);
                        }
                        break;
                }
            }
            break;
        case 3:
            /* NET */
            if (pos_advanced)
            {
            }
            else
            {
                switch (pos_barre)
                {
                    case MENU_3_0_NET_SERVER:   /* nom du serveur */
                        if ( (network) && (!net_master) )
                        {
                            free_texte_preview();
                            if (langue == ANGLAIS)
                                ajoute_texte_preview(-1, "Connecting to server...");
                            else
                                ajoute_texte_preview(-1, "Connexion au serveur...");
                            net_connect(net_server);
                        }
                        break;
                }
            }
            break;
    }
    grise_options_et_affiche(pos_menu);
}

/*
 * menu: menu principal de FlashTris
 */

void menu()
{
    int     i, j, k, old_value, *ptr_music;

    en_jeu = 0;
    en_pause = 0;

    /*langue = ANGLAIS;*/
    for (i = 0; i < 4; i++)
        for (j = 0; j < 2; j++)
        {
            k = 0;
            while (ptr_menus[i][j][k].o_nom != NULL) k++;
            nb_options[i][j] = k;
        }

    #ifdef MSDOS
    detourne_int_timer();
    #endif
    if (sb16)
    {
        playing_module = 0;
        change_music(NULL, 1);
    }

    /* charge l'image de fond du menu */
    load_dat(nom_fond[fond_menu], VSCR_AUTRES);

    /*memcpy_rapide(vscreen[VSCR_VSCREEN], vscreen[VSCR_AUTRES], 16000);*/
    copy_v2v(VSCR_AUTRES, VSCR_VSCREEN);

    /* charge l'image de fond du jeu */
    load_dat(nom_fond[fond_jeu], VSCR_AUTRES+1);
    for (j = 0; j < scr_nby; j++)
        for (i = 0; i < scr_nbx; i++)
            assombrit_pixel(VSCR_AUTRES+1, VSCR_AUTRES+2, i, j, 31, 31, 9);

    /*couleur_tubes = 3;*/
    affiche_tubes_menu(VSCR_VSCREEN, tab_couleur_tubes[couleur_tubes]);

    /*couleur_cases_cochees = rand()%5;*/
    couleur_cases_cochees = 4;

    /* recopie le copyright */
    /*putsprite(&copyright, 0, 188);*/

    /* modification de la palette avec les bonnes couleurs pour les */
    /* carres marrons et violets                                    */
    /* ...car la palette des flames ecrase ces couleurs...          */
    memcpy(&palette[240*3], &palette[199*3], 3);    /* MARRON */
    memcpy(&palette[241*3], &palette[201*3], 3);
    memcpy(&palette[242*3], &palette[206*3], 3);
    memcpy(&palette[243*3], &palette[204*3], 3);
    memcpy(&palette[244*3], &palette[209*3], 3);
    memcpy(&palette[245*3], &palette[212*3], 3);
    memcpy(&palette[246*3], &palette[178*3], 3);    /* VIOLET */
    memcpy(&palette[247*3], &palette[179*3], 3);
    memcpy(&palette[248*3], &palette[182*3], 3);
    memcpy(&palette[249*3], &palette[181*3], 3);
    memcpy(&palette[250*3], &palette[185*3], 3);
    memcpy(&palette[251*3], &palette[187*3], 3);

    /* initialisation des flames */
    init_flames(100, 1, COUL_FLAMES, 64, &titre_flashtris);
    flam_affichees = 0;
    flam_affichables = 1;
    flam_cptr = 100+(rand()%200);
    flam_eclair = 2+(rand()%3)*2;

    /* initialisation du "about scrolling" */
    init_scrolltxt();

    /* sauvegarde de la palette */
    memcpy(pal_ftris, palette, 768);
    setpal(palette);

    pos_menu = 0;
    pos_barre = 0;
    pos_advanced = 0;
    save_advanced[0] = 0;
    save_advanced[1] = 0;
    save_advanced[2] = 0;
    save_advanced[3] = 0;
    save_pos_barre[0][0] = 0;
    save_pos_barre[1][0] = 0;
    save_pos_barre[2][0] = 0;
    save_pos_barre[3][0] = 0;
    save_pos_barre[0][1] = 0;
    save_pos_barre[1][1] = 0;
    save_pos_barre[2][1] = 0;
    save_pos_barre[3][1] = 0;

    menu_choix_sans_jeu();

    network = 0;
    net_master = 0;

    niveau = 0;

    /*memcpy_rapide(vscreen[VSCR_MENU], vscreen[VSCR_VSCREEN], 16000);*/
    copy_v2v(VSCR_VSCREEN, VSCR_MENU);
    copy_v2s(VSCR_VSCREEN);
    redessine_preview(1, 1);
    grise_options_menu(0);
    grise_options_menu(1);
    grise_options_menu(2);
    grise_options_menu(3);
    affiche_partie_menu(ECRAN_REEL, 0, 0, 1);
    affiche_partie_menu(ECRAN_REEL, 1, 0, 0);
    affiche_partie_menu(ECRAN_REEL, 2, 0, 0);
    affiche_partie_menu(ECRAN_REEL, 3, 0, 0);

    /* recopie le titre "FlashTris" */
    /*for (i = 7; i < 221; i++)
        for (j = 168; j < 197; j++)
            if (vscreen[i+j*scr_nbx] != 0)
                putpixel_ofs(i+93+(j-167)*scr_nbx, vscreen[i+j*scr_nbx]);*/
    /*copy_v2s_xy_xy(vscreen, 7, 168, 214, 29, 100, 1);*/

    init_brik();

    #ifndef MSDOS
    if (!X_Window)
        keyboard_update();
    #endif

    compteur_palette = 0;
    compteur_clignote = 0;
    tab_cptr = 0;
    /*copy_s2v(vscreen);*/
    putsprite_tr(&titre_flashtris, 100, 1);


    bulle_affichee = 0;
    bulle_cptr = 0;
    bulle_duree = 0;

    liste_choix = 0;

    pos_musique = -1;       /* pour forcer l'affichage la 1ere fois */

    aide_affichee = 0;
    pieces_editor = 0;
    redefine_keys = 0;

    image_bombe = 0;

    pv_nb_lignes = 0;
    pv_texte_deb = 0;

    nb_PC_net = 0;
    net_adresse_serveur = 0;

    pixels_init();
    pixels_calcule_nb();

    quitte_flashtris = 0;
    quitte_rapide = 0;

    while (!quitte_flashtris)
    {
        if (module_fini)
            change_music(NULL, 1);

        #ifndef MSDOS
        if (X_Window)
            X_traite_evenement();
        #endif

        image_bombe = (image_bombe+1)%20;

        if ( (titre_en_flames) && (flam_affichables) )
        {
            if (flam_cptr > 0)
                flam_cptr--;
            else
                if (flam_eclair > 0)
                {
                    flam_eclair--;
                    if (flam_eclair == 0)
                    {
                        flam_affichees ^= 1;
                        if (flam_affichees)
                            flam_cptr = 1000+(rand()%2000);
                        else
                        {
                            flam_cptr = 200+(rand()%200);
                            putsprite_tr(&titre_flashtris, flam_x1, flam_y1);
                        }
                        flam_eclair = 2+(rand()%3)*2;
                    }
                    else
                        if ((flam_eclair%2) != 0)
                        {
                            if ( (sb16) && (sons_menu) )
                                SON_CYBER;
                            putsprite_tr(&titre_flashtris_blanc, flam_x1, flam_y1);
                        }
                        else
                        {
                            if (flam_affichees)
                                putsprite_tr(&flam_a_afficher, flam_x1, flam_y1);
                            else
                                putsprite_tr(&titre_flashtris, flam_x1, flam_y1);
                            flam_cptr += 10;
                        }
                }
        }

        #ifndef MSDOS
        if (!X_Window)
            keyboard_update();
        #endif
        teste_shift_ctrl_alt();

        waitretrace();

        if (about_scrolling)
            scrolltxt();

        if ( (sb16) && (barres_samples != 0) )
            affiche_barres_samples();

        affiche_pos_musique(ECRAN_REEL, 0);

        /*if (titre_en_flames)
            flames(flam_affichees & flam_affichables);*/

        rotation_palette_barre();

        if (bulle_duree > 0)
        {
            bulle_duree--;
            if (bulle_duree == 0)
                efface_bulle();
        }
        if (bulle_cptr > 0)
        {
            bulle_cptr--;
            if (bulle_cptr == 0)
            {
                pixels_efface();
                pixels_init();
                affiche_bulle(BULLE_INFO_CHOIX, DUREE_BULLE_INFO, pos_menu, pos_advanced, pos_barre);
            }
        }

        if (preview_affichee())
        {
            /* SHIFT + FLECHE HAUT */
            /*if ( (key_shift) && (key_tab[SCANCODE_CURSORBLOCKUP]) )*/
            /* F7 */
            if (key_tab[65])
            {
                if ( (pv_nb_lignes > 0) && (pv_texte_deb > 0) )
                {
                    pv_texte_deb--;
                    efface_texte_preview();
                }
                /*key_tab[SCANCODE_CURSORBLOCKUP] = 0;*/
                key_tab[65] = 0;
            }

            /* SHIFT + FLECHE BAS */
            /* F8 */
            /*if ( (key_shift) && (key_tab[SCANCODE_CURSORBLOCKDOWN]) )*/
            if (key_tab[66])
            {
                if (pv_texte_deb+10 <= pv_nb_lignes-1)
                {
                    pv_texte_deb++;
                    efface_texte_preview();
                }
                /*key_tab[SCANCODE_CURSORBLOCKDOWN] = 0;*/
                key_tab[66] = 0;
            }

            if ( (network) && (!net_master) )
            {
                if (cptr_net_retry > 0)
                {
                    cptr_net_retry--;
                    if (cptr_net_retry == 0)
                        net_connect(net_server);
                }
            }

            if ( (pos_menu != 0) || (pos_advanced == 0) )
            {
                if ( (pos_menu != 0) || (pos_advanced == 0) )
                    descend_pieces_preview();
                compteur_clignote = (compteur_clignote+1)%100;
                /* clignotement du mot "PAUSE" */
                if (en_pause)
                {
                    if (compteur_clignote == 50)
                        efface_pause_clignote();
                    else
                        if (compteur_clignote < 50)
                            affiche_pause_clignote();
                }
                /* si network = 1 alors le jeu ne peut pas etre en pause */
                if (network)
                {
                    if (compteur_clignote == 50)
                        efface_network_clignote();
                    else
                        if (compteur_clignote < 50)
                            affiche_network_clignote();
                }
                /* clignotement du curseur en mode "edition chaine" */
                if (edition_chaine)
                {
                    if ((compteur_clignote%50) == 30)
                        efface_curseur_clignote();
                    else
                        if ((compteur_clignote%50) < 30)
                            affiche_curseur_clignote();
                }
                affiche_texte_preview();
            }

            /*if ( (!liste_choix) && (!edition_chaine) )*/
                pixels_anim();
        }

        if (network)
            if (net_recv())
                traite_message_recu();

        brik();

        /* Echap : selon le mode en cours :            */
        /*         - quitte FlashTris                  */
        /*         - ferme l'aide de FlashTris         */
        /*         - ferme l'editeur de pieces         */
        /*         - ferme la redefinition des touches */
        if (key_tab[1])
        {
            if (aide_affichee)
                quitte_aide_flashtris();
            else
                if (pieces_editor)
                    quitte_pieces_editor();
                else
                    if (redefine_keys)
                        quitte_redefine_keys();
                    else
                        if (liste_choix)
                        {
                            /* Echap avec liste de choix ==> fermeture de la liste de */
                            /* choix SANS changement de l'option                      */
                            pixels_efface();
                            efface_liste_choix();
                            pixels_init();
                        }
                        else
                            if (edition_chaine)
                                fin_edition_chaine();
                            else
                            {
                                quitte_flashtris = 1;
                                if (key_control)
                                    quitte_rapide = 1;
                            }
            key_tab[1] = 0;
        }

        if (sb16)
        {
            /* augmentation volume  '+' */
            if ( (key_tab[78]) && (volume < VOLUME_MAX) )
            {
                if (key_control)
                    volume = (volume > VOLUME_MAX-INC_VOLUME_VITE)?VOLUME_MAX:volume+INC_VOLUME_VITE;
                else
                    volume++;
                setvolume(volume);
                affiche_volume(ECRAN_REEL);
                key_tab[78] = 0;
            }

            /* diminution volume  '-' */
            if ( (key_tab[74]) && (volume > 0) )
            {
                if (key_control)
                    volume = (volume < INC_VOLUME_VITE)?0:volume-INC_VOLUME_VITE;
                else
                    volume--;
                setvolume(volume);
                affiche_volume(ECRAN_REEL);
                key_tab[74] = 0;
            }

            /* F5 = musique precedente */
            if (key_tab[63])
            {
                ptr_music = (en_pause)?&music_jeu:&music_menu;
                if ( (*ptr_music != MUSIC_RANDOM) && (*ptr_music > MUSIC1) )
                {
                    (*ptr_music)--;
                    change_music(NULL, 1);
                    i = (en_pause)?1:0;
                    if ( ( (pos_menu == 2) && (pos_advanced == 0) )
                        || (save_advanced[2] == 0) )
                        affiche_option(ECRAN_REEL, 2, 0, i, (pos_menu == 2),
                            ((pos_menu == 2) && (pos_advanced == 0) && (pos_barre == i)), 2);
                }
                key_tab[63] = 0;
            }

            /* F6 = musique suivante */
            if (key_tab[64])
            {
                ptr_music = (en_pause)?&music_jeu:&music_menu;
                if (*ptr_music != MUSIC_RANDOM)
                {
                    if (*ptr_music < NB_MUSIC)
                    {
                        (*ptr_music)++;
                        change_music(NULL, 1);
                        i = (en_pause)?1:0;
                        if ( ( (pos_menu == 2) && (pos_advanced == 0) )
                            || (save_advanced[2] == 0) )
                            affiche_option(ECRAN_REEL, 2, 0, i, (pos_menu == 2),
                                ((pos_menu == 2) && (pos_advanced == 0) && (pos_barre == i)), 2);
                    }
                }
                else
                {
                    change_music(NULL, 1);
                    i = (en_pause)?1:0;
                    if ( ( (pos_menu == 2) && (pos_advanced == 0) )
                        || (save_advanced[2] == 0) )
                        affiche_option(ECRAN_REEL, 2, 0, i, (pos_menu == 2),
                            ((pos_menu == 2) && (pos_advanced == 0) && (pos_barre == i)), 2);
                }
                key_tab[64] = 0;
            }

            /* F11 = pattern precedent */
            if (key_tab[87])
            {
                orderpos = (orderpos == 0)?-1:orderpos-2;
                row = 64;
                key_tab[87] = 0;
            }

            /* F12 = pattern suivant */
            if (key_tab[88])
            {
                row = 64;
                key_tab[88] = 0;
            }

            /* R = "Random" mode pour la musique */
            if (key_tab[19])
            {
                if (en_pause)
                {
                    if (music_jeu == MUSIC_RANDOM)
                    {
                        music_jeu = music_jouee;
                        music_stop_at_end = 0;
                    }
                    else
                    {
                        music_jeu = MUSIC_RANDOM;
                        music_stop_at_end = 1;
                    }
                }
                else
                {
                    if (music_menu == MUSIC_RANDOM)
                    {
                        music_menu = music_jouee;
                        music_stop_at_end = 0;
                    }
                    else
                    {
                        music_menu = MUSIC_RANDOM;
                        music_stop_at_end = 1;
                    }
                }
                i = (en_pause)?1:0;
                if ( ( (pos_menu == 2) && (pos_advanced == 0) )
                    || (save_advanced[2] == 0) )
                    affiche_option(ECRAN_REEL, 2, 0, i, (pos_menu == 2),
                        ((pos_menu == 2) && (pos_advanced == 0) && (pos_barre == i)), 2);
                if ( (sb16) && (sons_menu) )
                    SON_MODIFIE_OPTION;
                key_tab[19] = 0;
            }
        }

        /* option precedente (la touche depend du menu (fleche gauche ou haut)) */
        if ( (key_tab[touche_opt_prec[pos_menu][pos_advanced]])
            && (!liste_choix) && (!edition_chaine) && (preview_affichee()) )
        {
            pixels_efface();
            efface_bulle();
            if ( (sb16) && (sons_menu) )
                SON_BOUGE_BARRE;
            affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 0, 2);
            pos_barre = (pos_barre == 0)?nb_options[pos_menu][pos_advanced]-1:pos_barre-1;
            affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 0);
            key_tab[touche_opt_prec[pos_menu][pos_advanced]] = 0;
            pixels_init();
            pixels_calcule_nb();
        }

        /* option suivante (la touche depend du menu (fleche droite ou bas)) */
        if ( (key_tab[touche_opt_suiv[pos_menu][pos_advanced]])
            && (!liste_choix) && (!edition_chaine) && (preview_affichee()) )
        {
            pixels_efface();
            efface_bulle();
            if ( (sb16) && (sons_menu) )
                SON_BOUGE_BARRE;
            affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 0, 2);
            pos_barre = (pos_barre == nb_options[pos_menu][pos_advanced]-1)?0:pos_barre+1;
            affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 0);
            key_tab[touche_opt_suiv[pos_menu][pos_advanced]] = 0;
            pixels_init();
            pixels_calcule_nb();
        }

        /* touches PGUP, PGDN, HOME et END pour la liste de choix */
        if (liste_choix)
        {
            if ( (key_tab[SCANCODE_PAGEUP]) || (key_tab[SCANCODE_HOME]) )
            {
                if (liste_choix_pos != 0)
                {
                    if ( (sb16) && (sons_menu) )
                        SON_BOUGE_LISTE_CHOIX;
                    i = liste_choix_pos;
                    liste_choix_pos = 0;
                    pixels_efface();
                    liste_choix_affiche_option(i);
                    liste_choix_affiche_option(liste_choix_pos);
                    pixels_sauve_fond();
                    liste_choix_cptr = DUREE_LISTE_CHOIX;
                }
                key_tab[SCANCODE_PAGEUP] = 0;
                key_tab[SCANCODE_HOME] = 0;
            }
            if ( (key_tab[SCANCODE_PAGEDOWN]) || (key_tab[SCANCODE_END]) )
            {
                if (liste_choix_pos != liste_choix_nb-1)
                {
                    if ( (sb16) && (sons_menu) )
                        SON_BOUGE_LISTE_CHOIX;
                    i = liste_choix_pos;
                    liste_choix_pos = liste_choix_nb-1;
                    pixels_efface();
                    liste_choix_affiche_option(i);
                    liste_choix_affiche_option(liste_choix_pos);
                    pixels_sauve_fond();
                    liste_choix_cptr = DUREE_LISTE_CHOIX;
                }
                key_tab[SCANCODE_PAGEDOWN] = 0;
                key_tab[SCANCODE_END] = 0;
            }
        }

        /* premiere option du menu actif (PGUP) */
        if ( (key_tab[SCANCODE_PAGEUP])
            && (!liste_choix) && (!edition_chaine) && (preview_affichee()) )
        {
            if (pos_barre != 0)
            {
                pixels_efface();
                efface_bulle();
                if ( (sb16) && (sons_menu) )
                    SON_BOUGE_BARRE;
                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 0, 2);
                pos_barre = 0;
                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 0);
                pixels_init();
                pixels_calcule_nb();
            }
            key_tab[SCANCODE_PAGEUP] = 0;
        }

        /* derniere option du menu actif (PGDN) */
        if ( (key_tab[SCANCODE_PAGEDOWN])
            && (!liste_choix) && (!edition_chaine) && (preview_affichee()) )
        {
            if (pos_barre != nb_options[pos_menu][pos_advanced]-1)
            {
                pixels_efface();
                efface_bulle();
                if ( (sb16) && (sons_menu) )
                    SON_BOUGE_BARRE;
                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 0, 2);
                pos_barre = nb_options[pos_menu][pos_advanced]-1;
                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 0);
                pixels_init();
                pixels_calcule_nb();
            }
            key_tab[SCANCODE_PAGEDOWN] = 0;
        }

        /*  premiere option du premier menu (HOME) */
        if ( (key_tab[SCANCODE_HOME])
            && (!liste_choix) && (!edition_chaine) && (preview_affichee()) )
        {
            if ( (pos_menu != 0) ||
                ( (en_pause) && (pos_barre != 1) )
                || ( (!en_pause) && (pos_barre != 0) ) )
            {
                pixels_efface();
                efface_bulle();
                if ( (sb16) && (sons_menu) )
                {
                    if (pos_menu == 0)
                        SON_BOUGE_BARRE;
                    else
                        SON_CHANGE_MENU;
                }
                save_advanced[pos_menu] = pos_advanced;
                save_pos_barre[pos_menu][pos_advanced] = pos_barre;
                /* efface le cadre sur l'option active */
                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 0, 0, 2);
                affiche_partie_menu(ECRAN_REEL, pos_menu, pos_advanced, 0);
                pos_menu = 0;
                if (en_pause)
                    pos_barre = 1;
                else
                    pos_barre = 0;
                pos_advanced = save_advanced[pos_menu];
                affiche_partie_menu(ECRAN_REEL, pos_menu, pos_advanced, 1);
                pixels_init();
                pixels_calcule_nb();
            }
            key_tab[SCANCODE_HOME] = 0;
        }

        /* choix precedent pour l'option selectionnee (pas une case a cocher) */
        if ( (key_tab[SCANCODE_CURSORBLOCKLEFT])
            && (!edition_chaine)
            && (preview_affichee()) )
        {
            if (!liste_choix)
            {
                if (!ptr_menus[pos_menu][pos_advanced][pos_barre].o_choix_actif)
                {
                    if ( (sb16) && (sons_menu) )
                        SON_IMPOSSIBLE_MODIFIE_OPTION;
                }
                else
                    if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int != NULL)
                        && ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini != 0)
                            || (ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi != 1)
                            || (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_libelle != NULL) ) )
                    {
                        if ( (key_control)
                            && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi-
                            ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini > LISTE_CHOIX_NB_MAX) )
                        {
                            i = (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int))-10;
                            if ( (i < ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini)
                                && (i != ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini-10) )
                                i = ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini;
                        }
                        else
                            i = (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int))-1;
                        if ( i >= ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini)
                        {
                            if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie == NULL)
                                || (verifie_option(ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie, i) ) )
                            {
                                pixels_efface();
                                efface_bulle();
                                (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int)) = i;
                                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 1);
                                if ( (sb16) && (sons_menu) )
                                    SON_MODIFIE_OPTION;
                                action_modification_option();
                                if ( (bulles) &&
                                    (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_bulle != NULL) )
                                    bulle_cptr = 10;
                                pixels_sauve_fond();
                            }
                            else
                                if ( (sb16) && (sons_menu) )
                                    SON_IMPOSSIBLE_MODIFIE_OPTION;
                        }
                    }
            }
            key_tab[SCANCODE_CURSORBLOCKLEFT] = 0;
        }

        /* choix suivant pour l'option selectionnee (pas une case a cocher) */
        if ( (key_tab[SCANCODE_CURSORBLOCKRIGHT])
            && (!edition_chaine)
            && (preview_affichee()) )
        {
            if (!liste_choix)
            {
                if (!ptr_menus[pos_menu][pos_advanced][pos_barre].o_choix_actif)
                {
                    if ( (sb16) && (sons_menu) )
                        SON_IMPOSSIBLE_MODIFIE_OPTION;
                }
                else
                    if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int != NULL)
                    && ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini != 0)
                        || (ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi != 1)
                        || (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_libelle != NULL) ) )
                    {
                        if ( (key_control)
                            && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi-
                            ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini > LISTE_CHOIX_NB_MAX) )
                        {
                            i = (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int))+10;
                            if ( (i > ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi)
                                && (i != ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi+10) )
                                i = ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi;
                        }
                        else
                            i = (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int))+1;
                        if ( i <= ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi)
                        {

                            if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie == NULL)
                                || (verifie_option(ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie, i) ) )
                            {
                                pixels_efface();
                                efface_bulle();
                                (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int)) = i;
                                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 1);
                                if ( (sb16) && (sons_menu) )
                                    SON_MODIFIE_OPTION;
                                action_modification_option();
                                if ( (bulles) &&
                                    (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_bulle != NULL) )
                                    bulle_cptr = 10;
                                pixels_sauve_fond();
                            }
                            else
                                if ( (sb16) && (sons_menu) )
                                    SON_IMPOSSIBLE_MODIFIE_OPTION;
                        }
                    }
            }
            key_tab[SCANCODE_CURSORBLOCKRIGHT] = 0;
        }

        if (pieces_editor)
        {
            if (key_tab[SCANCODE_CURSORBLOCKLEFT])
            {
                if ((editor_pos%4) != 0)
                {
                    pieces_editor_affiche_case(0, editor_pos, 0, 1);
                    editor_pos--;
                    pieces_editor_affiche_case(0, editor_pos, 0, 2);
                }
                key_tab[SCANCODE_CURSORBLOCKLEFT] = 0;
            }
            if (key_tab[SCANCODE_CURSORBLOCKRIGHT])
            {
                if (((editor_pos+1)%4) != 0)
                {
                    pieces_editor_affiche_case(0, editor_pos, 0, 1);
                    editor_pos++;
                    pieces_editor_affiche_case(0, editor_pos, 0, 2);
                }
                key_tab[SCANCODE_CURSORBLOCKRIGHT] = 0;
            }
            if (key_tab[SCANCODE_CURSORBLOCKUP])
            {
                if (editor_pos > 3)
                {
                    pieces_editor_affiche_case(0, editor_pos, 0, 1);
                    editor_pos -= 4;
                    pieces_editor_affiche_case(0, editor_pos, 0, 2);
                }
                key_tab[SCANCODE_CURSORBLOCKUP] = 0;
            }
            if (key_tab[SCANCODE_CURSORBLOCKDOWN])
            {
                if (editor_pos < 12)
                {
                    pieces_editor_affiche_case(0, editor_pos, 0, 1);
                    editor_pos += 4;
                    pieces_editor_affiche_case(0, editor_pos, 0, 2);
                }
                key_tab[SCANCODE_CURSORBLOCKDOWN] = 0;
            }
            if (key_tab[SCANCODE_INSERT])   /* Insert */
            {
                if ( (sb16) && (sons_menu) && (editor_piece[0] != 65535) )
                    SON_MODIFIE_OPTION;
                for (i = 0; i < 4; i++)
                    editor_piece[i] = 65535;
                for (i = 0; i < 4; i++)
                    for (j = 0; j < 16; j++)
                        pieces_editor_affiche_case(i, j, 1, 0);
                key_tab[SCANCODE_INSERT] = 0;
            }
            if (key_tab[SCANCODE_REMOVE])   /* Del */
            {
                if ( (sb16) && (sons_menu) && (editor_piece[0] != 0) )
                    SON_MODIFIE_OPTION;
                for (i = 0; i < 4; i++)
                    editor_piece[i] = 0;
                for (i = 0; i < 4; i++)
                    for (j = 0; j < 16; j++)
                        pieces_editor_affiche_case(i, j, 1, 0);
                key_tab[SCANCODE_REMOVE] = 0;
            }
            if (key_tab[57])                /* Espace */
            {
                editor_piece[0] ^= (1 << (15-editor_pos));
                pieces_editor_affiche_case(0, editor_pos, 1, 0);
                pieces_editor_retourne_piece(editor_piece[0], &editor_piece[1],
                    &editor_piece[2], &editor_piece[3]);
                if ( (sb16) && (sons_menu) )
                    SON_MODIFIE_OPTION;
                for (i = 1; i < 4; i++)
                    for (j = 0; j < 16; j++)
                        pieces_editor_affiche_case(i, j, 1, 0);
                key_tab[57] = 0;
            }
            if (key_tab[15])                /* TAB */
            {
                for (i = 0; i < 4; i++)
                    editor_piece[i] ^= 65535;
                if ( (sb16) && (sons_menu) )
                    SON_MODIFIE_OPTION;
                for (i = 0; i < 4; i++)
                    for (j = 0; j < 16; j++)
                        pieces_editor_affiche_case(i, j, 1, 0);
                key_tab[15] = 0;
            }
        }

        if (redefine_keys)
        {
            /*  redefine keys */
        }

        /* inversion d'une case cochee */
        if ( (key_tab[57]) && (!edition_chaine)
            && (preview_affichee()) )   /* Espace */
        {
            if ( (!liste_choix)
                && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_choix_actif)
                && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int != NULL)
                && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini == 0)
                && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi == 1)
                && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_libelle == NULL) )
            {
                if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie == NULL)
                    || (verifie_option(ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie,
                        (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int))^1) ) )
                {
                    efface_bulle();
                    (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int)) ^= 1;
                    affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 1);
                    if ( (sb16) && (sons_menu) )
                        SON_MODIFIE_OPTION;
                    action_modification_option();
                    if ( (bulles) &&
                        (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_bulle != NULL) )
                        bulle_cptr = 10;
                }
                else
                    if ( (sb16) && (sons_menu) )
                        SON_IMPOSSIBLE_MODIFIE_OPTION;
            }
            key_tab[57] = 0;
        }

        /* liste des choix pour une option                       */
        /* ou validation d'un choix si la liste est deja ouverte */
        /* ou edition d'une chaine                               */
        /* ou action d'un bouton                                 */
        if ( (key_tab[SCANCODE_ENTER] || key_tab[SCANCODE_KEYPADENTER]) /* ENTER */
            && (preview_affichee()) )
        {
            if (liste_choix)    /* liste de choix deja affichee ? */
            {
                old_value = (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int));
                if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_choix_actif)
                    && ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie == NULL)
                    || (verifie_option(ptr_menus[pos_menu][pos_advanced][pos_barre].o_fonction_verifie,
                        ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini+liste_choix_pos) ) ) )
                {
                    (*(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int)) =
                        ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini+liste_choix_pos;
                    pixels_efface();
                    efface_liste_choix();
                    if (old_value != *(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int))
                    {
                        if ( (sb16) && (sons_menu) )
                            SON_MODIFIE_OPTION;
                        affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 1, 1, 1);
                        action_modification_option();
                        if ( (bulles) &&
                            (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_bulle != NULL) )
                            bulle_cptr = 10;
                    }
                    pixels_init();
                }
                else
                {
                    if ( (sb16) && (sons_menu) )
                        SON_IMPOSSIBLE_MODIFIE_OPTION;
                    liste_choix_cptr = DUREE_LISTE_CHOIX;
                }
            }
            else
            {
                /* bouton ? */
                if (ptr_menus[pos_menu][pos_advanced][pos_barre].o_nom[0] == '*')
                {
                    /* choix actif ? */
                    if (ptr_menus[pos_menu][pos_advanced][pos_barre].o_choix_actif)
                    {
                        pixels_efface();
                        efface_bulle();
                        action_bouton();
                    }
                }
                else
                    /* si l'option n'est pas une case a cocher alors on affiche */
                    /* la liste de choix                                        */
                    if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int != NULL)
                        && ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini != 0)
                        || (ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi != 1)
                        || (ptr_menus[pos_menu][pos_advanced][pos_barre].o_ptr_libelle != NULL) ) )
                    {
                        if (ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi-
                            ptr_menus[pos_menu][pos_advanced][pos_barre].o_mini <= LISTE_CHOIX_NB_MAX)
                        {
                            pixels_efface();
                            efface_bulle();
                            affiche_liste_choix();
                            pixels_init();
                        }
                    }
                    else
                        /* chaine a editer */
                        if ( (ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_int == NULL)
                            && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_chaine != NULL)
                            && (ptr_menus[pos_menu][pos_advanced][pos_barre].o_choix_actif) )
                        {
                            if (edition_chaine)
                            {
                                strcpy(ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_chaine,
                                    edition_chaine_editee);
                                fin_edition_chaine();
                                action_modification_option();
                            }
                            else
                            {
                                pixels_efface();
                                debut_edition_chaine(
                                    pos_option[pos_menu][pos_advanced][pos_barre][0]-1,
                                    pos_option[pos_menu][pos_advanced][pos_barre][1]+7,
                                    pos_option[pos_menu][pos_advanced][pos_barre][0]+
                                        largeur_option[pos_menu][pos_advanced][pos_barre]+1,
                                    pos_option[pos_menu][pos_advanced][pos_barre][1]+15,
                                    ptr_menus[pos_menu][pos_advanced][pos_barre].o_valeur_chaine,
                                    ptr_menus[pos_menu][pos_advanced][pos_barre].o_maxi);
                                pixels_init();
                            }
                        }
            }
            key_tab[SCANCODE_ENTER] = 0;
            key_tab[SCANCODE_KEYPADENTER] = 0;
        }

        /* Selection dans la liste de choix */
        if (liste_choix)
        {
            if (key_tab[SCANCODE_CURSORBLOCKUP])
            {
                if ( (sb16) && (sons_menu) )
                    SON_BOUGE_LISTE_CHOIX;
                i = liste_choix_pos;
                if (liste_choix_pos == 0)
                    liste_choix_pos = liste_choix_nb-1;
                else
                    liste_choix_pos--;
                pixels_efface();
                liste_choix_affiche_option(i);
                liste_choix_affiche_option(liste_choix_pos);
                pixels_sauve_fond();
                liste_choix_cptr = DUREE_LISTE_CHOIX;
                key_tab[SCANCODE_CURSORBLOCKUP] = 0;
            }
            if (key_tab[SCANCODE_CURSORBLOCKDOWN])
            {
                if ( (sb16) && (sons_menu) )
                    SON_BOUGE_LISTE_CHOIX;
                i = liste_choix_pos;
                if (liste_choix_pos == liste_choix_nb-1)
                    liste_choix_pos = 0;
                else
                    liste_choix_pos++;
                pixels_efface();
                liste_choix_affiche_option(i);
                liste_choix_affiche_option(liste_choix_pos);
                pixels_sauve_fond();
                liste_choix_cptr = DUREE_LISTE_CHOIX;
                key_tab[SCANCODE_CURSORBLOCKDOWN] = 0;
            }
            if (liste_choix_cptr > 0)
            {
                liste_choix_cptr--;
                if (liste_choix_cptr == 0)
                {
                    pixels_efface();
                    efface_liste_choix();
                    pixels_init();
                }
            }
        }

        /* edition d'une chaine (valeur d'une option type chaine) */
        if (edition_chaine)
        {
            edition_touche = 0;
            for (i = 1; i < 127; i++)
                if ( (i != 42) && (i != 54) && (i != SCANCODE_LEFTCONTROL)
                    && (i != SCANCODE_RIGHTCONTROL) && (i != 56)
                    && (i != SCANCODE_RIGHTALT) )
                    if (key_tab[i])
                    {
                        edition_touche = i;
                        key_tab[i] = 0;
                        break;
                    }
            if (edition_touche != 0)
                edition_chaine_traite_touche(edition_touche);
        }

        /* advanced/normal */
        if ( (key_tab[16])
            && (preview_affichee()) && (!edition_chaine) )  /* A */
        {
            pixels_efface();
            if (liste_choix)
                efface_liste_choix();
            efface_bulle();
            bascule_advanced(1);
            key_tab[16] = 0;
            pixels_init();
            pixels_calcule_nb();
        }

        /* changement de menu (suivant ou precedent) */
        if (tab_cptr > 0)
            tab_cptr--;
        else
            if ( (key_tab[15])
                && (preview_affichee()) && (!edition_chaine) )    /* TAB */
            {
                pixels_efface();
                if (liste_choix)
                    efface_liste_choix();
                efface_bulle();
                pixels_init();
                if ( (sb16) && (sons_menu) )
                    SON_CHANGE_MENU;
                /* en quittant le menu du haut avec les options avancees, */
                /* on remet le titre et les options normales              */
                if ( (pos_menu == 0) && (pos_advanced) )
                    bascule_advanced(0);
                save_advanced[pos_menu] = pos_advanced;
                save_pos_barre[pos_menu][pos_advanced] = pos_barre;
                /* efface le cadre sur l'option active */
                affiche_option(ECRAN_REEL, pos_menu, pos_advanced, pos_barre, 0, 0, 2);
                affiche_partie_menu(ECRAN_REEL, pos_menu, pos_advanced, 0);
                if (key_shift)  /* Shift en plus ? */
                    pos_menu = (pos_menu == 0)?3:pos_menu-1;
                else
                    pos_menu = (pos_menu+1)%4;
                pos_advanced = save_advanced[pos_menu];
                pos_barre = save_pos_barre[pos_menu][pos_advanced];
                affiche_partie_menu(ECRAN_REEL, pos_menu, pos_advanced, 1);
                key_tab[15] = 0;
                tab_cptr = 1;
                pixels_calcule_nb();
            }

        /* aide sur l'option selectionnee */
        if ( (key_tab[59]) && (!liste_choix)
            && (!edition_chaine) && (preview_affichee()) )  /* F1 */
        {
            pixels_efface();
            pixels_init();
            affiche_bulle(BULLE_AIDE_OPTION, DUREE_BULLE_AIDE, pos_menu, pos_advanced, pos_barre);
            key_tab[59] = 0;
        }

        /* info sur le choix de l'option selectionnee (pas sur un bouton !) */
        if ( (key_tab[60]) && (!liste_choix)
            && (!edition_chaine) && (preview_affichee()) )  /* F2 */
        {
            if (ptr_menus[pos_menu][pos_advanced][pos_barre].o_nom[0] != '*')
            {
                pixels_efface();
                pixels_init();
                affiche_bulle(BULLE_INFO_CHOIX, DUREE_BULLE_INFO, pos_menu, pos_advanced, pos_barre);
            }
            key_tab[60] = 0;
        }

        /*  capture d'ecran du menu */
        if ( (key_alt) && (key_tab[34]) )       /* Alt-G */
        {
            save_graphics_raw();
            key_tab[56] = 0;
            key_tab[34] = 0;
        }

        /*if ( (key_tab[49]) && (pos_menu == 1) )    // N = advanced  provisoire
        {
            copy_s2v(VSCR_VSCREEN);
            for (i = 60; i < 200; i++)
            {
                //memcpy(vscreen+144+i*scr_nbx, vscreen+232+i*scr_nbx, 88);
                copy_v2v_xy_xy(VSCR_VSCREEN, VSCR_VSCREEN, 232, i, 88, 1, 144, i);
                //memcpy_rapide(vscreen+232+i*scr_nbx, vscr_menu+232+i*scr_nbx, (scr_nbx-232)/4+1);
                copy_v2v_xy_xy(VSCR_MENU, VSCR_VSCREEN, 232, i, (scr_nbx-232)/4+1, 1, 232, i);
            }
            // affiche les options avancees/normales dans vscreen
            save_pos_barre[pos_menu][pos_advanced] = pos_barre;
            pos_advanced ^= 1;
            pos_barre = save_pos_barre[pos_menu][pos_advanced];
            affiche_partie_menu(VSCR_VSCREEN, pos_menu, pos_advanced, 1);
            for (i = 0; i <= 88; i += 1)
            {
                waitretrace();
                copy_v2s_xy_xy(VSCR_VSCREEN, 144+i, 60, 88, 140, 232, 60);
                flames(flam_affichees);
                scrolltxt();
            }
            //affiche_progressif(vscreen, 232, 60, 319, 199);
        }*/

        /*if (key_tab[38])    // L = langue Anglais / Francais
        {
            langue ^= 1;
            bascule_langue();
            //affiche_partie_menu(1, 0);
            key_tab[38] = 0;
        }*/




        /*flames(100, 1, 313, 29, 146, 64);*/

        if (titre_en_flames)
            flames(flam_affichees & flam_affichables);

        /*affiche_vu_metres();*/
        /*affiche_instruments();*/

        /*flames_volume();*/
        /*flames_copyright();*/

        /*rotation_palette_grillage();*/
    }
    /*putsprite(&explosion, 160, 100);*/

    if (network)
        annule_reseau(1, 1, 0);

    if (!quitte_rapide)
    {
        if ( (pos_menu == 0) && (pos_advanced != 0) )
            bascule_advanced(0);
        for (i = 0; i < 40; i++)
        {
            if (i%2 == 0)
            {
                waitretrace();
                rotation_palette_barre();
                pixels_anim();
                if (about_scrolling)
                    scrolltxt();
                if ( (sb16) && (barres_samples != 0) )
                    affiche_barres_samples();
            }
            ligne_horiz(ECRAN_REEL, 96, 96+127, 60+i, 0);
            ligne_horiz(ECRAN_REEL, 96, 96+127, 60+79-i, 0);
        }
        clear_vscreen(VSCR_VSCREEN);
        make_effect_debut(VSCR_VSCREEN, 1/*+(rand()%2)*/, 16, VSCR_AUTRES+4);
    }

    stop_flames();
    stop_scroll();

    if (sb16)
    {
        if (playing_module)
        {
            setvolume(0);
            stopmodule();
            freemodule();
            setvolume(vol_ini);
        }
    }
    #ifdef MSDOS
    restaure_int_timer();
    #endif

    stop_brik();
}
