/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== mod.h: header pour mod.c
   ====

   ==== This file is part of FlashTris and Hell Module Player.
   ====
   ==== FlashTris/HMP are free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris/HMP are distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris/HMP; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __MOD__MOD32__
#define __MOD__MOD32__

#define DMABUFSIZE  2048
#define DEFTEMPO    6
#define DEFBPM      125
#define MIDCRATE    8448
#define MIXBUFSIZE  4096

#ifdef MSDOS
    #define VOLUME_MAX          31
    #define VOLUME_MAX_LINUX    100
#else
    #define VOLUME_MAX          100
    #define VOLUME_MAX_DOS      31
#endif

typedef struct
{
    unsigned char   *samples;
    unsigned short  position;
    unsigned short  len;
    unsigned short  repeat;
    unsigned short  replen;
    unsigned char   volume;
    unsigned char   erreur;
    unsigned short  period;
    unsigned short  pitch;
    unsigned short  effect;
    unsigned short  portto;
    unsigned char   portparm;
    unsigned char   vibpos;
    unsigned char   vibparm;
    unsigned char   oldsampofs;
    unsigned short  arp[3];
    unsigned short  arpindex;
} __attribute__((__packed__)) trackinfo;

typedef struct
{
    char            msname[22];
    unsigned short  mslength;
    char            msfinetune;
    char            msvolume;
    unsigned short  msrepeat;
    unsigned short  msreplen;
} modsample;

typedef struct
{
    char            mhname[20];
    modsample       mhsamples[31];
    char            mhorderlen;
    char            mhrestart;
    char            mhorder[128];
    unsigned int    mhsign;
} modheader;

typedef struct
{
    unsigned short  mslength;
    char            msfinetune;
    char            msvolume;
    unsigned short  msrepeat;
    unsigned short  msreplen;
} hmdsample;

typedef struct
{
    char            shorder[128];
    char            shorderlen;
    char            shrestart;
    hmdsample       shsamples[31];
    char            shnbtracks;
} hmdheader;


extern unsigned short   port_sb;
extern unsigned short   irq_sb;

extern unsigned char    numtracks;
extern unsigned short   mixspeed;
extern unsigned char    orderpos;
extern unsigned char    orderlen;
extern unsigned char    restart;
extern unsigned char    order[128];
extern unsigned char    *sampptr[64];   /* 31 */
extern unsigned short   samplen[64];    /* 31 */
extern unsigned short   samprep[64];    /* 31 */
extern unsigned short   sampreplen[64]; /* 31 */
extern unsigned short   sampvol[64];    /* 31 */
extern unsigned char    *patterns;
extern unsigned short   size_pattern;
extern trackinfo        tracks[8];

extern unsigned char    row;
extern unsigned char    breakrow;
extern unsigned char    tempo;
extern unsigned char    tempowait;
extern unsigned char    bpm;

extern unsigned char    *doublebuffer;
extern int              doublebuf_selector;
#ifdef MSDOS
extern unsigned short   g_select;
#endif
extern unsigned char    *dmabuffer;
extern unsigned short   dmaflag;

extern unsigned char    *bufptr;
extern unsigned int     buflen;
extern unsigned int     bpmsamples;

extern unsigned char    voltable[16640];
extern unsigned short   pitchtable[857];

/*extern unsigned char    buffer_pistes[8000];*/

extern int playing_module;

extern unsigned char music_stop_at_end;
extern unsigned char module_fini;

extern int fin_mod;
extern int vol_ini, volume;

extern int loadmodule(unsigned char *, long);
extern int load_hmodule(unsigned char *, long);
extern int loadsample(unsigned char *, int, long);
extern void freemodule();
#ifdef MSDOS
extern int detect_sb16();
#endif
extern int sbinit();
extern void sbdone();
extern void sbpoll();
extern void playmodule();
extern void stopmodule();
extern void playsample(int, int, unsigned short, unsigned char);
#ifdef MSDOS
extern unsigned char read_mixer(unsigned char);
extern void write_mixer(unsigned char, unsigned char);
#endif
extern int getvolume();
extern void setvolume(int);
#endif
