/* ===========================================================================

            MOD_A.S: partie assembleur de HMP pour Linux

            (c) 19/02/1999 by FlashCode (Sebastien Helleu)

 =============================================================================

   ==== This file is part of Hell Module Player (DMP).
   ====
   ==== HMP is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== HMP is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with HMP; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/02/19

2001/09/06: FlashCode:
    - ajout de la licence
*/



/* Variables globales */

.comm   port_sb,2,2
.comm   irq_sb,2,2
.comm   doublebuffer,4,4
.comm   dmaflag,2,2
.comm   dmabuffer,4,4
.comm   numtracks,1,1
.comm   row,1,1
.comm   breakrow,1,1
.comm   bpm,1,1
.comm   tempo,1,1
.comm   tempowait,1,1
.comm   tracks,8*34,34
.comm   orderpos,1,1
.comm   orderlen,1,1
.comm   note,4,4
.comm   bpmsamples,4,4
.comm   buflen,4,4
.comm   bufptr,4,4
.comm   bufrep,4,4
.comm   pitchtable,857*2,2
.comm   sampptr,64*4,4
.comm   samplen,64*4,4
.comm   samprep,64*4,4
.comm   sampreplen,64*4,4
.comm   sampvol,64*4,4
.comm   patterns,4,4
.comm   restart,1,1
.comm   order,128,1
.comm   voltable,16640,1
.comm   mixbuffer,4096,1
.comm   size_pattern,2,2
.comm   module_fini,1,1

/* pour la sauvegarde des pistes  */
/*.comm   ofs_pos_sample,4,4*/
/*.comm   buffer_pistes,8000,1*/

.data

.globl sintable
    .align 4
    .type   sintable,@object
    .size   sintable,32
sintable:
    .byte   0,25,50,74,98,120,142,162,180,197,212,225
    .byte   236,244,250,254,255,254,250,244,236,225
    .byte   212,197,180,162,142,120,98,74,50,25

.globl periodtable
    .align 4
    .type   periodtable,@object
    .size   periodtable,36*2
periodtable:
    .value  856,808,762,720,678,640,604,570,538,508,480,453
    .value  428,404,381,360,339,320,302,285,269,254,240,226
    .value  214,202,190,180,170,160,151,143,135,127,120,113

.globl mixspeed
    .align 4
    .type   mixspeed,@object
    .size   mixspeed,2
mixspeed:
    .value  22000

.text

/* ============================================================================
  BeatTrack:  Process the next beat in one track.
   In:
    EDI = track info address
============================================================================ */

.globl beattrack
    .type beattrack,@function

    .align 4
    beattrack:
        movw 18(%edi),%dx       /* 4 ???? (effect) */
        test %dx,%dx
        je .none
        cmp $0x00,%dh
        je .arpeggio
        cmp $0x01,%dh
        je .portup
        cmp $0x02,%dh
        je .portdown
        cmp $0x03,%dh
        je .toneport
        cmp $0x04,%dh
        je .vibrato
        cmp $0x05,%dh
        je .portslide
        cmp $0x06,%dh
        je .vibslide
        cmp $0x0a,%dh
        je .volslide
    .none:
        ret
    .arpeggio:
        movw 32(%edi),%bx       /* 4 ??? (arpindex) */
        andl $0x0ffff,%ebx
        movw 26(%edi,%ebx),%ax  /* 4 ??? (arp) */
        movw %ax,16(%edi)       /* 4 ??? (pitch) */
        addw $2,%bx
        cmpw $6,%bx
        jb .setarpindex
        xorw %bx,%bx
    .setarpindex:
        movw %bx,32(%edi)       /* 4 ??? (arpindex) */
        ret
    .portup:
        xorb %dh,%dh
        movw 14(%edi),%bx       /* 4 ??? (period) */
        subw %dx,%bx
        cmpw $113,%bx
        jge .notsmall
        movw $113,%bx
    .notsmall:
        movw %bx,14(%edi)       /* 4 ??? (period) */
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw pitchtable(%ebx),%ax
        movw %ax,16(%edi)       /* 4 ??? (pitch) */
        ret

    .portdown:
        xorb %dh,%dh
        movw 14(%edi),%bx       /* 4 ??? (period) */
        addw %dx,%bx
        cmpw $856,%bx
        jle .notbig
        movw $856,%bx
    .notbig:
        movw %bx,14(%edi)       /* period */
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw pitchtable(%ebx),%ax
        movw %ax,16(%edi)       /* pitch */
        ret
    .toneport:
        xorb %dh,%dh
        movw 20(%edi),%ax       /* portto */
        movw 14(%edi),%bx       /* period */
        cmpw %ax,%bx
        je .noport
        jg .porttoup
    .porttodown:
        addw %dx,%bx
        cmpw %ax,%bx
        jle .setport
    .fixport:
        movw %ax,%bx
        jmp .setport
    .porttoup:
        subw %dx,%bx
        cmpw %ax,%bx
        jl .fixport
    .setport:
        mov %bx,14(%edi)        /* period */
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw pitchtable(%ebx),%ax
        movw %ax,16(%edi)       /* pitch */
    .noport:
        ret
    .vibrato:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        shlb $2,%dh
        addb %dh,23(%edi)       /* vibpos */
        movb 23(%edi),%dh       /* vibpos */
        movb %dh,%bl
        shrb $2,%bl
        andw $0x1f,%bx
        andl $0x0ffff,%ebx
        movb sintable(%ebx),%al
        mulb %dl
        rolw $1,%ax
        xchg %al,%ah
        andb $1,%ah
        test %dh,%dh
        jns .vibup
        negw %ax
    .vibup:
        addw 14(%edi),%ax       /* period */
        movw %ax,%bx
        cmpw $113,%bx
        jge .nolovib
        movw $113,%bx
    .nolovib:
        cmpw $856,%bx
        jle .nohivib
        movw $856,%bx
    .nohivib:
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw pitchtable(%ebx),%ax
        movw %ax,16(%edi)       /* pitch */
        ret
    .portslide:
        call .volslide
        movb 22(%edi),%dl       /* portparm */
        jmp .toneport
    .vibslide:
        call .volslide
        movb 24(%edi),%dl       /* vibparm */
        jmp .vibrato
    .volslide:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        movb 12(%edi),%al       /* volume */
        subb %dl,%al
        jge .nolovol
        xorb %al,%al
    .nolovol:
        addb %dh,%al
        cmpb $64,%al
        jbe .nohivol
        movb $64,%al
    .nohivol:
        mov %al,12(%edi)        /* volume */
        ret

/* ============================================================================
 GetTrack:   Get the next Note from a pattern.
  In:
   EDI = track info address
   ESI = pattern note address
 Out:
   ESI = the next pattern note address
============================================================================ */

.globl gettrack
    .type gettrack,@function

    .align 4
    gettrack:

        movw 0(%esi),%ax
        addl $2,%esi

        xchg %al,%ah
        movb %ah,%bl
        andb $0x0f,%ah
        movw %ax,%cx

        movw 0(%esi),%ax
        addl $2,%esi

        xchg %al,%ah
        movb %ah,%bh
        andb $0x0f,%ah
        movw %ax,%dx
        movw %dx,18(%edi)       /* effect */
        andb $0x0f0,%bl
        shrb $4,%bh
        orb %bh,%bl
        je .setperiod
    .setsample:
        xorb %bh,%bh
        decw %bx
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw sampvol(%ebx),%ax
        movb %al,12(%edi)       /* volume */
        shlw $1,%bx

        movl sampptr(%ebx),%eax
        movl %eax,0(%edi)       /* samples */

        shrw $1,%bx
        movw samplen(%ebx),%ax
        movw %ax,6(%edi)        /* len */
        movw samprep(%ebx),%ax
        movw %ax,8(%edi)        /* repeat */
        movw sampreplen(%ebx),%ax
        movw %ax,10(%edi)       /* replen */

    .setperiod:
        test %cx,%cx
        je .seteffect

        movw %cx,20(%edi)       /* portto */
        cmpb $3,%dh
        je .seteffect

        movw %cx,14(%edi)       /* period */
        movw %cx,%bx
        addw %bx,%bx
        andl $0x0ffff,%ebx
        movw pitchtable(%ebx),%ax
        movw %ax,16(%edi)       /* pitch */
        movw $0,4(%edi)         /* position */

    .seteffect:
        test %dx,%dx
        je .initnone
        cmpb $0x00,%dh
        je .initarpeggio
        cmpb $0x03,%dh
        je .inittoneport
        cmpb $0x04,%dh
        je .initvibrato
        cmpb $0x09,%dh
        je .sampleofs
        cmpb $0x0b,%dh
        je .posjump
        cmpb $0x0c,%dh
        je .setvolume
        cmpb $0x0d,%dh
        je .break
        cmpb $0x0f,%dh
        je .setspeed
    .initnone:
        ret

    .inittoneport:
        test %dl,%dl
        jne .setportparm
        movb 22(%edi),%dl       /* portparm */
    .setportparm:
        movb %dl,22(%edi)       /* portparm */
        movw %dx,18(%edi)       /* effect */
        ret

    .initvibrato:
        movb 24(%edi),%al       /* vibparm */
        movb %al,%ah
        andb $0x0f,%al
        andb $0x0f0,%ah
        test $0x0f,%dl
        jne .okdepth
        orb %al,%dl
    .okdepth:
        test $0x0f0,%dl
        jne .okrate
        or %ah,%dl
    .okrate:
        movb %dl,24(%edi)       /* vibparm */
        movw %dx,18(%edi)       /* effect */
        test %cx,%cx
        je .okpos
        movb $0,23(%edi)        /* vibpos */
    .okpos:
        ret

    .sampleofs:
        test %dl,%dl
        jne .setsampleofs
        movb 25(%edi),%dl       /* oldsampofs */
    .setsampleofs:
        movb %dl,25(%edi)       /* oldsampofs */
        movb %dl,%dh
        xorb %dl,%dl
        movw %dx,4(%edi)        /* position */
        ret

    .posjump:
        movb %dl,orderpos
        movb $64,row
        ret

    .setvolume:
        cmpb $64,%dl
        jbe .okvol
        movb $64,%dl
    .okvol:
        movb %dl,12(%edi)       /* volume */
        ret

    .break:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        addb %dh,%dh
        addb %dh,%dl
        shlb $2,%dh
        addb %dh,%dl
        movb %dl,breakrow
        movb $64,row
        ret

    .setspeed:
        test %dl,%dl
        je .skip
        cmpb $31,%dl
        ja .setbpm
    .settempo:
        movb %dl,tempo
        movb %dl,tempowait
        ret
    .setbpm:
        movb %dl,bpm
        movb $103,%al
        mulb %dl
        movb %ah,%bl
        xorb %bh,%bh
        movw mixspeed,%ax
        xorw %dx,%dx
        divw %bx
        andl $0x0ffff,%eax
        movl %eax,bpmsamples
    .skip:
        ret

    .initarpeggio:
        movb %dl,%dh
        andb $0x0f,%dl
        shrb $4,%dh
        movw $36,%cx
        xorl %ebx,%ebx
        movw 14(%edi),%ax       /* period */
    .scanperiod:
        cmpw periodtable(%ebx),%ax
        jae .setarp
        addw $2,%bx
        loop .scanperiod
    .setarp:
        addw %dx,%dx
        addb %bl,%dh
        addb %bl,%dl
        movw periodtable(%ebx),%bx
        addw %bx,%bx
        movw pitchtable(%ebx),%ax
        movw %ax,26(%edi)       /* arp */
        movb %dh,%bl
        xorb %bh,%bh
        movw periodtable(%ebx),%bx
        addw %bx,%bx
        movw pitchtable(%ebx),%ax
        movw %ax,28(%edi)       /* arp+2 */
        movb %dl,%bl
        xorb %bh,%bh
        movw periodtable(%ebx),%bx
        addw %bx,%bx
        movw pitchtable(%ebx),%ax
        movw %ax,30(%edi)       /* arp+4 */
        movw $0,32(%edi)        /* arpindex */
        ret

//============================================================================
// UpdateTracks:  Main code to process the next tick to be played.
//============================================================================

.globl updatetracks
    .type updatetracks,@function

    .align 4
    updatetracks:

        decb tempowait
        je .gettracks

    .beattracks:
        movl $tracks,%edi
        call beattrack
        movl $tracks+34,%edi
        call beattrack
        movl $tracks+34*2,%edi
        call beattrack
        movl $tracks+34*3,%edi
        call beattrack
        cmpb $4,numtracks
        je .noupdate
        movl $tracks+34*4,%edi
        call beattrack
        movl $tracks+34*5,%edi
        call beattrack
        cmpb $6,numtracks
        je .noupdate
        movl $tracks+34*6,%edi
        call beattrack
        movl $tracks+34*7,%edi
        call beattrack
        ret

    .gettracks:
        movb tempo,%al
        movb %al,tempowait

        movl note,%esi
        cmpb $64,row
        jb .nopattwrap

        movl patterns,%esi
        movb orderpos,%bl
        cmpb orderlen,%bl
        jb .noorderwrap

        cmpb $1,music_stop_at_end
        jne .restartmodule
        movl $mixbuffer,%edi
        movl $4096,%ecx
        movb $0x80,%al
        rep
        stosb
        movb $1,module_fini
        jmp .noupdate

    .restartmodule:
        movb restart,%bl
        movb %bl,orderpos
        cmpb orderlen,%bl
        jae .noupdate

    .noorderwrap:
        xorb %bh,%bh
        andl $0x0ffff,%ebx
        movb order(%ebx),%bl
        movw size_pattern,%ax
        mulw %bx
        andl $0x0ffff,%eax
        addl %eax,%esi
        movb breakrow,%bl
        movb %bl,row
        xorb %bh,%bh
        movb %bh,breakrow
        shlw $4,%bx
        andl $0x0ffff,%ebx
        addl %ebx,%esi
        movl %esi,note
        incb orderpos
    .nopattwrap:
        incb row

        cld

        movl $tracks,%edi
        call gettrack
        movl $tracks+34,%edi
        call gettrack
        movl $tracks+34*2,%edi
        call gettrack
        movl $tracks+34*3,%edi
        call gettrack
        cmpb $4,numtracks
        je .aftergettrack
        movl $tracks+34*4,%edi
        call gettrack
        movl $tracks+34*5,%edi
        call gettrack
        cmpb $6,numtracks
        je .aftergettrack
        movl $tracks+34*6,%edi
        call gettrack
        movl $tracks+34*7,%edi
        call gettrack

    .aftergettrack:
        movl %esi,note
    .noupdate:
        ret

/* ============================================================================
 MixTrack:  Mixes one track into a CLEAN buffer.
  In:
   ESI = track info address
   EDI = buffer address
   ECX = buffer size
============================================================================ */

.globl mixtrack
    .type mixtrack,@function

    .align 4
    mixtrack:

        cmpw $2,10(%esi)        /* replen */
        ja .mixlooped

    .mixnonlooped:
        movl 0(%esi),%edx       /* samples */
        movw 4(%esi),%bx        /* position */
        andl $0x0ffff,%ebx
        movw 6(%esi),%bp        /* len */
        andl $0x0ffff,%ebp
        push %edx
        push %esi
        addl %edx,%ebx

        /* pour la sauvegarde des pistes  */
        /*movl %ebx,ofs_pos_sample*/

        addl %edx,%ebp
        movw 16(%esi),%dx       /* pitch */
        andl $0x0ffff,%edx
        movb 12(%esi),%al       /* volume */
        movb 13(%esi),%ah       /* erreur */
        movl %ebx,%esi
        movb %al,%bh
        movb %dl,%al
        movb %dh,%dl
        xorb %dh,%dh
        andl $0x0ffff,%ebx
    .nlmixsamp:
        cmpl %ebp,%esi
        jae .nlmixbye
        movb 0(%esi),%bl
        movb voltable(%ebx),%bl
        addb %bl,0(%edi)
        incl %edi
        addb %al,%ah
        adcl %edx,%esi
        loop .nlmixsamp
    .nlmixbye:
        movl %esi,%ebx
        popl %esi
        popl %edx
        subl %edx,%ebx
        movw %bx,4(%esi)        /* position */
        movb %ah,13(%esi)       /* erreur */
        ret

.mixlooped:
        movl 0(%esi),%edx       /* samples */
        movw 4(%esi),%bx        /* position */
        andl $0x0ffff,%ebx
        movw 10(%esi),%bp       /* replen */
        andl $0x0ffff,%ebp
        movl %ebp,bufrep
        addw 8(%esi),%bp        /* repeat */
        push %edx
        push %esi
        addl %edx,%ebx
        addl %edx,%ebp
        movw 16(%esi),%dx       /* pitch */
        andl $0x0ffff,%edx
        movb 12(%esi),%al       /* volume */
        movb 13(%esi),%ah       /* erreur */
        movl %ebx,%esi
        movb %al,%bh
        movb %dl,%al
        movb %dh,%dl
        xorb %dh,%dh
        andl $0x0ffff,%ebx
    .lpmixsamp:
        cmpl %ebp,%esi
        jb .lpmixnow
        subl bufrep,%esi
    .lpmixnow:
        movb 0(%esi),%bl
        movb voltable(%ebx),%bl
        addb %bl,0(%edi)
        incl %edi
        addb %al,%ah
        adcl %edx,%esi
        loop .lpmixsamp
    .lpmixbye:
        movl %esi,%ebx
        pop %esi
        pop %edx
        subl %edx,%ebx
        movw %bx,4(%esi)        /* position */
        movb %ah,13(%esi)       /* erreur */
        ret

//============================================================================
// GetSamples:  Returns the next chunk of samples to be played.
//  In:
//   EDI = buffer address
//   EBX = buffer size
//============================================================================

.globl getsamples
    .type getsamples,@function

    .align 4
    getsamples:

        pusha
        cld

    .nextchunk:
        cmpl $0,buflen
        jne .copychunk

        push %ebx
        push %edi

    .mixchunk:
        movl $mixbuffer,%edi
        movl bpmsamples,%ecx
        movl %edi,bufptr
        movl %ecx,buflen

        movb $0x80,%al
        rep
        stosb

        movl $tracks,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 1  */
        /*movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb*/

        movl $tracks+34,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 2  */
        /*movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        addl $1000,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb*/

        movl $tracks+34*2,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 3  */
        /*movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        addl $2000,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb*/

        movl $tracks+34*3,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 4  */
        /*movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        addl $3000,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb*/

        cmpb $4,numtracks
        je .aftermixtrack
        movl $tracks+34*4,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 5  */
        movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        addl $4000,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb*/

        movl $tracks+34*5,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 6  */
        movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        addl $5000,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb */

        cmpb $6,numtracks
        je .aftermixtrack
        movl $tracks+34*6,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 7  */
        movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        addl $6000,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb */

        movl $tracks+34*7,%esi
        movl bufptr,%edi
        movl buflen,%ecx
        call mixtrack

        /* sauvegarde piste 8  */
        /*movl buflen,%eax
        subl %ecx,%eax
        movl $buffer_pistes,%edi
        addl $7000,%edi
        movl ofs_pos_sample,%esi
        xchg %ecx,%eax
        rep
        movsb
        movl %eax,%ecx
        movb $0x80,%al
        rep
        stosb*/


    .aftermixtrack:
        call updatetracks

        pop %edi
        pop %ebx

    .copychunk:
        movl buflen,%ecx
        cmpl %ebx,%ecx
        jbe .movechunk
        movl %ebx,%ecx

    .movechunk:
        movl bufptr,%esi
        addl %ecx,bufptr
        subl %ecx,buflen
        subl %ecx,%ebx
        rep
        movsb
        test %ebx,%ebx
        jne .nextchunk

        popa
        ret


/* ============================================================================
 StartPlaying: Initializes the Sound System.
  In:
   Module Information Resources.
============================================================================ */

.globl startplaying
    .type startplaying,@function

    .align 4
    startplaying:

        pusha

    .setmodparms:
        movb $0,module_fini
        movb $0,orderpos
        movb $6,tempo
        movb $6,tempowait
        movb $125,bpm
        movb $65,row
        movb $0,breakrow
        movw mixspeed,%ax
        xorw %dx,%dx
        movw $50,%bx
        divw %bx
        andl $0x0ffff,%eax
        movl %eax,bpmsamples

    .cleartracks:
        movl $tracks,%edi
        movl $272,%ecx
        xorl %eax,%eax
        cld
        rep
        stosb

        movl %eax,bufptr
        movl %eax,buflen

    .makepitch:
        movw $8448,%ax
        movw $428,%bx
        mulw %bx
        divw mixspeed
        xorb %dh,%dh
        movb %ah,%dl
        movb %al,%ah
        xorb %al,%al
        movl $857,%ecx
        xorw %bx,%bx
        movl $pitchtable,%edi
    .pitchloop:
        push %ax
        push %dx
        cmpw %bx,%dx
        jae .nodiv
        divw %bx
    .nodiv:
        stosw
        pop %dx
        pop %ax
        incw %bx
        loop .pitchloop

    .makevolume:
        movl $voltable,%esi
        movl $16640,%ecx
        movl %ecx,%ebx
    .volloop:
        decw %bx
        movb %bl,%al
        imulb %bh
        movb %ah,(%esi,%ebx)
        loop .volloop

        popa
        ret

/* ============================================================================
 SbPoll:  Sound Blaster Polling. (=== DOS ONLY ! ===)
============================================================================ */

.globl _sbpoll
    .type _sbpoll,@function

    .align 4
    _sbpoll:

        pusha

    .getdmacount:
        in $0x03,%al
        movb %al,%cl
        in $0x03,%al
        movb %al,%ch

        movw dmaflag,%ax
        test %ax,%ax
        jne .secondhalf

    .firsthalf:
        cmpw $1024,%cx
        jae .bye
        movl dmabuffer,%edi
        movl $1024,%ebx
        call getsamples
        incw dmaflag
        jmp .bye

    .secondhalf:
        cmpw $1024,%cx
        jb .bye
        movl dmabuffer,%edi
        movl $1024,%ebx
        addl %ebx,%edi
        call getsamples
        decw dmaflag

    .bye:
        popa
        ret
