/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== netftris.h: header pour netftris.c
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#ifndef __FTRIS_NETFTRIS__
#define __FTRIS_NETFTRIS__


#include "net.h"


#define NB_PROTO            3

#define PROTO_TCPIP         0
#define PROTO_IPX           1
#define PROTO_MODEM         2

#define DELAI_RETRY         30

#define MAX_LONG_MSG        1000

#define NETFTRIS_CONNECT_REQUEST    'c'
#define NETFTRIS_CONNECT_ACCEPTED   'C'
#define NETFTRIS_CONNECT_REFUSED    '!'
#define NETFTRIS_DISCONNECT         'D'
#define NETFTRIS_START_GAME         'S'
#define NETFTRIS_LIGNES             'L'
#define NETFTRIS_PERD               'P'

#define NETFTRIS_REFUS_NBJ_MAX      'J'
#define NETFTRIS_REFUS_BOTS         'B'


typedef struct
{
    int             (*init)     (int, unsigned long *);
    int             (*send)     (unsigned long, int, int, unsigned char *);
    int             (*recv)     (int, unsigned char *, int *, unsigned long *);
    int             (*close)    ();
    unsigned long   (*nom2addr) (unsigned char *);
} t_net_driver;


extern int              network;
extern int              net_master;
extern int              net_type;
extern unsigned char    net_nom[11];
extern unsigned char    net_server[51];
extern int              net_nbj_max;
extern int              net_allow_bots;
extern int              net_death;
extern int              net_view_other;
extern int              net_bonus_level;
extern int              net_same_pieces;
extern int              net_chat;
extern int              net_port_serveur;

extern unsigned long    net_adresse_serveur;
extern unsigned long    net_adresse_locale;
extern int              net_port_local;
extern int              cptr_net_retry;


extern int net_init();
extern int net_connect(unsigned char *);
extern int net_send(int, int, unsigned char *);
extern int net_recv();
extern int net_close();
extern void traite_message_recu();
extern void envoi_disconnect(unsigned long, int);
extern void envoi_start_game();
extern void envoi_perdu();
extern void envoi_lignes(int);

#endif
