/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== video.c: routines graphiques pour Dos/Windows, Linux Console, X-Window
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#ifdef MSDOS
    #include <dpmi.h>
    #include <go32.h>
    #include <dos.h>
#endif
#ifdef LINUX
    #include <vga.h>
    #include <X11/Xlib.h>
    #include <X11/Xutil.h>
#endif

#include "ftris.h"
#include "video.h"
#include "key.h"
#include "data_exe.h"
#include "effet.h"


unsigned char   palette[768];
unsigned char   *vscreen[NB_VSCR_MAX];  /* ecrans virtuels pour Dos ou Linux Console */
#ifndef MSDOS
Pixmap          pixmap[NB_VSCR_MAX];    /* ecrans virtuels pour X-Window             */
Pixmap          pixmap_save;            /* utilise pour reafficher si evt Expose     */
XImage          *un_pixel;
#endif
int             nb_vscr;

int             scr_nbx, scr_nby;

#if defined(MSDOS) || defined(CYGWIN)

    /* pour MS-Dos */
    unsigned short  g_select;
    unsigned char   *adr_ecran = (unsigned char*)0xA0000;
    unsigned char   dos_save_screen[4000];
    unsigned char   dos_save_x, dos_save_y;

#else

    #define X_FONT "-misc-fixed-bold-r-normal--13-*-*-*-*-*-*-*"
    #define X_FONTWIDTH 7
    #define X_FONTHEIGHT 13

    /* pour Linux Console: */
    unsigned char   *adr_ecran;

    /* pour X-Window: */
    int             X_Window;       /* 1 si X-Window detecte */
    Display         *display;
    Window          window;
    XVisualInfo     visual;
    XSizeHints      sizehints;
    int             screen;
    Colormap        colormap;
    GC              gc;
    XGCValues       xgcvalues;
    XFontStruct     *fonte_x;
    static Atom     wm_del_win;     /* pour la fermeture propre de la fenetre */

    unsigned long   xcolor[256];
    int             couleurs_allouees;  /* 1 si setpal a ete appele mais pas encore freepal */
    /* couleurs standard : */
    /*unsigned char   *couleurs[16] =
                    { "#000000000000", "#0000aa", "#00aa00", "#00aaaa", "#aa0000",
                      "#aa00aa", "#aa5500", "#aaaaaa", "#555555", "#5555ff", "#55ff55",
                      "#55ffff", "#ff5555", "#ff55ff", "#ffff55", "#ffffffffffff" };*/
#endif

unsigned char   couleur_fond;   /* 0 sous Dos ou Linux Console, 7 sous X-Window  */
int             font_width;     /* 8 sous Dos ou Linux Console, 7 sous X-Window  */
int             font_height;    /* 8 sous Dos ou Linux Console, 13 sous X-Window */

unsigned char   flashtris[5][36] = { "*** *    *  *** * * *** **  *** ***",
                                     "*   *   * * *   * *  *  * *  *  *  ",
                                     "**  *   *** *** ***  *  **   *  ***",
                                     "*   *   * *   * * *  *  * *  *    *",
                                     "*   *** * * *** * *  *  * * *** ***" };

unsigned char fonte[128][8] =
  {{0,0,0,0,0,0,0,0},{126,129,165,129,189,153,129,126},{126,255,219,255,195,231,255,126},{108,254,254,254,124,56,16,0},
   {16,56,124,254,124,56,16,0},{56,124,56,254,254,146,16,124},{0,16,56,124,254,124,56,124},{0,0,24,60,60,24,0,0},
   {255,255,231,195,195,231,255,255},{0,60,102,66,66,102,60,0},{255,195,153,189,189,153,195,255},{15,7,15,125,204,204,204,120},
   {60,102,102,102,60,24,126,24},{63,51,63,48,48,112,240,224},{127,99,127,99,99,103,230,192},{153,90,60,231,231,60,90,153},
   {128,224,248,254,248,224,128,0},{2,14,62,254,62,14,2,0},{24,60,126,24,24,126,60,24},{102,102,102,102,102,0,102,0},
   {127,219,219,123,27,27,27,0},{62,99,56,108,108,56,134,252},{0,0,0,0,126,126,126,0},{24,60,126,24,126,60,24,255},
   {24,60,126,24,24,24,24,0},{24,24,24,24,126,60,24,0},{0,24,12,254,12,24,0,0},{0,48,96,254,96,48,0,0},
   {0,0,192,192,192,254,0,0},{0,36,102,255,102,36,0,0},{0,24,60,126,255,255,0,0},{0,255,255,126,60,24,0,0},
   {0,0,0,0,0,0,0,0},{24,24,24,56,56,0,56,0},{108,108,36,0,0,0,0,0},{108,254,254,108,254,254,108,0},
   {56,254,192,254,6,254,56,0},{198,206,28,56,112,230,198,0},{124,68,124,248,214,204,246,0},{24,24,16,0,0,0,0,0},
   {56,96,96,112,112,112,56,0},{56,12,12,28,28,28,56,0},{0,198,56,238,56,198,0,0},{0,24,24,126,24,24,0,0},
   {0,0,0,0,0,48,48,32},{0,0,0,252,0,0,0,0},{0,0,0,0,0,48,48,0},{6,14,28,56,112,224,192,0},
   {254,198,214,214,214,198,254,0},{24,24,24,56,56,56,56,0},{254,198,6,254,224,230,254,0},{254,6,6,62,14,14,254,0},
   {198,198,198,254,14,14,14,0},{254,192,192,254,14,14,254,0},{254,192,192,254,230,230,254,0},{254,198,6,14,14,14,14,0},
   {254,198,198,124,198,198,254,0},{254,198,198,254,14,14,14,0},{0,48,48,0,0,48,48,0},{0,48,48,0,0,48,48,32},

   {28,56,112,224,112,56,28,0},{0,0,254,0,254,0,0,0},{112,56,28,14,28,56,112,0},{254,198,6,62,56,0,56,0},
   {254,198,222,222,222,192,254,0},{124,68,68,254,194,194,194,0},{252,196,196,254,230,230,254,0},
   {254,198,192,224,224,230,254,0},{252,198,198,230,230,230,252,0},{254,192,192,248,224,224,254,0},
   {254,192,192,248,224,224,224,0},{254,198,192,238,230,230,254,0},{198,198,198,254,230,230,230,0},{254,48,48,56,56,56,254,0},
   {6,6,6,14,14,206,254,0},{198,198,204,248,236,230,230,0},{192,192,192,224,224,224,254,0},{254,214,214,198,230,230,230,0},
   {252,198,198,230,230,230,230,0},{254,198,198,230,230,230,254,0},{254,198,198,254,224,224,224,0},
   {254,198,198,206,206,206,254,0},{254,198,198,254,248,236,230,0},{254,206,192,254,14,206,254,0},{254,48,48,56,56,56,56,0},
   {198,198,198,230,230,230,254,0},{198,198,198,204,216,240,224,0},{198,198,198,214,214,214,254,0},
   {198,198,108,56,108,198,198,0},{198,198,198,254,56,56,56,0},{254,198,6,124,224,230,254,0},{124,96,96,112,112,112,124,0},
   {192,224,112,56,28,14,6,0},{124,12,12,28,28,28,124,0},{16,56,108,198,0,0,0,0},{0,0,0,0,0,0,0,255},
   {48,48,16,0,0,0,0,0},{0,0,126,6,254,206,254,0},{192,192,192,254,230,230,254,0},{0,0,254,198,224,230,254,0},
   {6,6,6,254,206,206,254,0},{0,0,254,230,254,224,254,0},{56,96,96,120,112,112,112,0},{0,0,254,230,230,254,6,126},
   {192,192,192,254,230,230,230,0},{0,48,0,48,56,56,56,0},{0,6,0,6,14,14,110,60},{192,192,198,204,248,236,230,0},
   {192,192,192,224,224,224,248,0},{0,0,254,214,214,198,198,0},{0,0,252,198,230,230,230,0},{0,0,254,198,230,230,254,0},
   {0,0,254,198,198,254,224,224},{0,0,254,198,198,254,14,14},{0,0,248,192,224,224,224,0},{0,0,254,192,254,14,254,0},
   {0,48,252,48,56,56,56,0},{0,0,198,198,230,230,254,0},{0,0,204,204,216,240,224,0},{0,0,198,198,214,214,254,0},
   {0,0,198,108,56,108,198,0},{0,0,230,230,230,254,6,254},{0,0,254,6,124,224,254,0},{60,48,48,96,48,48,60,0},
   {24,24,24,0,56,56,56,0},{112,48,48,24,48,48,112,0},{118,220,0,0,0,0,0,0},{0,16,56,108,198,198,254,0}};

unsigned char petite_fonte[94][5] =
  {/* 33*/{16,16,16,0,16},{20,20,0,0,0},/*#*/{10,31,10,31,10},{31,20,31,5,31},{0,18,4,8,18},
   /* 38*/{8,20,8,20,14},{16,16,0,0,0},{8,16,16,16,8},{16,8,8,8,16},{0,20,8,20,0},
   /* 43*/{0,8,28,8,0},{0,0,0,8,16},{0,0,28,0,0},{0,0,0,0,16},{4,8,8,16,16},
   /* 48*/{28,20,20,20,28},{24,8,8,8,8},{28,4,28,16,28},{28,4,12,4,28},{16,20,28,4,4},
   /* 53*/{28,16,28,4,28},{28,16,28,20,28},{28,4,12,4,4},{28,20,28,20,28},
   /* 57*/{28,20,28,4,28},{0,0,16,0,16},{0,8,0,8,16},{4,8,16,8,4},{0,28,0,28,0},
   /* 62*/{16,8,4,8,16},{12,18,4,0,4},/*@*/{12,18,22,16,12},{8,20,28,20,20},{24,20,24,20,28},
   /* 67*/{12,16,16,16,12},{24,20,20,20,24},{12,16,24,16,12},{12,16,24,16,16},
   /* 71*/{12,16,20,20,12},{20,20,28,20,20},{28,8,8,8,28},{28,8,8,8,24},
   /* 75*/{18,20,24,20,18},{16,16,16,16,12},{17,27,21,17,17},{18,26,22,18,18},
   /* 79*/{8,20,20,20,8},{24,20,24,16,16},{8,20,20,28,12},{24,20,24,20,20},
   /* 83*/{12,16,8,4,24},{28,8,8,8,8},{18,18,18,18,12},{18,18,18,20,8},
   /* 87*/{17,17,21,27,17},{20,20,8,20,20},{20,20,8,8,8},{28,4,8,16,28},
   /* 91*/{24,16,16,16,24},{16,8,8,4,4},{24,8,8,8,24},{8,20,0,0,0},{0,0,0,0,28},
   /* 96*/{16,8,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},
   /*101*/{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},
   /*106*/{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},
   /*111*/{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},
   /*116*/{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},
   /*121*/{0,0,0,0,0},{0,0,0,0,0},{12,8,16,8,12},{16,16,16,16,16},{24,8,4,8,24},
   /*126*/{10,20,0,0,0} };

unsigned char fonte_digital[10][7] =
  {/*0*/{6,9,9,0,9,9,6},/*1*/{0,1,1,0,1,1,0},/*2*/{6,1,1,6,8,8,6},
   /*3*/{6,1,1,6,1,1,6},/*4*/{0,9,9,6,1,1,0},/*5*/{6,8,8,6,1,1,6},
   /*6*/{6,8,8,6,9,9,6},/*7*/{6,1,1,0,1,1,0},/*8*/{6,9,9,6,9,9,6},
   /*9*/{6,9,9,6,1,1,6}};


/*
 * setmode: active un mode video (graphique ou texte)
 *          renvoie  0 si OK
 *                  -1 si probleme d'activation du mode video
 *          *** Dos uniquement ***
 */

#if defined(MSDOS) || (defined CYGWIN)
int setmode(short mode)
{
    __dpmi_regs regs;

    regs.x.ax = mode;
    __dpmi_int(0x10, &regs);
    regs.x.ax = 0x0F00;
    __dpmi_int(0x10, &regs);
    if (regs.h.al != mode)
        return -1;
    else
        return 0;
}
#endif

/*
 * detect_X_Window: renvoie 1 si X_Window est detecte, 0 sinon
 *                  NE PAS APPELER SOUS DOS !!!
 */

#ifdef LINUX
void detect_X_Window()
{
    display = XOpenDisplay(NULL);
    X_Window = (display != NULL);
}
#endif

/*
 * init_grafx: Linux: renvoie  0 si OK (ou pas de X-Window)
 *                            -1 pas assez de memoire
 *                            -2 si erreur lors de l'initialisation de X-Window
 *               Dos: renvoie  0 si OK (carte VGA ok (mode 13h ok))
 *                            -1 pas assez de memoire
 *                            -2 si erreur activation mode 13h
 */

int init_grafx(int nbx, int nby)
{
    int         i;
    #if defined(MSDOS) || (defined CYGWIN)
    union REGS  regs_in, regs_out;
    #endif
    #ifdef LINUX
    /*XColor      xcl, exa;*/
    XVisualInfo     *visual_list;
    int             match;
    #endif

    #if defined(MSDOS) || (defined CYGWIN)
    /*if ( (nbx != 0) || (nby != 0) )
        ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
            "parameters 'nbx' and 'nby' runs only with X-Window !");*/
    scr_nbx = 320;
    scr_nby = 200;
    /*if ( (vscreen = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
        return -1;
    if ( (vscr_menu = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
        return -1;
    if ( (vscr_jeu = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
        return -1;
    if ( (vscr_jeu_vide = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
        return -1;*/
    g_select = _dos_ds;
    regs_in.h.ah = 0x03;
    regs_in.h.bh = 0;
    int86(0x10, &regs_in, &regs_out);
    dos_save_x = regs_out.h.dl;
    dos_save_y = regs_out.h.dh;
    __asm__ __volatile__ (
        "push %%ds\n
        movl %0, %%edi\n
        movw _g_select, %%ds\n
        movl $0x0B8000, %%esi\n
        movl $1000, %%ecx\n
        rep\n
        movsl\n
        pop  %%ds"
        :
        : "g" (dos_save_screen)
        : "ecx", "esi", "edi"
    );
    if (setmode(0x13) != 0)
        return INIT_GRAFX_ERR_MODE;
    couleur_fond = 0;
    font_width = 8;
    font_height = 8;
    #else
    if (X_Window)
    {
        scr_nbx = nbx;
        scr_nby = nby;

        /* PROVISOIRE POUR TESTER X-WINDOW EN 320*200  */
        /* scr_nbx = 320; */
        /* scr_nby = 200; */

        /*if ( (vscreen = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;
        if ( (vscr_menu = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;
        if ( (vscr_jeu = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;
        if ( (vscr_jeu_vide = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;*/
        couleur_fond = 0;
        font_width = X_FONTWIDTH;
        font_height = X_FONTHEIGHT;
        screen = DefaultScreen(display);

        visual.screen = screen;
        visual_list = XGetVisualInfo(display, VisualScreenMask, &visual, &match);
        if(!visual_list)
        {
            ftris_error(MSG_ERROR, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                "no matched visuals (X-Window)");
            return INIT_GRAFX_ERR_MODE;
        }
        visual = visual_list[0];
        XFree(visual_list);
        /*if (visual.colormap_size < 256)
        {
            fprintf(stderr, "FlashTris ERROR: colormap is too small (size=%d, needs 256)\n",
                visual.colormap_size);
            return -2;
        }*/

        colormap = DefaultColormap(display, screen);
        if ((fonte_x = XLoadQueryFont(display, X_FONT)) == NULL)
        {
            ftris_error(MSG_ERROR, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                "can't load X font");
            return INIT_GRAFX_ERR_MODE;
        }
        /*for (i = 0; i < 16; i++)
            if (XAllocNamedColor(display, colormap, couleurs[i], &xcl, &exa) == 0)
            {
                fprintf(stderr, "FlashTris ERROR: can't allocate color #%d\n", i);
                return -2;
            }
            else
                xcolor[i] = xcl.pixel;*/
        window = XCreateSimpleWindow(display, RootWindow(display, screen),
            0, 0, scr_nbx, scr_nby, 4,
            WhitePixel(display, screen), xcolor[couleur_fond]);

        pixmap_save = XCreatePixmap(display, window, scr_nbx, scr_nby,
            DefaultDepth(display, screen));
        nb_vscr = NB_VSCR_MAX;
        for (i = 0; i < NB_VSCR_MAX; i++)
            pixmap[i] = XCreatePixmap(display, window, scr_nbx, scr_nby,
                DefaultDepth(display, screen));

        un_pixel = XGetImage(display, pixmap_save, 0, 0, 1, 1, 0xFFFF, ZPixmap);

        sizehints.flags = PMaxSize;
        sizehints.flags = PMinSize | PMaxSize | PSize | PResizeInc;
        /*sizehints.flags = PResizeInc;*/
        sizehints.min_width = scr_nbx;
        sizehints.min_height = scr_nby;
        sizehints.max_width = scr_nbx;
        sizehints.max_height = scr_nby;
        sizehints.width_inc = 1;
        sizehints.height_inc = 1;
        XSetStandardProperties(display, window,
            "F l a s h T r i s",    /* titre de la fenetre            */
            "FlashTris",            /* titre dans la barre des taches */
            None, 0, 0, &sizehints);

        gc = XCreateGC(display, window, (unsigned long)0, &xgcvalues);
        XSetFont(display, gc, fonte_x->fid);
        XSetForeground(display, gc, WhitePixel(display, screen));
        XSelectInput(display, window,
            ExposureMask | StructureNotifyMask | KeyPressMask | KeyReleaseMask | ButtonPressMask);
        XMapWindow(display, window);
        wm_del_win = XInternAtom(display, "WM_DELETE_WINDOW", False);
        XSetWMProtocols(display, window, &wm_del_win, 1);
    }
    else
    {
        /*if ( (nbx != 0) || (nby != 0) )
            ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                "parameters 'nbx' and 'nby' runs only with X-Window !");*/
        scr_nbx = 320;
        scr_nby = 200;
        /* Linux Console : */
        /*if ( (vscreen = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;
        if ( (vscr_menu = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;
        if ( (vscr_jeu = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;
        if ( (vscr_jeu_vide = (unsigned char *)ftris_malloc(scr_nbx*scr_nby, "virtual screen")) == NULL )
            return -1;*/
        if (vga_setmode(G320x200x256) != 0)
            return INIT_GRAFX_ERR_MODE;
        /*vga_setlinearaddressing();*/
        adr_ecran = vga_getgraphmem();
        couleur_fond = 0;
        font_width = 8;
        font_height = 8;
    }
    #endif

    /* alloue les vscreens (sauf pour X_Window) */
    #ifdef LINUX
    if (!X_Window)
    #endif
    {
        nb_vscr = NB_VSCR_MAX;
        for (i = 0; i < NB_VSCR_MAX; i++)
            if ( (vscreen[i] = (unsigned char *)malloc(scr_nbx*scr_nby)) == NULL)
            {
                nb_vscr = i;
                ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                    "can't allocate all virtual screens (allocated: %d/%d)",
                    i, NB_VSCR_MAX);
                break;
                /*for (j = 0; j < i; j++)
                    free(vscr[j]);
                return -1;*/
            }
    }

    return 0;
}

/*
 * close_grafx: X-Window: ferme la fenetre graphique
 *              Dos ou Linux console: restaure le mode texte
 */

void close_grafx()
{
    #if defined(MSDOS) || (defined CYGWIN)
    union REGS  regs_in, regs_out;
    #else
    int     i;
    #endif

    #if defined(MSDOS) || (defined CYGWIN)
    setmode(0x03);
    __asm__ __volatile__ (
        "push %%es\n
        movl %0, %%esi\n
        movw _g_select, %%es\n
        movl $0x0B8000, %%edi\n
        movl $1000, %%ecx\n
        rep\n
        movsl\n
        pop  %%es"
        :
        : "g" (dos_save_screen)
        : "ecx", "esi", "edi"
    );
    regs_in.h.ah = 0x02;
    regs_in.h.dl = dos_save_x;
    regs_in.h.dh = dos_save_y;
    regs_in.h.bh = 0;
    int86(0x10, &regs_in, &regs_out);
    #endif
    #ifdef LINUX
    if (X_Window)
    {
        XCloseDisplay(display);
        XFreePixmap(display, pixmap_save);
        for (i = 0; i < NB_VSCR_MAX; i++)
            XFreePixmap(display, pixmap[i]);
    }
    else
        vga_setmode(TEXT);
    #endif
}

/* X_expose: est appele lorqu'un evenement "expose" survient */

#ifdef LINUX
void X_expose(XEvent *xevent)
{
    int     exp_width, exp_height;

    /*  */
    if ( (xevent->xexpose.x < scr_nbx)
        && (xevent->xexpose.y < scr_nby) )
    {
        if (xevent->xexpose.x+xevent->xexpose.width > scr_nbx)
            exp_width = scr_nbx-xevent->xexpose.x;
        else
            exp_width = xevent->xexpose.width;
        if (xevent->xexpose.y+xevent->xexpose.height > scr_nby)
            exp_height = scr_nby-xevent->xexpose.y;
        else
            exp_height = xevent->xexpose.height;
        XCopyArea(display, pixmap_save, window, gc,
            xevent->xexpose.x, xevent->xexpose.y,
            exp_width, exp_height,
            xevent->xexpose.x, xevent->xexpose.y);
    }
}
#endif

/*
 * X_traite_evenement: traite un evenement X-Window (s'il y en a au moins 1)
 */

#ifdef LINUX
void X_traite_evenement()
{
    XEvent  xevent;

    if (XCheckWindowEvent(display, window,
        ExposureMask, &xevent) == True)
    {
        switch (xevent.type)
        {
            case Expose:
                X_expose(&xevent);
                break;
        }
    }
    if (XCheckWindowEvent(display, window,
        KeyPressMask|KeyReleaseMask|StructureNotifyMask,
        &xevent) == True)
    {
        switch (xevent.type)
        {
            case KeyPress:
                /*printf("touche X-window = %d\n", xevent.xkey.keycode);*/
                xkey2scancode_tab(xevent.xkey.keycode, 1);
                break;
            case KeyRelease:
                xkey2scancode_tab(xevent.xkey.keycode, 0);
                /*printf("RELEASE key= %d\n", xevent.xkey.keycode);*/
                break;
            /*case ClientMessage:
                quitte_flashtris = 1;
                break;*/
        }
    }
}
#endif

/* ==========================================================================
                       FONCTIONS GRAPHIQUES ELEMENTAIRES
   ========================================================================== */

/*
 * waitretrace: attend le retour de balayage
 *              *** Dos ou Linux Console ***
 */

void waitretrace()
{
    #if defined(MSDOS) || (defined CYGWIN)
    __asm__ __volatile__ ("
        movw $0x3da, %%dx\n
    wait1:
        in   %%dx, %%al\n
        test $8, %%al\n
        jnz  wait1\n
    wait2:
        in   %%dx, %%al\n
        test $8, %%al\n
        jz   wait2"
        :
        :
        : "al", "dx");
    #else
    if (X_Window)
    {
        /*  X-Window  */
    }
    else
        vga_waitretrace();
    #endif
}

/*
 * clear_screen: efface l'ecran graphique
 */

void clear_screen()
{
    #if defined(MSDOS) || (defined CYGWIN)
    __asm__ __volatile__ (
        #ifdef MSDOS
        "push %%es\n
        movw _g_select, %%es\n"
        #endif
        "movl $0xA0000, %%edi\n
        movl $32000, %%ecx\n
        xorl %%eax, %%eax\n
        rep\n
        stosw\n"
        #ifdef MSDOS
        "pop  %%es"
        #endif
        :
        :
        : "eax", "ecx", "edi");
    #else
    if (X_Window)
        XClearWindow(display, window);
    else
    {
        __asm__ __volatile__ (
            "movl adr_ecran, %%edi\n"
            "movl $32000, %%ecx\n
            xorl %%eax, %%eax\n
            rep\n
            stosw\n"
            :
            :
            : "eax", "ecx", "edi");
    }
    #endif
}

/*
 * clear_vscreen: efface un ecran virtuel
 */

void clear_vscreen(int no_vscr)
{
    #ifdef LINUX
    /*  ca marche l'effacement d'un pixmap ????  */
    if (X_Window)
        XClearArea(display, window, 0, 0, scr_nbx, scr_nby, False);
    else
    #endif
        memset(vscreen[no_vscr], 0, 64000);
}

/*
 * putpixel_ofs: affiche un pixel dans l'ecran a l'offset indique
 */

inline void putpixel_ofs(int no_vscr, int ofs, unsigned char couleur)
{
    #ifdef LINUX
    if (X_Window)
    {
        XSetForeground(display, gc, xcolor[couleur]);
        if (no_vscr == ECRAN_REEL)
        {
            XDrawPoint(display, pixmap_save, gc, ofs%scr_nbx, ofs/scr_nbx);
            XDrawPoint(display, window, gc, ofs%scr_nbx, ofs/scr_nbx);
        }
        else
            XDrawPoint(display, pixmap[no_vscr], gc, ofs%scr_nbx, ofs/scr_nbx);
    }
    else
    {
        if (no_vscr == ECRAN_REEL)
            adr_ecran[ofs] = couleur;
        else
            vscreen[no_vscr][ofs] = couleur;
    }
    #else
    if (no_vscr == ECRAN_REEL)
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%es\n
            movw _g_select, %%es\n
            movl $0xA0000, %%edi\n"
            #else
            "movl adr_ecran, %%edi\n"
            #endif
            "addl %0, %%edi\n
            movb %1, %%al\n
            movb %%al, %%es:(%%edi)\n"
            #ifdef MSDOS
            "pop  %%es"
            #endif
            :
            : "g" (ofs), "g" (couleur)
            : "al", "edi");
    else
    {
        /*vscr = vscreen[no_vscr];
        __asm__ __volatile__ ("
            movl %2, %%edi\n
            addl %0, %%edi\n
            movb %1, %%al\n
            movb %%al, %%es:(%%edi)"
            :
            : "g" (ofs), "g" (couleur), "g" (vscr)
            : "al", "edi");*/
        vscreen[no_vscr][ofs] = couleur;
    }
    #endif
}

/*
 * getpixel_ofs: renvoie la couleur d'un pixel de l'ecran
 */

unsigned char getpixel_ofs(int no_vscr, int ofs)
{
    unsigned char   couleur;
    #ifndef MSDOS
    /*XImage          *ximage;*/
    #endif

    #ifndef MSDOS
    if (X_Window)
    {
        /*  A TESTER  */

        /*  A OPTIMISER ????  */

        /*if (no_vscr == ECRAN_REEL)
            ximage = XGetImage(display, pixmap_save,
                ofs%scr_nbx, ofs/scr_nbx, 1, 1, 0xFFFF, ZPixmap);
        else
            ximage = XGetImage(display, pixmap[no_vscr],
                ofs%scr_nbx, ofs/scr_nbx, 1, 1, 0xFFFF, ZPixmap);*/

        if (no_vscr == ECRAN_REEL)
            un_pixel = XGetSubImage(display, pixmap_save,
                ofs%scr_nbx, ofs/scr_nbx, 1, 1, 0xFFFF, ZPixmap, un_pixel, 0, 0);
        else
            un_pixel = XGetSubImage(display, pixmap[no_vscr],
                ofs%scr_nbx, ofs/scr_nbx, 1, 1, 0xFFFF, ZPixmap, un_pixel, 0, 0);
        couleur = XGetPixel(un_pixel, 0, 0);

        /*XDestroyImage(ximage);*/
    }
    else
    {
        if (no_vscr == ECRAN_REEL)
            return adr_ecran[ofs];
        else
            return vscreen[no_vscr][ofs];
    }
    #else
    if (no_vscr == ECRAN_REEL)
    {
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%ds\n
            movw _g_select, %%ds\n
            movl $0xA0000, %%esi\n"
            #else
            "movl adr_ecran, %%esi\n"
            #endif
            "addl %0, %%esi\n
            movl %1, %%edi\n
            movsb\n"
            #ifdef MSDOS
            "pop  %%ds"
            #endif
            :
            : "g" (ofs), "g" (&couleur)
            : "eax", "esi", "edi");
    }
    else
    {
        /*vscr = vscreen[no_vscr];
        __asm__ __volatile__ ("
            movl %2, %%esi\n
            addl %0, %%esi\n
            movb (%%esi), %%al\n
            movb %%al, (%1)"
            :
            : "g" (ofs), "g" (&couleur), "g" (vscr)
            : "al", "esi");*/
        couleur = vscreen[no_vscr][ofs];
    }
    #endif
    return couleur;
}

/*
 * ligne_horiz: trace une ligne horizontale en mode graphique
 *              *** Dos ou Linux Console ***
 */

void ligne_horiz(int no_vscr, unsigned short x1, unsigned short x2,
                 unsigned short y, unsigned char coul)
{
    unsigned char   *scr;

    #ifdef MSDOS
    if (no_vscr == ECRAN_REEL)
        __asm__ __volatile__ ("
            push %%es\n
            movw $320, %%ax\n
            xorw %%dx, %%dx\n
            mulw %2\n
            xorl %%edi, %%edi\n
            movw %0, %%di\n
            addw %%ax, %%di\n
            movb %3, %%al\n
            movw _g_select, %%es\n
            addl $0xA0000, %%edi\n
            xorl %%ecx, %%ecx\n
            movw %1, %%cx\n
            subw %0, %%cx\n
            incw %%cx\n
            rep\n
            stosb\n
            pop  %%es"
            :
            : "g" (x1), "g" (x2), "g" (y), "g" (coul)
            : "ax", "ecx", "dx", "edi");
    else
    {
        scr = vscreen[no_vscr];
        __asm__ __volatile__ ("
            movw $320, %%ax\n
            xorw %%dx, %%dx\n
            mulw %2\n
            xorl %%edi, %%edi\n
            movw %0, %%di\n
            addw %%ax, %%di\n
            movb %3, %%al\n
            addl %4, %%edi\n
            xorl %%ecx, %%ecx\n
            movw %1, %%cx\n
            subw %0, %%cx\n
            incw %%cx\n
            rep\n
            stosb"
            :
            : "g" (x1), "g" (x2), "g" (y), "g" (coul), "g" (scr)
            : "ax", "ecx", "dx", "edi");
    }
    #else
    if (X_Window)
    {
        XSetForeground(display, gc, xcolor[coul]);
        if (no_vscr == ECRAN_REEL)
        {
            XDrawLine(display, pixmap_save, gc, x1, y, x2, y);
            XDrawLine(display, window, gc, x1, y, x2, y);
        }
        else
            XDrawLine(display, pixmap[no_vscr], gc, x1, y, x2, y);
    }
    else
    {
        /* Linux Console : */
        if (no_vscr == ECRAN_REEL)
            scr = adr_ecran;
        else
            scr = vscreen[no_vscr];
        /*__asm__ __volatile__ ("
            movw $320, %%ax\n
            xorw %%dx, %%dx\n
            mulw %2\n
            xorl %%edi, %%edi\n
            movw %0, %%di\n
            addw %%ax, %%di\n
            movb %3, %%al\n
            addl %4, %%edi\n
            xorl %%ecx, %%ecx\n
            movw %1, %%cx\n
            subw %0, %%cx\n
            incw %%cx\n
            rep\n
            stosb"
            :
            : "g" (x1), "g" (x2), "g" (y), "g" (coul), "g" (scr)
            : "ax", "ecx", "dx", "edi"
        );*/
        memset(scr+y*scr_nbx+x1, coul, x2-x1+1);
    }
    #endif
}

/*
 * ligne_vertic: trace une ligne verticale en mode graphique
 *               *** Dos ou Linux Console ***
 */

void ligne_vertic(int no_vscr, unsigned short x, unsigned short y1,
                  unsigned short y2, unsigned char coul)
{
    unsigned char   *scr;
    #ifndef MSDOS
    int             j;
    #endif

    #ifdef MSDOS
    if (no_vscr == ECRAN_REEL)
        __asm__ __volatile__ ("
            push %%es\n
            movw $320, %%ax\n
            xorw %%dx, %%dx\n
            mulw %1\n
            xorl %%edi, %%edi\n
            movw %0, %%di\n
            addw %%ax, %%di\n
            movb %3, %%al\n
            movw _g_select, %%es\n
            addl $0xA0000, %%edi\n
            movw %2, %%cx\n
            subw %1, %%cx\n
            incw %%cx\n
        boucle_vertic1:
            movb %%al, %%es:(%%edi)\n
            addl $320, %%edi\n
            decw %%cx\n
            jnz  boucle_vertic1\n
            pop  %%es"
            :
            : "g" (x), "g" (y1), "g" (y2), "g" (coul)
            : "ax", "cx", "dx", "edi");
    else
    {
        scr = vscreen[no_vscr];
        __asm__ __volatile__ ("
            movw $320, %%ax\n
            xorw %%dx, %%dx\n
            mulw %1\n
            xorl %%edi, %%edi\n
            movw %0, %%di\n
            addw %%ax, %%di\n
            movb %3, %%al\n
            addl %4, %%edi\n
            movw %2, %%cx\n
            subw %1, %%cx\n
            incw %%cx\n
        boucle_vertic2:
            movb %%al, %%es:(%%edi)\n
            addl $320, %%edi\n
            decw %%cx\n
            jnz  boucle_vertic2"
            :
            : "g" (x), "g" (y1), "g" (y2), "g" (coul), "g" (scr)
            : "ax", "cx", "dx", "edi");
    }
    #else
    if (X_Window)
    {
        XSetForeground(display, gc, xcolor[coul]);
        if (no_vscr == ECRAN_REEL)
        {
            XDrawLine(display, pixmap_save, gc, x, y1, x, y2);
            XDrawLine(display, window, gc, x, y1, x, y2);
        }
        else
            XDrawLine(display, pixmap[no_vscr], gc, x, y1, x, y2);
    }
    else
    {
        /* Linux Console : */
        if (no_vscr == ECRAN_REEL)
            scr = adr_ecran;
        else
            scr = vscreen[no_vscr];
        /*__asm__ __volatile__ ("
            movw $320, %%ax\n
            xorw %%dx, %%dx\n
            mulw %1\n
            xorl %%edi, %%edi\n
            movw %0, %%di\n
            addw %%ax, %%di\n
            movb %3, %%al\n
            addl %4, %%edi\n
            movw %2, %%cx\n
            subw %1, %%cx\n
            incw %%cx\n
        boucle_vertic:
            movb %%al, %%es:(%%edi)\n
            addl $320, %%edi\n
            decw %%cx\n
            jnz  boucle_vertic"
            :
            : "g" (x), "g" (y1), "g" (y2), "g" (coul), "g" (scr)
            : "ax", "cx", "dx", "edi"
        );*/
        for (j = y1; j <= y2; j++)
            scr[j*scr_nbx+x] = coul;
    }
    #endif
}

/*
 * rectangle: trace un rectangle en mode graphique
 */

void rectangle(int no_vscr, unsigned short x1, unsigned short y1,
               unsigned short x2, unsigned short y2, unsigned char couleur)
{
    #ifndef MSDOS
    if (X_Window)
    {
        XSetForeground(display, gc, xcolor[couleur]);
        if (no_vscr == ECRAN_REEL)
        {
            XDrawRectangle(display, pixmap_save, gc, x1, y1, x2-x1+1, y2-y1+1);
            XDrawRectangle(display, window, gc, x1, y1, x2-x1+1, y2-y1+1);
        }
        else
            XDrawRectangle(display, pixmap[no_vscr], gc, x1, y1, x2-x1+1, y2-y1+1);
    }
    else
    #endif
    {
        ligne_horiz(no_vscr, x1, x2, y1, couleur);
        ligne_horiz(no_vscr, x1, x2, y2, couleur);
        ligne_vertic(no_vscr, x1, y1+1, y2-1, couleur);
        ligne_vertic(no_vscr, x2, y1+1, y2-1, couleur);
    }
}

/*
 * fill_rectangle: trace un rectangle plein en mode graphique
 */

void fill_rectangle(int no_vscr, unsigned short x1, unsigned short y1,
                    unsigned short x2, unsigned short y2, unsigned char couleur)
{
    int     i;

    for (i = y1; i <= y2; i++)
        ligne_horiz(no_vscr, x1, x2, i, couleur);
}

/*
 * setcoul: modifie une couleur de la palette
 *          *** Cette fonction existe sous Linux dans SVGALIB mais c'est
 *              une grosse daube ***
 */

#ifdef MSDOS
void setcoul(unsigned char coul, unsigned char red, unsigned char green,
            unsigned char blue)
{
    /*__asm__ __volatile__ ("
        movw $0x1010, %%ax\n
        xorb %%bh, %%bh\n
        movb %0, %%bl\n
        movb %1, %%dh\n
        movb %2, %%ch\n
        movb %3, %%cl\n
        int  $0x10"
        :
        : "g" (coul), "g" (red), "g" (green), "g" (blue)
        : "ax", "bx", "cx", "dh"
    );*/
    palette[coul*3] = red;
    palette[coul*3+1] = green;
    palette[coul*3+2] = blue;
    __asm__ __volatile__ ("
        movb %0, %%al\n
        movw $0x3c8, %%dx\n
        outb %%al, %%dx\n
        incw %%dx\n
        movb %1, %%al\n
        outb %%al, %%dx\n
        movb %2, %%al\n
        outb %%al, %%dx\n
        movb %3, %%al\n
        outb %%al, %%dx"
        :
        : "g" (coul), "g" (red), "g" (green), "g" (blue)
        : "al", "dx"
    );
}
#else
void setcoul(unsigned char coul, unsigned char red, unsigned char green,
             unsigned char blue)
{
    XColor          couleur, exacte;
    unsigned char   nom_couleur[20];

    palette[coul*3] = red;
    palette[coul*3+1] = green;
    palette[coul*3+2] = blue;
    if (X_Window)
    {
        XFreeColors(display, colormap, &xcolor[coul], 1, 0);
        sprintf(nom_couleur, "#%02x%02x%02x", red, green, blue);
        if (XAllocNamedColor(display, colormap, nom_couleur, &couleur, &exacte) == 0)
            ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                "can't allocate color #%d", coul);
        else
            xcolor[coul] = couleur.pixel;
    }
    else
    {
        /* Linux Console : */
        __asm__ __volatile__ ("
            movb %0, %%al\n
            movw $0x3c8, %%dx\n
            outb %%al, %%dx\n
            incw %%dx\n
            movb %1, %%al\n
            outb %%al, %%dx\n
            movb %2, %%al\n
            outb %%al, %%dx\n
            movb %3, %%al\n
            outb %%al, %%dx"
            :
            : "g" (coul), "g" (red), "g" (green), "g" (blue)
            : "al", "dx"
        );
    }
}
#endif

/*
 * setpal: active une palette de 256 couleurs
 */

void setpal(unsigned char *pal)
{
    #ifndef MSDOS
    int             i;
    XColor          couleur, exacte;
    unsigned char   nom_couleur[20];
    #endif

    /*if (pal != palette)
        memcpy(palette, pal, 768);*/
    #ifndef MSDOS
    if (X_Window)
    {
        if (couleurs_allouees)
            for (i = 0; i < 256; i++)
                XFreeColors(display, colormap, &xcolor[i], 1, 0);
        for (i = 0; i < 256; i++)
        {
            sprintf(nom_couleur, "#%02x%02x%02x", pal[i*3]<<2, pal[i*3+1]<<2, pal[i*3+2]<<2);
            if (XAllocNamedColor(display, colormap, nom_couleur, &couleur, &exacte) == 0)
                ftris_error(MSG_WARNING, NO_BUG, NO_CLOSE_SB16, CONTINUE,
                    "can't allocate color #%d", i);
            else
                xcolor[i] = couleur.pixel;
        }
        couleurs_allouees = 1;
    }
    else
        /*for (i = 0; i < 256; i++)
            setcoul(i, pal[i*3], pal[i*3+1], pal[i*3+2]);*/
        /*__asm__ __volatile__ ("
            movl %0, %%esi\n
            movl $768, %%ecx\n
            xorl %%eax, %%eax\n
            movw $0x3c8, %%dx\n
            outb %%al, %%dx\n
            incw %%dx\n
            rep\n
            outsb"
            :
            : "g" (pal)
            : "eax", "ecx", "dx", "esi"
        );*/
        /* FONCTIONNE PARFAITEMENT CHEZ Ramses2 !!!!!!!!!!!!!! (01/11/99, FlashCode) */
        __asm__ __volatile__ ("
            movl %0, %%esi\n
            xorw %%bx, %%bx\n
            movw $256, %%cx\n
            movw $0x3c8, %%dx\n
        boucle_setcoul:
            movb %%bl, %%al\n
            outb %%al, %%dx\n
            incw %%dx\n
            lodsb\n
            outb %%al, %%dx\n
            lodsb\n
            outb %%al, %%dx\n
            lodsb\n
            outb %%al, %%dx\n
            decw %%dx\n
            incw %%bx\n
            decw %%cx\n
            jnz  boucle_setcoul"
            :
            : "g" (pal)
            : "eax", "ebx", "ecx", "edx", "esi"
        );
    #else
        __asm__ __volatile__ ("
            movl %0, %%esi\n
            movl $768, %%ecx\n
            xorl %%eax, %%eax\n
            movw $0x3c8, %%dx\n
            outb %%al, %%dx\n
            incw %%dx\n
            rep\n
            outsb"
            :
            : "g" (pal)
            : "eax", "ecx", "dx", "esi"
        );
        /*__asm__ __volatile__ ("
            movw $0x1012, %%ax\n
            xorw %%bx, %%bx\n
            movw $256, %%cx\n
            movl %0, %%edx\n
            int  $0x10"
            :
            : "g" (pal)
            : "ax", "bx", "cx", "edx"
        );*/
    #endif
}

/*
 * freepal: libere les couleurs allouees par setpal
 *          *** SPECIFIQUE X-WINDOW ***
 */

/*#ifndef MSDOS
void freepal()
{
    int     i;

    if (couleurs_allouees)
    {
        for (i = 0; i < 256; i++)
            XFreeColor(xcolor[
        couleurs_allouees = 0;
    }
}
#endif*/

/*
 * fade_in: fondu d'ouverture
 */

void fade_in(unsigned char *to_pal, int nb_skip, int delay_pause)
{
    unsigned char   pal_fondu[768];
    int             i, j;

    memset(pal_fondu, 0, 768);
    for (j = 0; j < 64; j++)
    {
        for (i = 0; i < 768; i++)
            if (pal_fondu[i] < to_pal[i])
                pal_fondu[i]++;
        if ((j % nb_skip) == 0)
        {
            waitretrace();
            setpal(pal_fondu);
            usleep(delay_pause);
        }
    }
    waitretrace();
    setpal(to_pal);
}

/*
 * fade_to: fondu d'une palette vers une autre
 */

void fade_to(unsigned char *from_pal, unsigned char *to_pal,
             int nb_skip, int delay_pause)
{
    unsigned char   pal_actuelle[768];
    int             i, j;

    memcpy(pal_actuelle, from_pal, 768);
    setpal(pal_actuelle);
    for (j = 0; j < 64; j++)
    {
        for (i = 0; i < 768; i++)
            if (pal_actuelle[i] < to_pal[i])
                pal_actuelle[i]++;
            else
                if (pal_actuelle[i] > to_pal[i])
                    pal_actuelle[i]--;
        if ((j % nb_skip) == 0)
        {
            waitretrace();
            setpal(pal_actuelle);
            usleep(delay_pause);
        }
    }
    waitretrace();
    setpal(to_pal);
}

/*
 * fade_out: fondu d'ouverture
 */

void fade_out(unsigned char *from_pal, int nb_skip, int delay_pause)
{
    unsigned char   pal_fondu[768];
    int             i, j;

    memcpy(pal_fondu, from_pal, 768);
    for (j = 0; j < 64; j++)
    {
        for (i = 0; i < 768; i++)
            if (pal_fondu[i] > 0)
                pal_fondu[i]--;
        if ((j % nb_skip) == 0)
        {
            waitretrace();
            setpal(pal_fondu);
            usleep(delay_pause);
        }
    }
    waitretrace();
    setpal(pal_fondu);
}

/*
 *  load_pcx: charge un fichier PCX dans un buffer (qui peut etre l'ecran)
 *            La variable palette[768] doit etre definie
 *           Renvoie:  0 = OK
 *                    -1 = fichier non trouve
 *                    -2 = le fichier n'est pas un PCX 320*200*256
 *                    -3 = pas assez de memoire
 */

int load_pcx(unsigned char *nom_pcx, int no_vscr_dest)
{
    FILE            *f;
    int             i, ptr_buffer, ptr_dest;
    #ifdef DATA_EXE
    long            pos_fichier;
    #else
    long            pos;
    #endif
    unsigned char   *buffer;
    long            taille_donnees;

    #ifdef DATA_EXE
    if ((f = fopen(argv0, "rb")) == NULL)
        return -1;
    pos_fichier = position_fichier(nom_pcx);
    if (fseek(f, -pos_fichier+taille_fichier(nom_pcx)-768, SEEK_END) != 0)
        { fclose(f); return -2; }
    #else
    unsigned char   nom_complet[256];

    sprintf(nom_complet, "%s%s", PATH_GFX, nom_pcx);

    if ((f = fopen(nom_complet, "rb")) == NULL)
        return -1;
    if (fseek(f, -768, SEEK_END) != 0)
        { fclose(f); return -2; }
    pos = ftell(f);
    if (pos <= 128)
        { fclose(f); return -2; }
    #endif
    fread(palette, 1, 768, f);
    for (i = 0; i < 768; i++) palette[i] >>= 2;
    #ifndef MSDOS
    if (X_Window) setpal(palette);
    #endif
    /*setpal(palette);*/
    #ifdef DATA_EXE
    if (fseek(f, -pos_fichier+128, SEEK_END) != 0)
        { fclose(f); return -2; }
    taille_donnees = taille_fichier(nom_pcx)-768-128;
    #else
    if (fseek(f, 128, SEEK_SET) != 0)
        { fclose(f); return -2; }
    taille_donnees = pos-128;
    #endif
    if ( (buffer = (unsigned char *)ftris_malloc(taille_donnees, "image_load buffer")) == NULL)
        { fclose(f); return -3; }
    fread(buffer, 1, taille_donnees, f);
    ptr_dest = 0; ptr_buffer = 0;
    #ifndef MSDOS
    if (X_Window)
    {
        while (ptr_buffer < taille_donnees-1)
        {
            if (buffer[ptr_buffer] >= 0xC0)
            {
                i = buffer[ptr_buffer]-0xC0;
                XSetForeground(display, gc, xcolor[buffer[ptr_buffer+1]]);
                XDrawLine(display, pixmap[no_vscr_dest], gc,
                    ptr_dest%320, ptr_dest/320,
                    (ptr_dest%320)+i-1, ptr_dest/320);
                ptr_buffer += 2;
                ptr_dest += i;
            }
            else
            {
                XSetForeground(display, gc, xcolor[buffer[ptr_buffer]]);
                XDrawPoint(display, pixmap[no_vscr_dest], gc,
                    ptr_dest%320, ptr_dest/320);
                ptr_dest++;
                ptr_buffer++;
            }
        }
    }
    else
    #endif
    {
        while (ptr_buffer < taille_donnees-1)
        {
            if (buffer[ptr_buffer] >= 0xC0)
            {
                i = buffer[ptr_buffer]-0xC0;
                memset(&vscreen[no_vscr_dest][ptr_dest], buffer[ptr_buffer+1], i);
                ptr_buffer += 2;
                ptr_dest += i;
            }
            else
               vscreen[no_vscr_dest][ptr_dest++] = buffer[ptr_buffer++];
        }
    }
    free(buffer);
    fclose(f);
    return 0;
}

/*
 * load_dat: charge un fichier DAT (PCX transforme) dans un buffer
 *           (qui peut etre l'ecran)
 *           La variable palette[768] doit etre definie
 *           Renvoie:  0 = OK
 *                    -1 = fichier non trouve
 *                    -2 = le fichier n'est pas un DAT-FTRIS 320*200*256
 *                    -3 = pas assez de memoire
 */

/*int load_dat(unsigned char *nom_dat, int no_vscr_dest)
{
    FILE            *f;
    int             i, ptr_buffer, ptr_dest;
    unsigned char   *buffer;
    long            taille_donnees;

    #ifdef DATA_EXE
    if ((f = fopen(argv0, "rb")) == NULL)
        return -1;
    if (fseek(f, -position_fichier(nom_dat), SEEK_END) != 0)
        { fclose(f); return -2; }
    taille_donnees = taille_fichier(nom_dat)-768;
    #else
    unsigned char   nom_complet[256];

    sprintf(nom_complet, "%s%s", PATH_GFX, nom_dat);

    if ((f = fopen(nom_complet, "rb")) == NULL)
        return -1;
    if (fseek(f, 0, SEEK_END) != 0)
        { fclose(f); return -2; }
    taille_donnees = ftell(f)-768;
    if (fseek(f, 0, SEEK_SET) != 0)
        { fclose(f); return -2; }
    #endif
    fread(palette, 1, 768, f);
    #ifndef MSDOS
    if (X_Window) setpal(palette);
    #endif
    ***setpal(palette);
    if ( (buffer = (unsigned char *)ftris_malloc(taille_donnees, "image_load buffer")) == NULL)
        { fclose(f); return -3; }
    fread(buffer, 1, taille_donnees, f);
    for (i = 0; i < taille_donnees; i++)
        buffer[i] ^= 0xFE;
    ptr_dest = 0; ptr_buffer = 0;
    #ifndef MSDOS
    if (X_Window)
    {
        while (ptr_buffer < taille_donnees-1)
        {
            if (buffer[ptr_buffer] >= 0xC0)
            {
                i = buffer[ptr_buffer]-0xC0;
                XSetForeground(display, gc, xcolor[buffer[ptr_buffer+1]]);
                XDrawLine(display, pixmap[no_vscr_dest], gc,
                    ptr_dest%320, ptr_dest/320,
                    (ptr_dest%320)+i-1, ptr_dest/320);
                ptr_buffer += 2;
                ptr_dest += i;
            }
            else
            {
                XSetForeground(display, gc, xcolor[buffer[ptr_buffer]]);
                XDrawPoint(display, pixmap[no_vscr_dest], gc,
                    ptr_dest%320, ptr_dest/320);
                ptr_dest++;
                ptr_buffer++;
            }
        }
    }
    else
    #endif
    {
        while (ptr_buffer < taille_donnees-1)
        {
            if (buffer[ptr_buffer] >= 0xC0)
            {
                i = buffer[ptr_buffer]-0xC0;
                memset(&vscreen[no_vscr_dest][ptr_dest], buffer[ptr_buffer+1], i);
                ptr_buffer += 2;
                ptr_dest += i;
            }
            else
               vscreen[no_vscr_dest][ptr_dest++] = buffer[ptr_buffer++];
        }
    }
    free(buffer);
    fclose(f);
    return 0;
}*/

/*
 * load_gif: charge un fichier GIF dans un buffer
 *           Renvoie:  0 = OK
 *                    -1 = fichier non trouve
 *                    -2 = le fichier n'est pas un GIF 320*200*256 valide
 *                    -3 = pas assez de memoire
 */

int load_gif(unsigned char *nom_gif, int no_vscr_dest)
{
    FILE            *f;
    #ifdef DATA_EXE
    long            pos_fichier;
    #endif
    unsigned char   buf[768];
    int             buf_cnt;
    int             buf_idx;
    unsigned char   stack[4096];
    int             prefix[4096];
    int             extnsn[4096];
    int             stack_ptr;
    int             work_bits;
    long            work_data;
    int             root_size;
    int             code_size;
    int             code_mask;
    int             prev_code;
    int             table_size;
    int             i, ptr_dest;
    int             code, code2, first, place;

    #ifdef DATA_EXE
    if ((f = fopen(argv0, "rb")) == NULL)
        return -1;
    pos_fichier = position_fichier(nom_gif);
    fseek(f, -pos_fichier+13, SEEK_END);
    #else
    unsigned char   nom_complet[256];

    sprintf(nom_complet, "%s%s", PATH_GFX, nom_gif);

    if ((f = fopen(nom_complet, "rb")) == NULL)
        return -1;
    fseek(f, 13, SEEK_SET);
    #endif
    fread(&palette, 1, 768, f);
    for (i = 0; i < 768; i++) palette[i] >>= 2;
    fread(buf, 1, 1, f);
    fread(buf, 1, 9, f);
    ptr_dest = 0;
    stack_ptr = 0;
    work_bits = 0;
    work_data = 0;
    fread(buf, 1, 1, f);
    root_size = buf[0];
    code_size = root_size+1;
    code_mask = (1 << code_size)-1;
    buf_cnt = 0;
    buf_idx = 0;
    prev_code = GIF_NULL_CODE;
    table_size = GIF_EOF_CODE+1;
    for (i = 0; i < 4096; i++)
    {
        prefix[i] = GIF_NULL_CODE;
        extnsn[i] = i;
    }
    for (i = 0; i < 320*200; i++)
    {
        while (stack_ptr == 0)
        {
            while (work_bits < code_size)
            {
                if (buf_idx == buf_cnt)
                {
                    fread(buf, 1, 1, f);
                    buf_cnt = (int)buf[0];
                    fread(buf, 1, buf_cnt, f);
                    buf_idx = 0;
                }
                work_data |= ((long) buf[buf_idx++]) << work_bits;
                work_bits += 8;
            }
            code = work_data & code_mask;
            work_data >>= code_size;
            work_bits -= code_size;

            if (code == GIF_CLEAR_CODE)
            {
                code_size = root_size+1;
                code_mask = (1 << code_size)-1;
                prev_code = GIF_NULL_CODE;
                table_size = GIF_EOF_CODE+1;
            }
            else
                if (code == GIF_EOF_CODE)
                {
                    fclose(f);
                    return -2;
                }
                else
                    if (prev_code == GIF_NULL_CODE)
                    {
                        code2 = code;
                        while (prefix[code2] != GIF_NULL_CODE)
                        {
                            stack[stack_ptr++] = extnsn[code2];
                            code2 = prefix[code2];
                        }
                        stack[stack_ptr++] = extnsn[code2];
                        prev_code = code;
                    }
                    else
                    {
                        if (code < table_size)
                        {
                            code2 = code;
                            while (prefix[code2] != GIF_NULL_CODE)
                            {
                                stack[stack_ptr++] = extnsn[code2];
                                code2 = prefix[code2];
                            }
                            stack[stack_ptr++] = extnsn[code2];
                            first = extnsn[code2];
                        }
                        else
                        {
                            place = stack_ptr;
                            stack[stack_ptr++] = GIF_NULL_CODE;

                            code2 = prev_code;
                            while (prefix[code2] != GIF_NULL_CODE)
                            {
                                stack[stack_ptr++] = extnsn[code2];
                                code2 = prefix[code2];
                            }
                            stack[stack_ptr++] = extnsn[code2];
                            first = extnsn[code2];
                            stack[place] = first;
                        }

                        prefix[table_size] = prev_code;
                        extnsn[table_size] = first;
                        if ( (table_size == code_mask) && (code_size < 12) )
                        {
                            code_size++;
                            code_mask = (1 << code_size)-1;
                        }
                        table_size++;
                        prev_code = code;
                    }
        }
        #ifndef MSDOS
        if (X_Window)
        {
            XSetForeground(display, gc, xcolor[(int)stack[--stack_ptr]]);
            XDrawPoint(display, pixmap[no_vscr_dest], gc,
                ptr_dest%320, ptr_dest/320);
            ptr_dest++;
        }
        else
        #endif
            vscreen[no_vscr_dest][ptr_dest++] = (int)stack[--stack_ptr];
    }
    fclose(f);
    return 0;
}

/*
 * load_dat: charge un fichier GIF-DAT dans un buffer
 *           Renvoie:  0 = OK
 *                    -1 = fichier non trouve
 *                    -2 = le fichier n'est pas un GIF-DAT 320*200*256 valide
 *                    -3 = pas assez de memoire
 */

int load_dat(unsigned char *nom_dat, int no_vscr_dest)
{
    FILE            *f;
    #ifdef DATA_EXE
    long            pos_fichier;
    #endif
    unsigned char   buf[768];
    int             buf_cnt;
    int             buf_idx;
    unsigned char   stack[4096];
    int             prefix[4096];
    int             extnsn[4096];
    int             stack_ptr;
    int             work_bits;
    long            work_data;
    int             code_size;
    int             code_mask;
    int             prev_code;
    int             table_size;
    int             i, j, ptr_dest;
    int             code, code2, first, place;

    #ifdef DATA_EXE
    if ((f = fopen(argv0, "rb")) == NULL)
        return -1;
    pos_fichier = position_fichier(nom_dat);
    if (fseek(f, -position_fichier(nom_dat), SEEK_END) != 0)
        { fclose(f); return -2; }
    #else
    unsigned char   nom_complet[256];

    sprintf(nom_complet, "%s%s", PATH_GFX, nom_dat);

    if ((f = fopen(nom_complet, "rb")) == NULL)
        return -1;
    #endif
    fread(&palette, 1, 768, f);
    #ifndef MSDOS
    if (X_Window) setpal(palette);
    #endif
    ptr_dest = 0;
    stack_ptr = 0;
    work_bits = 0;
    work_data = 0;
    code_size = 8+1;
    code_mask = (1 << code_size)-1;
    buf_cnt = 0;
    buf_idx = 0;
    prev_code = GIF_NULL_CODE;
    table_size = GIF_EOF_CODE+1;
    for (i = 0; i < 4096; i++)
    {
        prefix[i] = GIF_NULL_CODE;
        extnsn[i] = i;
    }
    for (i = 0; i < 320*200; i++)
    {
        while (stack_ptr == 0)
        {
            while (work_bits < code_size)
            {
                if (buf_idx == buf_cnt)
                {
                    fread(buf, 1, 1, f);
                    buf_cnt = (int)(buf[0]^0xFE);
                    fread(buf, 1, buf_cnt, f);
                    for (j = 0; j < buf_cnt; j++)
                        buf[j] ^= 0xFE;
                    buf_idx = 0;
                }
                work_data |= ((long) buf[buf_idx++]) << work_bits;
                work_bits += 8;
            }
            code = work_data & code_mask;
            work_data >>= code_size;
            work_bits -= code_size;

            if (code == GIF_CLEAR_CODE)
            {
                code_size = 8+1;
                code_mask = (1 << code_size)-1;
                prev_code = GIF_NULL_CODE;
                table_size = GIF_EOF_CODE+1;
            }
            else
                if (code == GIF_EOF_CODE)
                {
                    fclose(f);
                    return -2;
                }
                else
                    if (prev_code == GIF_NULL_CODE)
                    {
                        code2 = code;
                        while (prefix[code2] != GIF_NULL_CODE)
                        {
                            stack[stack_ptr++] = extnsn[code2];
                            code2 = prefix[code2];
                        }
                        stack[stack_ptr++] = extnsn[code2];
                        prev_code = code;
                    }
                    else
                    {
                        if (code < table_size)
                        {
                            code2 = code;
                            while (prefix[code2] != GIF_NULL_CODE)
                            {
                                stack[stack_ptr++] = extnsn[code2];
                                code2 = prefix[code2];
                            }
                            stack[stack_ptr++] = extnsn[code2];
                            first = extnsn[code2];
                        }
                        else
                        {
                            place = stack_ptr;
                            stack[stack_ptr++] = GIF_NULL_CODE;

                            code2 = prev_code;
                            while (prefix[code2] != GIF_NULL_CODE)
                            {
                                stack[stack_ptr++] = extnsn[code2];
                                code2 = prefix[code2];
                            }
                            stack[stack_ptr++] = extnsn[code2];
                            first = extnsn[code2];
                            stack[place] = first;
                        }

                        prefix[table_size] = prev_code;
                        extnsn[table_size] = first;
                        if ( (table_size == code_mask) && (code_size < 12) )
                        {
                            code_size++;
                            code_mask = (1 << code_size)-1;
                        }
                        table_size++;
                        prev_code = code;
                    }
        }
        #ifndef MSDOS
        if (X_Window)
        {
            XSetForeground(display, gc, xcolor[(int)stack[--stack_ptr]]);
            XDrawPoint(display, pixmap[no_vscr_dest], gc,
                ptr_dest%320, ptr_dest/320);
            ptr_dest++;
        }
        else
        #endif
            vscreen[no_vscr_dest][ptr_dest++] = (int)stack[--stack_ptr];
    }
    fclose(f);
    return 0;
}

/* ==========================================================================
                               GESTION DES SPRITES
   ========================================================================== */

/*
 * getsprite: met en memoire (dans un t_sprite) une portion d'image de l'ecran
 *            (reel ou virtuel)
 */

void getsprite(int no_vscr, int x, int y, int lx, int ly, t_sprite *spr)
{
    int     i, j;

    spr->s_lx = lx;
    spr->s_ly = ly;
    #ifndef MSDOS
    if (X_Window)
    {
        if (no_vscr == ECRAN_REEL)
            spr->s_ximage = XGetImage(display, pixmap_save, x, y, lx, ly,
                0xFFFF, ZPixmap);
        else
            spr->s_ximage = XGetImage(display, pixmap[no_vscr], x, y, lx, ly,
                0xFFFF, ZPixmap);
        spr->s_ptr = (unsigned char *)ftris_malloc(lx*ly, "a sprite");
        for (i = 0; i < lx; i++)
            for (j = 0; j < ly; j++)
                spr->s_ptr[i+j*lx] = XGetPixel(spr->s_ximage, i, j);
    }
    else
    #endif
    {
        spr->s_ptr = (unsigned char *)ftris_malloc(lx*ly, "a sprite");
        for (i = 0; i < lx; i++)
            for (j = 0; j < ly; j++)
                spr->s_ptr[i+j*lx] = getpixel_ofs(no_vscr, x+i+(y+j)*scr_nbx);
        /* ancien getsprite:
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%ds\n"
            #endif
            "movl %0, %%esi\n
            movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %1\n
            addl %%eax, %%esi\n
            movl %4, %%edi\n
            movl %2, %%eax\n
            movl %3, %%edx\n"
            #ifdef MSDOS
            "movw _g_select, %%ds\n
            addl $0xA0000, %%esi\n"
            #else
            "addl adr_ecran, %%esi\n"
            #endif
            "movl %%esi, %%ebx\n
        getsprite_ligne:
            movl %%eax, %%ecx\n
            rep\n
            movsb\n
            addl $320, %%ebx\n
            movl %%ebx, %%esi\n
            decl %%edx\n
            jnz  getsprite_ligne\n"
            #ifdef MSDOS
            "pop  %%ds"
            #endif
            :
            : "g" (x), "g" (y), "g" (lx), "g" (ly), "g" (spr->s_ptr)
            : "eax", "ebx", "ecx", "edx", "esi", "edi"
        );*/
        /* ancien getsprite_vs:
        __asm__ __volatile__ ("
            movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %1\n
            movl %5, %%esi\n
            addl %0, %%esi\n
            addl %%eax, %%esi\n
            movl %%esi, %%ebx\n
            movl %4, %%edi\n
            movl %2, %%eax\n
            movl %3, %%edx\n
        getsprite_vs_ligne:
            movl %%eax, %%ecx\n
            rep\n
            movsb\n
            addl $320, %%ebx\n
            movl %%ebx, %%esi\n
            decl %%edx\n
            jnz  getsprite_vs_ligne"
            :
            : "g" (x), "g" (y), "g" (lx), "g" (ly), "g" (spr->s_ptr), "g" (vscr)
            : "eax", "ebx", "ecx", "edx", "esi", "edi"
        );*/

    }
}

/*
 * replacesprite: remplace le contenu d'un sprite en copiant depuis l'ecran
 *                (reel ou virtuel)
 */

void replacesprite(int no_vscr, int x, int y, t_sprite *spr)
{
    int     i, j;

    #ifndef MSDOS
    if (X_Window)
    {
        XDestroyImage(spr->s_ximage);
        if (no_vscr == ECRAN_REEL)
            spr->s_ximage = XGetImage(display, pixmap_save, x, y,
                spr->s_lx, spr->s_ly, 0xFFFF, ZPixmap);
        else
            spr->s_ximage = XGetImage(display, pixmap[no_vscr], x, y,
                spr->s_lx, spr->s_ly, 0xFFFF, ZPixmap);
        for (i = 0; i < spr->s_lx; i++)
            for (j = 0; j < spr->s_ly; j++)
                spr->s_ptr[i+j*spr->s_lx] = XGetPixel(spr->s_ximage, i, j);
    }
    else
    #endif
    {
        for (i = 0; i < spr->s_lx; i++)
            for (j = 0; j < spr->s_ly; j++)
                spr->s_ptr[i+j*spr->s_lx] = getpixel_ofs(no_vscr, x+i+(y+j)*scr_nbx);
    }
}

/*
 * putsprite: affiche un sprite a l'ecran reel ou dans un ecran virtuel
 */

void putsprite(int no_vscr, t_sprite *spr, int x, int y)
{
    int             lx, ly;
    unsigned char   *vscr;
    #ifndef MSDOS
    int             j, ofs, ofs_spr;
    #endif

    lx = spr->s_lx;
    ly = spr->s_ly;
    if (no_vscr == ECRAN_REEL)
    {
        #ifndef MSDOS
        if (X_Window)
        {
            XPutImage(display, pixmap_save, gc, spr->s_ximage, 0, 0, x, y, lx, ly);
            XPutImage(display, window, gc, spr->s_ximage, 0, 0, x, y, lx, ly);
        }
        else
        {
            ofs = y*scr_nbx+x;
            ofs_spr = 0;
            for (j = 0; j < ly; j++)
            {
                memcpy(adr_ecran+ofs, spr->s_ptr+ofs_spr, lx);
                ofs += scr_nbx;
                ofs_spr += lx;
            }
        }
        #else
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%es\n"
            #endif
            "movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %1\n
            movl %4, %%esi\n"
            #ifdef MSDOS
            "movw _g_select, %%es\n
            movl $0xA0000, %%edi\n"
            #else
            "movl adr_ecran, %%edi\n"
            #endif
            "addl %0, %%edi\n
            addl %%eax, %%edi\n
            movl %%edi, %%ebx\n
            movl %2, %%eax\n
            movl %3, %%edx\n
        boucle_putspr:
            movl %%eax, %%ecx\n
            rep\n
            movsb\n
            addl $320, %%ebx\n
            movl %%ebx, %%edi\n
            decl %%edx\n
            jnz  boucle_putspr\n"
            #ifdef MSDOS
            "pop  %%es"
            #endif
            :
            : "g" (x), "g" (y), "g" (lx), "g" (ly), "g" (spr->s_ptr)
            : "eax", "ebx", "ecx", "edx", "esi", "edi"
        );
        #endif
    }
    else
    {
        #ifndef MSDOS
        if (X_Window)
        {
            XPutImage(display, pixmap[no_vscr], gc, spr->s_ximage, 0, 0, x, y, lx, ly);
        }
        else
        {
            ofs = y*scr_nbx+x;
            ofs_spr = 0;
            vscr = vscreen[no_vscr];
            for (j = 0; j < ly; j++)
            {
                memcpy(vscr+ofs, spr->s_ptr+ofs_spr, lx);
                ofs += scr_nbx;
                ofs_spr += lx;
            }
        }
        #else
        {
            vscr = vscreen[no_vscr];
            __asm__ __volatile__ (
                "movl $320, %%eax\n
                xorl %%edx, %%edx\n
                mull %2\n
                movl %5, %%esi\n
                movl %0, %%edi\n
                addl %1, %%edi\n
                addl %%eax, %%edi\n
                movl %%edi, %%ebx\n
                movl %3, %%eax\n
                movl %4, %%edx\n
            boucle_putspr_v:
                movl %%eax, %%ecx\n
                rep\n
                movsb\n
                addl $320, %%ebx\n
                movl %%ebx, %%edi\n
                decl %%edx\n
                jnz  boucle_putspr_v"
                :
                : "g" (vscr), "g" (x), "g" (y), "g" (lx), "g" (ly), "g" (spr->s_ptr)
                : "eax", "ebx", "ecx", "edx", "esi", "edi"
            );
        }
        #endif
    }
}

/*
 * putsprite_tr: affiche un sprite a l'ecran avec transparence
 */

void putsprite_tr(t_sprite *spr, int x, int y)
{
    int     lx, ly;
    #ifndef MSDOS
    int     i, j, ofs, ofs_spr, coul;
    #endif

    lx = spr->s_lx;
    ly = spr->s_ly;
    #ifndef MSDOS
    if (X_Window)
    {
        /*  gerer la transparence !!!!  */
        /*XPutImage(display, pixmap_save, gc, spr->s_ximage, 0, 0, x, y,
            spr->s_lx, spr->s_ly);*/
        for (i = 0; i < lx; i++)
            for (j = 0; j < ly; j++)
            {
                coul = spr->s_ptr[i+(j*lx)];
                if (coul != 0)
                {
                    XSetForeground(display, gc, xcolor[coul]);
                    XDrawPoint(display, pixmap_save, gc, x+i, y+j);
                    XDrawPoint(display, window, gc, x+i, y+j);
                }
            }
    }
    else
    {
        ofs = y*scr_nbx+x;
        ofs_spr = 0;
        for (j = 0; j < ly; j++)
        {
            for (i = 0; i < lx; i++)
            {
                if (spr->s_ptr[ofs_spr] != 0)
                    adr_ecran[ofs+i] = spr->s_ptr[ofs_spr];
                ofs_spr++;
            }
            ofs += scr_nbx;
        }
    }
    #else
    __asm__ __volatile__ (
        #ifdef MSDOS
        "push %%es\n"
        #endif
        "movl $320, %%eax\n
        xorl %%edx, %%edx\n
        mull %1\n
        movl %4, %%esi\n"
        #ifdef MSDOS
        "movw _g_select, %%es\n
        movl $0xA0000, %%edi\n"
        #else
        "movl adr_ecran, %%edi\n"
        #endif
        "addl %0, %%edi\n
        addl %%eax, %%edi\n
        movl %%edi, %%ebx\n
        movl %2, %%eax\n
        movl %3, %%edx\n
    boucle_putspr_tr:
        movl %%eax, %%ecx\n
    putspr_tr_col:
        cmpb $0, (%%esi)\n
        jz putspr_tr_pas_touche\n
        movsb\n
        jmp putspr_tr_apres_test\n
    putspr_tr_pas_touche:
        incl %%esi\n
        incl %%edi\n
    putspr_tr_apres_test:
        decl %%ecx\n
        jnz putspr_tr_col\n
        addl $320, %%ebx\n
        movl %%ebx, %%edi\n
        decl %%edx\n
        jnz  boucle_putspr_tr\n"
        #ifdef MSDOS
        "pop  %%es"
        #endif
        :
        : "g" (x), "g" (y), "g" (lx), "g" (ly), "g" (spr->s_ptr)
        : "eax", "ebx", "ecx", "edx", "esi", "edi"
    );
    #endif
}

/*
 * putsprite_tr_fond: affiche un sprite a l'ecran avec transparence en prenant
 *                    le fond dans un ecran virtuel
 */

void putsprite_tr_fond(int no_vscr_fond, t_sprite *spr, int x, int y)
{
    int     lx, ly;
    int     i, j;
    #ifndef MSDOS
    int     coul;
    #endif

    lx = spr->s_lx;
    ly = spr->s_ly;
    #ifndef MSDOS
    if (X_Window)
    {
        /*  gerer la transparence !!!!  */
        /*XPutImage(display, pixmap_save, gc, spr->s_ximage, 0, 0, x, y,
            spr->s_lx, spr->s_ly);*/
        for (i = 0; i < lx; i++)
            for (j = 0; j < ly; j++)
            {
                coul = spr->s_ptr[i+j*lx];
                if (coul != 0)
                {
                    XSetForeground(display, gc, xcolor[coul]);
                    XDrawPoint(display, pixmap_save, gc, x+i, y+j);
                    XDrawPoint(display, window, gc, x+i, y+j);
                }
            }
    }
    else
    #endif
        for (i = 0; i < lx; i++)
            for (j = 0; j < ly; j++)
                if (spr->s_ptr[i+j*lx] == 0)
                    putpixel_ofs(ECRAN_REEL, x+i+(y+j)*scr_nbx,
                        vscreen[no_vscr_fond][x+i+(y+j)*scr_nbx]);
                else
                    putpixel_ofs(ECRAN_REEL, x+i+(y+j)*scr_nbx,
                        spr->s_ptr[i+j*lx]);
}

/*
 * putsprite_v_tr: affiche un sprite dans un ecran virtuel avec transparence
 */

void putsprite_v_tr(int no_vscr, t_sprite *spr, int x, int y)
{
    int             lx, ly;
    unsigned char   *vscr;
    #ifndef MSDOS
    int             i, j, ofs, ofs_spr, coul;
    #endif

    lx = spr->s_lx;
    ly = spr->s_ly;
    #ifndef MSDOS
    if (X_Window)
    {
        for (i = 0; i < lx; i++)
            for (j = 0; j < ly; j++)
            {
                coul = spr->s_ptr[i+(j*lx)];
                if (coul != 0)
                {
                    XSetForeground(display, gc, xcolor[coul]);
                    XDrawPoint(display, pixmap[no_vscr], gc, x+i, y+j);
                }
            }
    }
    else
    {
        ofs = y*scr_nbx+x;
        ofs_spr = 0;
        vscr = vscreen[no_vscr];
        for (j = 0; j < ly; j++)
        {
            for (i = 0; i < lx; i++)
            {
                if (spr->s_ptr[ofs_spr] != 0)
                    vscr[ofs+i] = spr->s_ptr[ofs_spr];
                ofs_spr++;
            }
            ofs += scr_nbx;
        }
    }
    #else
    {
        vscr = vscreen[no_vscr];
        __asm__ __volatile__ ("
            movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %2\n
            movl %5, %%esi\n
            movl %0, %%edi\n
            addl %1, %%edi\n
            addl %%eax, %%edi\n
            movl %%edi, %%ebx\n
            movl %3, %%eax\n
            movl %4, %%edx\n
        boucle_putspr_v_tr:
            movl %%eax, %%ecx\n
        putspr_v_tr_col:
            cmpb $0, (%%esi)\n
            jz putspr_v_tr_pas_touche\n
            movsb\n
            jmp putspr_v_tr_apres_test\n
        putspr_v_tr_pas_touche:
            incl %%esi\n
            incl %%edi\n
        putspr_v_tr_apres_test:
            decl %%ecx\n
            jnz putspr_v_tr_col\n
            addl $320, %%ebx\n
            movl %%ebx, %%edi\n
            decl %%edx\n
            jnz  boucle_putspr_v_tr"
            :
            : "g" (vscr), "g" (x), "g" (y), "g" (lx), "g" (ly), "g" (spr->s_ptr)
            : "eax", "ebx", "ecx", "edx", "esi", "edi"
        );
    }
    #endif
}

/*
 * putsprite_clip: affiche un sprite a l'ecran en le coupant
 */

void putsprite_clip(int no_vscr, t_sprite *spr, int x, int y,
                    int skipx, int skipy, int nbx, int nby)
{
    unsigned char   *ptr_debut, *vscr;
    int             add_ligne, lx, ly;
    #ifndef MSDOS
    int             j, ofs, ofs_spr;
    #endif

    lx = spr->s_lx;
    ly = spr->s_ly;
    ptr_debut = spr->s_ptr+((skipy*(spr->s_lx))+skipx);
    add_ligne = (spr->s_lx)-nbx;
    if (no_vscr == ECRAN_REEL)
    {
        #ifndef MSDOS
        if (X_Window)
        {
            /*  A TESTER  */
            XPutImage(display, pixmap_save, gc, spr->s_ximage,
                skipx, skipy, x, y, nbx, nby);
            XPutImage(display, window, gc, spr->s_ximage,
                skipx, skipy, x, y, nbx, nby);
        }
        else
        {
            ofs = (y+skipy)*scr_nbx+x+skipx;
            ofs_spr = skipy*ly+skipx;
            for (j = skipy; j < nby; j++)
            {
                memcpy(adr_ecran+ofs, spr->s_ptr+ofs_spr, nbx);
                ofs += scr_nbx;
                ofs_spr += lx;
            }
        }
        #else
        {
            __asm__ __volatile__ (
                #ifdef MSDOS
                "push %%es\n"
                #endif
                "movl $320, %%eax\n
                xorl %%edx, %%edx\n
                mull %1\n
                movl %5, %%esi\n"
                #ifdef MSDOS
                "movw _g_select, %%es\n
                movl $0xA0000, %%edi\n"
                #else
                "movl adr_ecran, %%edi\n"
                #endif
                "addl %0, %%edi\n
                addl %%eax, %%edi\n
                movl %%edi, %%ebx\n
                movl %3, %%eax\n
                movl %4, %%edx\n
            boucle_putspr_c:
                movl %%eax, %%ecx\n
                rep\n
                movsb\n
                addl $320, %%ebx\n
                movl %%ebx, %%edi\n
                addl %2, %%esi\n
                decl %%edx\n
                jnz  boucle_putspr_c\n"
                #ifdef MSDOS
                "pop  %%es"
                #endif
                :
                : "g" (x), "g" (y), "g" (add_ligne), "g" (nbx), "g" (nby),
                  "g" (ptr_debut)
                : "eax", "ebx", "ecx", "edx", "esi", "edi"
            );
        }
        #endif
    }
    else
    {
        #ifndef MSDOS
        if (X_Window)
        {
            /*  A TESTER  */
            XPutImage(display, pixmap[no_vscr], gc, spr->s_ximage,
                skipx, skipy, x, y, nbx, nby);
        }
        else
        {
            ofs = (y+skipy)*scr_nbx+x+skipx;
            ofs_spr = skipy*ly+skipx;
            vscr = vscreen[no_vscr];
            for (j = skipy; j < nby; j++)
            {
                memcpy(vscr+ofs, spr->s_ptr+ofs_spr, nbx);
                ofs += scr_nbx;
                ofs_spr += lx;
            }
        }
        #else
        {
            vscr = vscreen[no_vscr];
            __asm__ __volatile__ (
                "movl $320, %%eax\n
                xorl %%edx, %%edx\n
                mull %2\n
                movl %6, %%esi\n
                movl %0, %%edi\n
                addl %1, %%edi\n
                addl %%eax, %%edi\n
                movl %%edi, %%ebx\n
                movl %4, %%eax\n
                movl %5, %%edx\n
            boucle_putspr_v_c:
                movl %%eax, %%ecx\n
                rep\n
                movsb\n
                addl $320, %%ebx\n
                movl %%ebx, %%edi\n
                addl %3, %%esi\n
                decl %%edx\n
                jnz  boucle_putspr_v_c"
                :
                : "g" (vscr), "g" (x), "g" (y), "g" (add_ligne), "g" (nbx), "g" (nby),
                  "g" (ptr_debut)
                : "eax", "ebx", "ecx", "edx", "esi", "edi"
            );
        }
        #endif
    }
}

/*
 * getpixel_ofs_sprite: renvoie la valeur d'un pixel d'un sprite
 */

unsigned long getpixel_ofs_sprite(t_sprite *spr, int ofs)
{
    #ifndef MSDOS
    if (X_Window)
        return XGetPixel(spr->s_ximage, ofs%spr->s_lx, ofs/spr->s_ly);
    else
    #endif
        return spr->s_ptr[ofs];
}

/*
 * getpixel_xy_sprite: renvoie la valeur d'un pixel d'un sprite
 */

unsigned long getpixel_xy_sprite(t_sprite *spr, int x, int y)
{
    #ifndef MSDOS
    if (X_Window)
        return XGetPixel(spr->s_ximage, x, y);
    else
    #endif
        return spr->s_ptr[x+y*spr->s_lx];
}

/*
 * putpixel_ofs_sprite: modifie la couleur d'un pixel d'un sprite
 */

void putpixel_ofs_sprite(t_sprite *spr, int ofs, unsigned long couleur)
{
    #ifndef MSDOS
    if (X_Window)
        XPutPixel(spr->s_ximage, ofs%spr->s_lx, ofs/spr->s_lx, couleur);
    else
    #endif
        spr->s_ptr[ofs] = (unsigned char)couleur;
}

/*
 * putpixel_xy_sprite: modifie la couleur d'un pixel d'un sprite
 */

void putpixel_xy_sprite(t_sprite *spr, int x, int y, unsigned long couleur)
{
    #ifndef MSDOS
    if (X_Window)
        XPutPixel(spr->s_ximage, x, y, couleur);
    else
    #endif
        spr->s_ptr[x+y*spr->s_lx] = (unsigned char)couleur;
}

/*
 * copy_v2s_xy: copie une portion d'un ecran virtuel vers l'ecran au meme endroit
 */

void copy_v2s_xy(int no_vscr, int x, int y, int lx, int ly)
{
    unsigned char   *vscr;
    #ifndef MSDOS
    int             j, ofs;
    #endif

    #ifndef MSDOS
    if (X_Window)
    {
        XCopyArea(display, pixmap[no_vscr], pixmap_save, gc, x, y, lx, ly, x, y);
        XCopyArea(display, pixmap[no_vscr], window, gc, x, y, lx, ly, x, y);
    }
    else
    {
        ofs = y*scr_nbx+x;
        vscr = vscreen[no_vscr];
        for (j = 0; j < ly; j++)
        {
            memcpy(adr_ecran+ofs, vscr+ofs, lx);
            ofs += scr_nbx;
        }
    }
    #else
    {
        vscr = vscreen[no_vscr];
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%es\n"
            #endif
            "movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %2\n"
            #ifdef MSDOS
            "movl %0, %%esi\n
            movw _g_select, %%es\n
            movl $0xA0000, %%edi\n"
            #else
            "movl %0, %%esi\n
            movl adr_ecran, %%edi\n"
            #endif
            "addl %1, %%esi\n
            addl %%eax, %%esi\n
            addl %1, %%edi\n
            addl %%eax, %%edi\n
            movl %%edi, %%ebx\n
            movl %3, %%eax\n
            movl %4, %%edx\n
            movl $320, %%ebx\n
            subl %3, %%ebx\n
        boucle_move_1:
            movl %%eax, %%ecx\n
            rep\n
            movsb\n
            addl %%ebx, %%esi\n
            addl %%ebx, %%edi\n
            decl %%edx\n
            jnz  boucle_move_1\n"
            #ifdef MSDOS
            "pop  %%es"
            #endif
            :
            : "g" (vscr), "g" (x), "g" (y), "g" (lx), "g" (ly)
            : "eax", "ebx", "ecx", "edx", "esi", "edi"
        );
    }
    #endif
}

/*
 * copy_v2v_xy: copie une portion de vscreen dans un autre vscreen
 */

void copy_v2v_xy(int no_vscr_source, int no_vscr_cible,
                 int x, int y, int lx, int ly)
{
    int     i;

    #ifndef MSDOS
    if (X_Window)
    {
        XCopyArea(display, pixmap[no_vscr_source], pixmap[no_vscr_cible],
            gc, x, y, lx, ly, x, y);
    }
    else
    #endif
        for (i = y; i < y+ly; i++)
            memcpy(vscreen[no_vscr_cible]+x+i*scr_nbx,
                vscreen[no_vscr_source]+x+i*scr_nbx, lx);
}

/*
 * copy_v2v_xy_xy: copie une portion de vscreen dans un autre vscreen
 */

void copy_v2v_xy_xy(int no_vscr_source, int no_vscr_cible,
                 int x, int y, int lx, int ly, int x2, int y2)
{
    int     i;

    #ifndef MSDOS
    if (X_Window)
    {
        XCopyArea(display, pixmap[no_vscr_source], pixmap[no_vscr_cible],
            gc, x, y, lx, ly, x2, y2);
    }
    else
    #endif
        for (i = y; i < y+ly; i++)
            memcpy(vscreen[no_vscr_cible]+x2+(i-y+y2)*scr_nbx,
                vscreen[no_vscr_source]+x+i*scr_nbx, lx);
}

/*
 * copy_v2s_xy_xy: copie une portion de vscreen dans l'ecran
 *                 a une position differente
 */

void copy_v2s_xy_xy(int no_vscr, int x, int y, int lx, int ly, int x2, int y2)
{
    unsigned char   *vscr;
    #ifndef MSDOS
    int             j, ofs, ofs2;
    #endif

    #ifndef MSDOS
    if (X_Window)
    {
        XCopyArea(display, pixmap[no_vscr], pixmap_save, gc, x, y, lx, ly, x2, y2);
        XCopyArea(display, pixmap[no_vscr], window, gc, x, y, lx, ly, x2, y2);
    }
    else
    {
        ofs = y*scr_nbx+x;
        ofs2 = y2*scr_nbx+x2;
        vscr = vscreen[no_vscr];
        for (j = 0; j < ly; j++)
        {
            memcpy(adr_ecran+ofs2, vscr+ofs, lx);
            ofs += scr_nbx;
            ofs2 += scr_nbx;
        }
    }
    #else
    {
        vscr = vscreen[no_vscr];
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%es\n"
            #endif
            "movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %2\n"
            #ifdef MSDOS
            "movl %0, %%esi\n
            movw _g_select, %%es\n
            movl $0xA0000, %%edi\n"
            #else
            "movl %0, %%esi\n
            movl adr_ecran, %%edi\n"
            #endif
            "addl %1, %%esi\n
            addl %%eax, %%esi\n
            movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %6\n
            addl %5, %%edi\n
            addl %%eax, %%edi\n
            movl %%edi, %%ebx\n
            movl %3, %%eax\n
            movl %4, %%edx\n
            movl $320, %%ebx\n
            subl %3, %%ebx\n
        boucle_move_2:
            movl %%eax, %%ecx\n
            rep\n
            movsb\n
            addl %%ebx, %%esi\n
            addl %%ebx, %%edi\n
            decl %%edx\n
            jnz  boucle_move_2\n"
            #ifdef MSDOS
            "pop  %%es"
            #endif
            :
            : "g" (vscr), "g" (x), "g" (y), "g" (lx), "g" (ly), "g" (x2), "g" (y2)
            : "eax", "ebx", "ecx", "edx", "esi", "edi"
        );
    }
    #endif
}

/*
 * copy_v2s: copie un vscreen complet dans l'ecran
 */

void copy_v2s(int no_vscr)
{
    #ifdef MSDOS
    unsigned char   *vscr;
    #endif

    #ifndef MSDOS
    if (X_Window)
    {
        XCopyArea(display, pixmap[no_vscr], pixmap_save, gc, 0, 0,
            scr_nbx, scr_nby, 0, 0);
        XCopyArea(display, pixmap[no_vscr], window, gc, 0, 0,
            scr_nbx, scr_nby, 0, 0);
    }
    else
        memcpy_rapide(adr_ecran, vscreen[no_vscr], (scr_nbx*scr_nby)>>2);
    #else
    {
        vscr = vscreen[no_vscr];
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%es\n
            movl %0, %%esi\n
            movw _g_select, %%es\n
            movl $0xA0000, %%edi\n"
            #else
            "movl %0, %%esi\n
            movl adr_ecran, %%edi\n"
            #endif
            "movl $16000, %%ecx\n
            rep\n
            movsl\n"
            #ifdef MSDOS
            "pop  %%es"
            #endif
            :
            : "g" (vscr)
            : "ecx", "esi", "edi"
        );
    }
    #endif
}

/*
 * copy_s2v: copie l'ecran complet dans vscreen
 */

void copy_s2v(int no_vscr)
{
    #ifdef MSDOS
    unsigned char   *vscr;
    #endif

    #ifndef MSDOS
    if (X_Window)
        XCopyArea(display, pixmap_save, pixmap[no_vscr], gc, 0, 0,
            scr_nbx, scr_nby, 0, 0);
    else
        memcpy_rapide(vscreen[no_vscr], adr_ecran, (scr_nbx*scr_nby)>>2);
    #else
    {
        vscr = vscreen[no_vscr];
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%ds\n
            movl %0, %%edi\n
            movw _g_select, %%ds\n
            movl $0xA0000, %%esi\n"
            #else
            "movl %0, %%edi\n
            movl adr_ecran, %%esi\n"
            #endif
            "movl $16000, %%ecx\n
            rep\n
            movsl\n"
            #ifdef MSDOS
            "pop  %%ds"
            #endif
            :
            : "g" (vscr)
            : "ecx", "esi", "edi"
        );
    }
    #endif
}

/*
 * copy_s2v_xy: copie une portion d'un ecran virtuel vers l'ecran au meme endroit
 */

void copy_s2v_xy(int no_vscr, int x, int y, int lx, int ly)
{
    unsigned char   *vscr;
    #ifndef MSDOS
    int             j, ofs;
    #endif

    #ifndef MSDOS
    if (X_Window)
    {
        XCopyArea(display, pixmap_save, pixmap[no_vscr], gc, x, y, lx, ly, x, y);
    }
    else
    {
        ofs = y*scr_nbx+x;
        vscr = vscreen[no_vscr];
        for (j = 0; j < ly; j++)
        {
            memcpy(vscr+ofs, adr_ecran+ofs, lx);
            ofs += scr_nbx;
        }
    }
    #else
    {
        vscr = vscreen[no_vscr];
        __asm__ __volatile__ (
            #ifdef MSDOS
            "push %%ds\n"
            #endif
            "movl $320, %%eax\n
            xorl %%edx, %%edx\n
            mull %2\n"
            #ifdef MSDOS
            "movl %0, %%edi\n
            movw _g_select, %%ds\n
            movl $0xA0000, %%esi\n"
            #else
            "movl %0, %%edi\n
            movl adr_ecran, %%esi\n"
            #endif
            "addl %1, %%esi\n
            addl %%eax, %%esi\n
            addl %1, %%edi\n
            addl %%eax, %%edi\n
            movl %%edi, %%ebx\n
            movl %3, %%eax\n
            movl %4, %%edx\n
            movl $320, %%ebx\n
            subl %3, %%ebx\n
        boucle_move_3:
            movl %%eax, %%ecx\n
            rep\n
            movsb\n
            addl %%ebx, %%esi\n
            addl %%ebx, %%edi\n
            decl %%edx\n
            jnz  boucle_move_3\n"
            #ifdef MSDOS
            "pop  %%ds"
            #endif
            :
            : "g" (vscr), "g" (x), "g" (y), "g" (lx), "g" (ly)
            : "eax", "ebx", "ecx", "edx", "esi", "edi"
        );
    }
    #endif
}

/*
 * copy_v2v: copie un ecran virtuel dans un autre
 */

void copy_v2v(int no_vscr_source, int no_vscr_cible)
{
    #ifndef MSDOS
    if (X_Window)
    {
        XCopyArea(display, pixmap[no_vscr_source], pixmap[no_vscr_cible],
            gc, 0, 0, scr_nbx, scr_nby, 0, 0);
    }
    else
    #endif
        memcpy_rapide(vscreen[no_vscr_cible], vscreen[no_vscr_source], (scr_nbx*scr_nby)>>2);
}

/*
 * copy_buf2s: copie un buffer vers l'ecran
 */

void copy_buf2s(unsigned char *buffer, int x, int y, int nombre)
{
    #ifndef MSDOS
    int     i;
    #endif

    #ifndef MSDOS
    if (X_Window)
    {
        for (i = 0; i < nombre; i++)
        {
            XSetForeground(display, gc, xcolor[buffer[i]]);
            XDrawPoint(display, pixmap_save, gc, x, y);
            XDrawPoint(display, window, gc, x, y);
            x++;
            if (x >= scr_nbx)
            {
                x = 0;
                y++;
            }
        }
    }
    else
    {
        for (i = 0; i < nombre; i++)
        {
            adr_ecran[y*scr_nbx+x] = buffer[i];
            x++;
            if (x >= scr_nbx)
            {
                x = 0;
                y++;
            }
        }
    }
    #else
    __asm__ __volatile__ (
        #ifdef MSDOS
        "push %%es\n"
        #endif
        "movl $320, %%eax\n
        xorl %%edx, %%edx\n
        mull %2\n"
        #ifdef MSDOS
        "movl %0, %%esi\n
        movw _g_select, %%es\n
        movl $0xA0000, %%edi\n"
        #else
        "movl %0, %%esi\n
        movl adr_ecran, %%edi\n"
        #endif
        "addl %1, %%edi\n
        addl %%eax, %%edi\n
        movl %3, %%ecx\n
        rep\n
        movsb\n"
        #ifdef MSDOS
        "pop  %%es"
        #endif
        :
        : "g" (buffer), "g" (x), "g" (y), "g" (nombre)
        : "eax", "ecx", "edx", "esi", "edi"
    );
    #endif
}

/*
 *  efface_ecran_mosaique: efface l'ecran avec effet de mosaique
 *                         (fait disparaitre des carres les uns apres les autres)
 *                         !!! scr_nbx doit etre un multiple de nbx
 *                         !!! scr_nby doit etre un multiple de nby
 */

void efface_ecran_mosaique(int no_vscr, int tab_mosaique[][2],
                           int nbx, int nby, int nb_wait)
{
    int     i, x, y, largeur, hauteur;

    largeur = scr_nbx/nbx;
    hauteur = scr_nby/nby;
    for (i = 0; i < nbx*nby; i++)
    {
        x = tab_mosaique[i][0]*largeur;
        y = tab_mosaique[i][1]*hauteur;
        fill_rectangle(no_vscr, x, y, x+largeur-1, y+hauteur-1, 0);
        if (i%nb_wait == 0)
            waitretrace();
    }
}

/*
 * affiche_ecran_mosaique: affiche l'ecran avec effet de mosaique
 *                         (fait apparaitre des carres les uns apres les autres)
 *                         !!! scr_nbx doit etre un multiple de nbx
 *                         !!! scr_nby doit etre un multiple de nby
 */

void affiche_ecran_mosaique(int no_vscr, int tab_mosaique[][2],
                            int nbx, int nby, int nb_wait)
{
    int     i, x, y, largeur, hauteur;

    largeur = scr_nbx/nbx;
    hauteur = scr_nby/nby;
    for (i = 0; i < nbx*nby; i++)
    {
        x = tab_mosaique[i][0]*largeur;
        y = tab_mosaique[i][1]*hauteur;
        copy_v2s_xy(no_vscr, x, y, largeur, hauteur);
        if (i%nb_wait == 0)
            waitretrace();
    }
}

/*
 * affiche_ecran_vers_centre: affiche l'ecran avec la moitie superieure qui
 *                            descend depuis le haut et la moitie inferieure
 *                            qui monte depuis le bas de l'ecran
 */

void affiche_ecran_vers_centre(int no_vscr, int nb_wait)
{
    int     i, centre;

    centre = scr_nby/2;
    for (i = 0; i < centre; i++)
    {
        copy_v2s_xy_xy(no_vscr, 0, centre-i, scr_nbx, i+1, 0, 0);
        copy_v2s_xy_xy(no_vscr, 0, centre+1, scr_nbx, i+1, 0, scr_nby-i);
        if (i%nb_wait == 0)
            waitretrace();
    }
    copy_v2s(no_vscr);
}

/* ==========================================================================
                      AFFICHAGE DE TEXTE EN MODE GRAPHIQUE
   ========================================================================== */

/*
 * write_xy_c: ecrit une chaine de caracteres en mode graphique
 *             ** Couleur avec degrade
 */

void write_xy_c(int no_vscr, int x, int y, int couleur, int inc_coul,
                unsigned char *chaine, ...)
{
    int             i, j, k, ofs;
    unsigned char   buffer[100];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    /*  X-Window : */
    /*XSetForeground(display, gc, xcolor[couleur]);
    XDrawString(display, window, gc, x, y, buffer, strlen(buffer));*/
    ofs = x+(y*scr_nbx);
    for (i = 0; i < strlen(buffer); i++)
    {
        for (j = 0; j < 8; j++)
            for (k = 0; k < 8; k++)
                if ( (fonte[buffer[i]][j] & (128 >> k)) != 0)
                    putpixel_ofs(no_vscr, ofs+(j*scr_nbx)+k, couleur+j*inc_coul);
        ofs += 9;
    }
}

/*
 * write_xy_c_f: ecrit une chaine de caracteres en mode graphique
 *               ** Couleur avec degrade - Fond
 */

void write_xy_c_f(int no_vscr, int x, int y, int couleur, int inc_coul,
                  int fond, unsigned char *chaine, ...)
{
    int             i, j, k, ofs;
    unsigned char   buffer[100];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    ofs = x+(y*scr_nbx);
    for (i = 0; i < strlen(buffer); i++)
    {
        for (j = 0; j < 8; j++)
            for (k = 0; k < 8; k++)
                if ( (fonte[buffer[i]][j] & (128 >> k)) != 0)
                    putpixel_ofs(no_vscr, ofs+(j*scr_nbx)+k, couleur+j*inc_coul);
                else
                    putpixel_ofs(no_vscr, ofs+(j*scr_nbx)+k, fond);
        ofs += 9;
    }
}

/*
 * write_xy_c_o: ecrit une chaine de caracteres en mode graphique
 *               ** Couleur avec degrade - Ombre
 */

void write_xy_c_o(int no_vscr, int x, int y, int couleur, int inc_coul,
                  int ombre, unsigned char *chaine, ...)
{
    int             i, j, k, ofs;
    unsigned char   buffer[100];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    ofs = x+(y*scr_nbx);
    for (i = 0; i < strlen(buffer); i++)
    {
        for (j = 0; j < 8; j++)
            for (k = 0; k < 8; k++)
                if ( (fonte[buffer[i]][j] & (128 >> k)) != 0)
                {
                    putpixel_ofs(no_vscr, ofs+(j*scr_nbx)+k, couleur+j*inc_coul);
                    putpixel_ofs(no_vscr, ofs+(j*scr_nbx)+k+scr_nbx+1, ombre);
                }
        ofs += 9;
    }
}

/*
 * write_xy_vs_c_o: ecrit une chaine de caracteres en mode graphique
 *                  dans un ecran virtuel
 *                  ** Couleur avec degrade - Ombre
 */

/*void write_xy_vs_c_o(unsigned char *vs, int x, int y, int couleur, int inc_coul,
                     int ombre, unsigned char *chaine, ...)
{
    int             i, j, k, ofs;
    unsigned char   buffer[100];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    #ifndef MSDOS
    if (X_Window)
    {
    }
    else
    #endif
    {
        ofs = x+(y*scr_nbx);
        for (i = 0; i < strlen(buffer); i++)
        {
            for (j = 0; j < 8; j++)
                for (k = 0; k < 8; k++)
                    if ( (fonte[buffer[i]][j] & (128 >> k)) != 0)
                    {
                        vs[ofs+(j*scr_nbx)+k] = couleur+j*inc_coul;
                        vs[ofs+(j*scr_nbx)+k+321] = ombre;
                    }
            ofs += 9;
        }
    }
}*/

/*
 * write_xy_b_c_o: ecrit une chaine de caracteres en mode graphique
 *                 ** Couleur avec degrade - Gros caracteres - Ombre
 */

void write_xy_b_c_o(int no_vscr, int x, int y, int couleur, int inc_coul,
                    int ombre, unsigned char *chaine, ...)
{
    int             i, j, k, ofs;
    unsigned char   buffer[100];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    ofs = x+(y*scr_nbx);
    for (i = 0; i < strlen(buffer); i++)
    {
        for (j = 0; j < 8; j++)
            for (k = 0; k < 8; k++)
                if ( (fonte[buffer[i]][j] & (128 >> k)) != 0)
                {
                    putpixel_ofs(no_vscr, ofs+(j*scr_nbx*2)+k*2, couleur+j*inc_coul);
                    putpixel_ofs(no_vscr, ofs+(j*scr_nbx*2)+k*2+scr_nbx+1, ombre);
                }
        ofs += 18;
    }
}

/*
 * write_xy_vs_b_c_o: ecrit une chaine de caracteres en mode graphique
 *                    dans un ecran virtuel
 *                    ** Couleur avec degrade - Gros caracteres - Ombre
 */

/*void write_xy_vs_b_c_o(unsigned char *vs, int x, int y, int couleur,
                       int inc_coul, int ombre, unsigned char *chaine, ...)
{
    int             i, j, k, ofs;
    unsigned char   buffer[100];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    #ifndef MSDOS
    if (X_Window)
    {
    }
    else
    #endif
    {
        ofs = x+(y*scr_nbx);
        for (i = 0; i < strlen(buffer); i++)
        {
            for (j = 0; j < 8; j++)
                for (k = 0; k < 8; k++)
                    if ( (fonte[buffer[i]][j] & (128 >> k)) != 0)
                    {
                        vs[ofs+(j*640)+k*2] = couleur+j*inc_coul;
                        vs[ofs+(j*640)+k*2+321] = ombre;
                    }
            ofs += 18;
        }
    }
}*/

/*
 * text_length: renvoie la longueur d'un texte affichable en petite fonte
 */

int text_length(unsigned char *texte)
{
    int     i, j, k, car, plus_a_droite, longueur;

    longueur = 0;
    for (i = 0; i < strlen(texte); i++)
    {
        if (texte[i] == 32)
            longueur += 4;
        else
        {
            if ( (texte[i] >= 'a') && (texte[i] <= 'z') )
                car = texte[i]-('a'-'A')-33;
            else
                car = texte[i]-33;
            if (i > 0) longueur++;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                        if (plus_a_droite < j) plus_a_droite = j;
            longueur += plus_a_droite+1;
        }
    }
    return longueur;
}

/*
 * write_xy_s_c: ecrit une chaine de caracteres en mode graphique
 *               ** Petite fonte - Couleur avec degrade
 */

void write_xy_s_c(int no_vscr, int x, int y, int couleur, int inc_coul,
                  unsigned char *chaine, ...)
{
    int             i, j, k, inc_x, plus_a_droite;
    unsigned char   buffer[100], car;
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    inc_x = 0;
    for (i = 0; i < strlen(buffer); i++)
    {
        if (buffer[i] == 32)
            inc_x += 4;
        else
        {
            if ( (buffer[i] >= 'a') && (buffer[i] <= 'z') )
                car = buffer[i]-('a'-'A')-33;
            else
                car = buffer[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j, couleur+(k*inc_coul));
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            inc_x += plus_a_droite+2;
        }
    }
}

/*
 * write_xy_s_c_brut: ecrit une chaine de caracteres en mode graphique
 *                    ** Petite fonte - Couleur avec degrade
 */

void write_xy_s_c_brut(int no_vscr, int x, int y, int couleur, int inc_coul,
                       unsigned char *chaine)
{
    int             i, j, k, inc_x, plus_a_droite;
    unsigned char   car;

    inc_x = 0;
    for (i = 0; i < strlen(chaine); i++)
    {
        if (chaine[i] == 32)
            inc_x += 4;
        else
        {
            if ( (chaine[i] >= 'a') && (chaine[i] <= 'z') )
                car = chaine[i]-('a'-'A')-33;
            else
                car = chaine[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j, couleur+(k*inc_coul));
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            inc_x += plus_a_droite+2;
        }
    }
}

/*
 * write_xy_vs_s_c: ecrit une chaine de caracteres en mode graphique dans un ecran virtuel
 *                  ** Vscreen - Petite fonte - Couleur avec degrade
 */

/*void write_xy_vs_s_c(unsigned char *vs, int x, int y, int couleur,
                     int inc_coul, unsigned char *chaine, ...)
{
    int             i, j, k, inc_x, plus_a_droite;
    unsigned char   buffer[100], car;
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    inc_x = 0;
    #ifndef MSDOS
    if (X_Window)
    {
    }
    else
    #endif
    {
        for (i = 0; i < strlen(buffer); i++)
        {
            if (buffer[i] == 32)
                inc_x += 4;
            else
            {
                if ( (buffer[i] >= 'a') && (buffer[i] <= 'z') )
                    car = buffer[i]-('a'-'A')-33;
                else
                    car = buffer[i]-33;
                plus_a_droite = 0;
                for (j = 0; j < 5; j++)
                    for (k = 0; k < 5; k++)
                        if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                        {
                            vs[scr_nbx*(y+k)+x+inc_x+j] = couleur+(k*inc_coul);
                            if (plus_a_droite < j) plus_a_droite = j;
                        }
                inc_x += plus_a_droite+2;
            }
        }
    }
}*/

/*
 * write_xy_s_c_o: ecrit une chaine de caracteres en mode graphique
 *                 ** Petite fonte - Couleur avec degrade - Ombre
 */

void write_xy_s_c_o(int no_vscr, int x, int y, int couleur, int inc_coul,
                    int ombre, unsigned char *chaine, ...)
{
    int             i, j, k, inc_x, plus_a_droite;
    unsigned char   buffer[100], car;
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    inc_x = 0;
    for (i = 0; i < strlen(buffer); i++)
    {
        if (buffer[i] == 32)
            inc_x += 4;
        else
        {
            if ( (buffer[i] >= 'a') && (buffer[i] <= 'z') )
                car = buffer[i]-('a'-'A')-33;
            else
                car = buffer[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j, couleur+(k*inc_coul));
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j+scr_nbx+1, ombre);
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            inc_x += plus_a_droite+2;
        }
    }
}

/*
 * write_xy_s_c_o_brut: ecrit une chaine de caracteres en mode graphique
 *                      ** Petite fonte - Couleur avec degrade - Ombre
 *                      ** Ecrit le texte brut (sans evaluation par sprintf)
 */

void write_xy_s_c_o_brut(int no_vscr, int x, int y, int couleur, int inc_coul,
                         int ombre, unsigned char *chaine)
{
    int             i, j, k, inc_x, plus_a_droite;
    unsigned char   car;

    inc_x = 0;
    for (i = 0; i < strlen(chaine); i++)
    {
        if (chaine[i] == 32)
            inc_x += 4;
        else
        {
            if ( (chaine[i] >= 'a') && (chaine[i] <= 'z') )
                car = chaine[i]-('a'-'A')-33;
            else
                car = chaine[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j, couleur+(k*inc_coul));
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j+scr_nbx+1, ombre);
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            inc_x += plus_a_droite+2;
        }
    }
}

/*
 * write_xy_s_c_o_tab: ecrit une chaine de caracteres en mode graphique
 *                     ** Petite fonte - Couleur avec tableau de degrade - Ombre
 */

void write_xy_s_c_o_tab(int no_vscr, int x, int y, int tab_coul[],
                        int ombre, unsigned char *chaine, ...)
{
    int             i, j, k, inc_x, plus_a_droite;
    unsigned char   buffer[100], car;
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    inc_x = 0;
    for (i = 0; i < strlen(buffer); i++)
    {
        if (buffer[i] == 32)
            inc_x += 4;
        else
        {
            if ( (buffer[i] >= 'a') && (buffer[i] <= 'z') )
                car = buffer[i]-('a'-'A')-33;
            else
                car = buffer[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j, tab_coul[k]);
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j+scr_nbx+1, ombre);
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            inc_x += plus_a_droite+2;
        }
    }
}

/*
 * write_xy_s_c_o_droite: ecrit une chaine de caracteres en mode graphique
 *                        ** Petite fonte - Couleur avec degrade - Ombre - Centre a droite
 */

void write_xy_s_c_o_droite(int no_vscr, int x, int y, int couleur,
                           int inc_coul, int ombre, int long_centre,
                           unsigned char *chaine, ...)
{
    int             i, j, k, inc_x, plus_a_droite, largeur;
    unsigned char   buffer[100], car;
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    inc_x = 0;
    largeur = text_length(buffer);
    if (largeur < long_centre)
        x += (long_centre-largeur);
    for (i = 0; i < strlen(buffer); i++)
    {
        if (buffer[i] == 32)
            inc_x += 4;
        else
        {
            if ( (buffer[i] >= 'a') && (buffer[i] <= 'z') )
                car = buffer[i]-('a'-'A')-33;
            else
                car = buffer[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j, couleur+(k*inc_coul));
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j+scr_nbx+1, ombre);
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            inc_x += plus_a_droite+2;
        }
    }
}

/*
 * write_xy_s_c_o_tab_droite: ecrit une chaine de caracteres en mode graphique
 *                            ** Petite fonte - Couleur avec tableau de
 *                               degrade - Ombre - Centre a droite
 */

void write_xy_s_c_o_tab_droite(int no_vscr, int x, int y, int tab_coul[],
                               int ombre, int long_centre,
                               unsigned char *chaine, ...)
{
    int             i, j, k, inc_x, plus_a_droite, largeur;
    unsigned char   buffer[100], car;
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    inc_x = 0;
    largeur = text_length(buffer);
    if (largeur < long_centre)
        x += (long_centre-largeur);
    for (i = 0; i < strlen(buffer); i++)
    {
        if (buffer[i] == 32)
            inc_x += 4;
        else
        {
            if ( (buffer[i] >= 'a') && (buffer[i] <= 'z') )
                car = buffer[i]-('a'-'A')-33;
            else
                car = buffer[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j, tab_coul[k]);
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+inc_x+j+scr_nbx+1, ombre);
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            inc_x += plus_a_droite+2;
        }
    }
}

/*
 * write_xy_vs_s_c_o: ecrit une chaine de caracteres en mode graphique dans un ecran virtuel
 *                    ** Vscreen - Petite fonte - Couleur avec degrade - Ombre
 */

/*void write_xy_vs_s_c_o(unsigned char *vs, int x, int y, int couleur,
                       int inc_coul, int ombre, unsigned char *chaine, ...)
{
    int             i, j, k, inc_x, plus_a_droite;
    unsigned char   buffer[100], car;
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    inc_x = 0;
    #ifndef MSDOS
    if (X_Window)
    {
    }
    else
    #endif
    {
        for (i = 0; i < strlen(buffer); i++)
        {
            if (buffer[i] == 32)
                inc_x += 4;
            else
            {
                if ( (buffer[i] >= 'a') && (buffer[i] <= 'z') )
                    car = buffer[i]-('a'-'A')-33;
                else
                    car = buffer[i]-33;
                plus_a_droite = 0;
                for (j = 0; j < 5; j++)
                    for (k = 0; k < 5; k++)
                        if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                        {
                            vs[scr_nbx*(y+k)+x+inc_x+j] = couleur+(k*inc_coul);
                            vs[scr_nbx*(y+k)+x+inc_x+j+321] = ombre;
                            if (plus_a_droite < j) plus_a_droite = j;
                        }
                inc_x += plus_a_droite+2;
            }
        }
    }
}*/

/*
 * write_xy_digit_c: affiche un nombre style digital
 *                   ** Fonte chiffre digital - Couleur avec degrade
 */

void write_xy_digit_c(int no_vscr, int x, int y, int couleur, int inc_coul,
                      unsigned char *chaine, ...)
{
    int             i, j, k;
    unsigned char   buffer[100];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    for (i = 0; i < strlen(buffer); i++)
    {
        if (buffer[i] != 32)
            for (j = 0; j < 4; j++)
                for (k = 0; k < 7; k++)
                    if ( (fonte_digital[buffer[i]-'0'][k] & (8 >> j)) != 0)
                        putpixel_ofs(no_vscr, scr_nbx*(y+k)+x+j, couleur+(k*inc_coul));
        x += 5;
    }
}

/*
 * make_image_texte_s: fabrique une image (X*5) a partir du texte fourni
 *                     X etant la largeur du texte (petite fonte) en pixels
 *                     L'image doit etre deja allouee
 */

void make_image_texte_s(unsigned char *image, int largeur_image,
                        unsigned char *texte, int couleur)
{
    int             i, j, k, x, plus_a_droite;
    unsigned char   car;

    x = 0;
    for (i = 0; i < strlen(texte); i++)
    {
        if (texte[i] == 32)
            x += 4;
        else
        {
            if ( (texte[i] >= 'a') && (texte[i] <= 'z') )
                car = texte[i]-('a'-'A')-33;
            else
                car = texte[i]-33;
            plus_a_droite = 0;
            for (j = 0; j < 5; j++)
                for (k = 0; k < 5; k++)
                    if ( (petite_fonte[car][k] & (16 >> j)) != 0)
                    {
                        image[x+j+(k*largeur_image)] = couleur;
                        if (plus_a_droite < j) plus_a_droite = j;
                    }
            x += plus_a_droite+2;
        }
    }
}

/* ==========================================================================
                              AFFICHAGE DES PIECES
   ========================================================================== */

/*
 * affiche_brique: affiche une petite brique
 */

void affiche_brique(int no_vscr, int x, int y, int taille,
                    unsigned char couleur)
{
    #ifndef MSDOS
    if (X_Window)
    {
        /*XSetForeground(display, gc, xcolor[couleur]);
        if (no_vscr == ECRAN_REEL)
        {
            XFillRectangle(display, pixmap_save, gc, x, y, taille, taille);
            XFillRectangle(display, window, gc, x, y, taille, taille);
        }
        else
            XFillRectangle(display, pixmap[no_vscr], gc, x, y, taille, taille);*/
        putsprite(no_vscr, &brique[taille-TC_MIN][couleur], x, y);
    }
    else
    #endif
    /* Linux Console ou Dos : */
    {
        /*x2 = x+taille-1;
        for (i = 0; i < taille; i++)
            ligne_horiz(x, x2, y+i, couleur);*/
        putsprite(no_vscr, &brique[taille-TC_MIN][couleur], x, y);
    }
}

/*
 * efface_brique: efface une brique et remet le fond (depuis vscreen)
 */

void efface_brique(int no_vscr, int no_vscr_fond, int x, int y, int taille)
{
    #ifndef MSDOS
    if (X_Window)
    {
        /*XSetForeground(display, gc, xcolor[0]);
        if (no_vscr == ECRAN_REEL)
        {
            XFillRectangle(display, pixmap_save, gc, x, y, taille, taille);
            XFillRectangle(display, window, gc, x, y, taille, taille);
        }
        else
            XFillRectangle(display, pixmap[no_vscr], gc, x, y, taille, taille);*/
        if (no_vscr == ECRAN_REEL)
            copy_v2s_xy(no_vscr_fond, x, y, taille, taille);
        else
            copy_v2v_xy(no_vscr_fond, no_vscr, x, y, taille, taille);
    }
    else
    #endif
    /* Linux Console ou Dos : */
    {
        if (no_vscr == ECRAN_REEL)
            copy_v2s_xy(no_vscr_fond, x, y, taille, taille);
        else
            copy_v2v_xy(no_vscr_fond, no_vscr, x, y, taille, taille);
    }
}

#ifndef MSDOS
void X_dessine_flashtris(int x, int y, int tc, int coul_bord, int coul, int coul_fond)
{
    int     i, j;

    for (j = 0; j < 5; j++)
        for (i = 0; i  < 35; i++)
            if (flashtris[j][i] == '*')
            {
                XSetForeground(display, gc, xcolor[coul_bord]);
                XDrawLine(display, window, gc, x+i*tc, y+j*tc, x+i*tc+tc-1, y+j*tc);
                XDrawLine(display, window, gc, x+i*tc, y+j*tc, x+i*tc, y+j*tc+tc-1);
                XSetForeground(display, gc, xcolor[coul]);
                XFillRectangle(display, window, gc, x+i*tc+1, y+j*tc+1, tc-1, tc-1);
            }
            else
            {
                XSetForeground(display, gc, xcolor[coul_fond]);
                XFillRectangle(display, window, gc, x+i*tc, y+j*tc, tc, tc);
            }
}
#endif
