/* ====
   ==== FlashTris Game, (c) 1999-2001 by FlashCode (Sebastien Helleu)
   ====
   ====    web: http://flashcode.free.fr
   ==== e-mail: flashcode@free.fr
   ====
   ==== video.h: header pour video.c
   ====

   ==== This file is part of FlashTris.
   ====
   ==== FlashTris is free software; you can redistribute it and/or modify
   ==== it under the terms of the GNU General Public License as published by
   ==== the Free Software Foundation; either version 2 of the License, or
   ==== (at your option) any later version.
   ====
   ==== FlashTris is distributed in the hope that it will be useful,
   ==== but WITHOUT ANY WARRANTY; without even the implied warranty of
   ==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ==== GNU General Public License for more details.
   ====
   ==== You should have received a copy of the GNU General Public License
   ==== along with FlashTris; if not, write to the Free Software
   ==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 1999/06/21

2001/09/06: FlashCode:
    - ajout de la licence
*/


#ifndef __FTRIS_VIDEO__
#define __FTRIS_VIDEO__

#ifndef MSDOS
    #ifndef CYGWIN
        #include <X11/Xlib.h>
        #include <X11/Xutil.h>
    #endif
#endif

#include "game.h"

#define X_NBX_DEFAUT    640
#define X_NBY_DEFAUT    400

#define INIT_GRAFX_ERR_MEMORY   -1
#define INIT_GRAFX_ERR_MODE     -2

#define GIF_NULL_CODE   -1
#define GIF_CLEAR_CODE  256
#define GIF_EOF_CODE    257

/*#define NB_VSCR_MAX 22*/
#define NB_VSCR_MAX 25
#define ECRAN_REEL      -1
#define VSCR_VSCREEN    0
#define VSCR_MENU       1
#define VSCR_JEU        2
#define VSCR_JEU_VIDE   3
#define VSCR_AUTRES     4
#define VSCR_DERNIER    (NB_VSCR_MAX-1)


typedef struct
{
    int             s_lx;
    int             s_ly;
    unsigned char   *s_ptr;
    #if !defined(MSDOS) && !defined(CYGWIN)
    XImage          *s_ximage;
    #endif
} t_sprite;


extern unsigned char    palette[768];
extern unsigned char    *vscreen[NB_VSCR_MAX];

extern int              scr_nbx, scr_nby;

extern unsigned char    *adr_ecran;

#if !defined(MSDOS) && !defined(CYGWIN)
extern int              X_width, X_height;
extern int              X_Window;
extern Display          *display;
extern Window           window;
extern int              screen;
extern XVisualInfo      visual;
extern GC               gc;
extern unsigned long    xcolor[256];
extern Pixmap           pixmap[NB_VSCR_MAX];
extern Pixmap           pixmap_save;
#endif

extern unsigned char    couleur_fond;
extern int              font_width;
extern int              font_height;

extern unsigned char    fonte[128][8];
extern unsigned char    petite_fonte[94][5];
extern unsigned char    fonte_digital[10][7];


#if !defined(MSDOS) && !defined(CYGWIN)
extern void detect_X_Window();
#endif
extern int init_grafx(int, int);
extern void close_grafx();

#if !defined(MSDOS) && !defined(CYGWIN)
extern void X_expose(XEvent *);
extern void X_traite_evenement();
#endif

extern void waitretrace();
extern void clear_screen();
extern void clear_vscreen(int);
extern void putpixel_ofs(int, int, unsigned char);
extern unsigned char getpixel_ofs(int, int);
extern void ligne_horiz(int, unsigned short, unsigned short, unsigned short, unsigned char);
extern void ligne_vertic(int, unsigned short, unsigned short, unsigned short, unsigned char);
extern void rectangle(int, unsigned short, unsigned short, unsigned short, unsigned short, unsigned char);
extern void fill_rectangle(int, unsigned short, unsigned short, unsigned short, unsigned short, unsigned char);
extern void setcoul(unsigned char, unsigned char, unsigned char, unsigned char);
extern void setpal(unsigned char *);
extern void fade_in(unsigned char *, int, int);
extern void fade_to(unsigned char *, unsigned char *, int, int);
extern void fade_out(unsigned char *, int, int);
extern int  load_pcx(unsigned char *, int);
extern int  load_dat(unsigned char *, int);
extern int  load_gif(unsigned char *, int);

extern void getsprite(int, int, int, int, int, t_sprite *);
extern void replacesprite(int, int, int, t_sprite *);
extern void putsprite(int, t_sprite *, int, int);
extern void putsprite_tr(t_sprite *, int, int);
extern void putsprite_tr_fond(int, t_sprite *, int, int);
extern void putsprite_v_tr(int, t_sprite *, int, int);
extern void putsprite_clip(int, t_sprite *, int, int, int, int, int, int);
extern unsigned long getpixel_ofs_sprite(t_sprite *, int);
extern unsigned long getpixel_xy_sprite(t_sprite *, int, int);
extern void putpixel_ofs_sprite(t_sprite *, int, unsigned long);
extern void putpixel_xy_sprite(t_sprite *, int, int, unsigned long);

extern void copy_v2s_xy(int, int, int, int, int);
extern void copy_v2v_xy(int, int, int, int, int, int);
extern void copy_v2v_xy_xy(int, int, int, int, int, int, int, int);
extern void copy_v2s_xy_xy(int, int, int, int, int, int, int);
extern void copy_v2s(int);
extern void copy_s2v(int);
extern void copy_s2v_xy(int, int, int, int, int);
extern void copy_v2v(int, int);
extern void copy_buf2s(unsigned char *, int, int, int);

extern void efface_ecran_mosaique(int, int[][2], int, int, int);
extern void affiche_ecran_mosaique(int, int[][2], int, int, int);
extern void affiche_ecran_vers_centre(int, int);

extern void write_xy_c(int, int, int, int, int, unsigned char *, ...);
extern void write_xy_c_f(int, int, int, int, int, int, unsigned char *, ...);
extern void write_xy_c_o(int, int, int, int, int, int, unsigned char *, ...);
extern void write_xy_b_c_o(int, int, int, int, int, int, unsigned char *, ...);
extern int  text_length(unsigned char *);
extern void write_xy_s_c(int, int, int, int, int, unsigned char *, ...);
extern void write_xy_s_c_brut(int, int, int, int, int, unsigned char *);
extern void write_xy_s_c_o(int, int, int, int, int, int, unsigned char *, ...);
extern void write_xy_s_c_o_brut(int, int, int, int, int, int, unsigned char *);
extern void write_xy_s_c_o_tab(int, int, int, int [], int, unsigned char *, ...);
extern void write_xy_s_c_o_droite(int, int, int, int, int, int, int, unsigned char *, ...);
extern void write_xy_s_c_o_tab_droite(int, int, int, int [], int, int, unsigned char *, ...);
extern void write_xy_digit_c(int, int, int, int, int, unsigned char *, ...);
extern void make_image_texte_s(unsigned char *, int, unsigned char *, int);

extern void affiche_brique(int, int, int, int, unsigned char);
extern void efface_brique(int, int, int, int, int);
#if !defined(MSDOS) && !defined(CYGWIN)
extern void X_dessine_flashtris(int, int, int, int, int, int);
#endif
#endif
